import * as React from "react";
import * as moment from "moment";
import { SelectValue } from 'antd/lib/select';
import { IPropsInterface as IButton } from "./packages/elements/irs-button/src/module";
import { IPropsInterface as IInput} from "./packages/elements/irs-input/src/module";
import { IPropsInterface as IDropdown} from "./packages/elements/irs-dropdown/src/module";
import { IPropsInterface as IRow} from "./packages/layout/irs-row/src/module";
import { IPropsInterface as ICol} from "./packages/layout/irs-col/src/module";
import { IPropsInterface as IDatePicker } from "./packages/elements/irs-datepicker/src/module";
import { IPropsInterface as ITimePicker } from "./packages/elements/irs-timepicker/src/module";
import { IPropsInterface as IModal} from "./packages/elements/irs-modal/src/module";
import { IPropsInterface as ITab } from "./packages/elements/irs-tab/src/module"
import { IPropsInterface as IPagination } from "./packages/elements/irs-pagination/src/module"
import { IPropsInterface as ICalendar } from "./packages/elements/irs-calendar/src/module";
import { ISelectInterface as ISelect} from "./packages/elements/irs-select/src/module";
import { IRadioInterface as IRadio } from "./packages/elements/irs-radio/src/module";
import { ISwitchInterface as ISwitch } from "./packages/elements/irs-switch/src/module";
import { IMessageApi as IMessage } from "./packages/elements/irs-message/src/module";
import { IPropsInterface as ICheckbox } from "./packages/elements/irs-checkbox/src/module";
import { IPropsInterface as ITransfer } from "./packages/componsties/irs-faq/src/module";
import { IPropsInterface as IMenu } from "./packages/elements/irs-menu/src/module"
import { IPropsInterface as ICascader } from "./packages/elements/irs-cascader/src/module"

import { IPropsInterface as ITable } from "./packages/elements/irs-table/src/module"
import { IPropsInterface as ITableConfigure } from "./packages/elements/irs-tableconfigure/src/module"


import { TransferDirection } from 'antd/lib/transfer';
import { SelectParam, ClickParam } from 'antd/lib/menu';

import { IPropsInterface as ISteps } from "./packages/elements/irs-steps/src/module"
import { IPropsInterface as IError } from './packages/elements/irs-error/src/module'
import { IPropsInterface as IBreadcrumb } from './packages/elements/irs-breadcrumb/src/module'
import { IPropsInterface as ISpin } from './packages/elements/irs-spin/src/module'
import { IPropsInterface as IProgress } from './packages/elements/irs-progress/src/module'
import { IPropsInterface } from './packages/elements/irs-tooltip/src/module';
import { BreadcrumbItemProps } from 'antd/lib/breadcrumb/BreadcrumbItem';
import { IPropsInterface as IrsTooltip} from "./packages/elements/irs-tooltip/src/module"
import { IPropsInterface as IrsPopover} from "./packages/elements/irs-popover/src/module"
import { IPropsInterface as IrsPopconfirm} from "./packages/elements/irs-popconfirm/src/module"
import { IPropsInterface as IAutocomplete } from "./packages/elements/irs-autocomplete/src/module"
import { IPropsInterface as IrsCard} from "./packages/elements/irs-card/src/module"
import { IPropsInterface as IImport } from "./packages/componsties/irs-import/src/module";
import { IPropsInterface as IApprover } from "./packages/componsties/irs-approver/src/module";
import { IPropsInterface as IrsUpload, IrsUploadFile, IrsRcFile} from "./packages/elements/irs-upload/src/module"

import { IPropsInterface as IrsDepartmentSelector} from "./packages/componsties/irs-department-selector/src/module";
import { IPropsInterface as IrsFAQ} from "./packages/componsties/irs-faq/src/module";
import { IPropsInterface as IrsStaffAndDepartmentSelector} from "./packages/componsties/irs-staff-department-selector/src/module";
import { IPropsInterface as IrsStaffSelector} from "./packages/componsties/irs-staff-selector/src/module";
import { IPropsInterface as IrsAuthority} from "./packages/componsties/irs-authority/src/module";

export declare type RangePickerValue = undefined[] | [moment.Moment] | [undefined, moment.Moment] | [moment.Moment, moment.Moment];
export declare type CalendarMode = 'month' | 'year';

export class IrsButton extends React.Component<IButton, any> {
    static defaultProps: any;
    constructor(props: any);
    componentDidMount(): void;
    handleClick: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    render(): JSX.Element;
}
export class IrsInput extends React.Component<IInput, any> {
    static defaultProps: any;
    constructor(props: IInput);
    componentDidMount(): void;
    changeHandler: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    pressEnter: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    search: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>, value: any) => void;
    changeInputNumber: (value: number) => void;
    render(): JSX.Element;
}

export class IrsRow extends React.Component<IRow, any> {
    static defaultProps: any;
    constructor(props: any);
    componentDidMount(): void;
    render(): JSX.Element;
}

export class IrsCol extends React.Component<ICol, any> {
    static defaultProps: any;
    constructor(props: any);
    componentDidMount(): void;
    render(): JSX.Element;
}

export class IrsCascader extends React.Component<ICascader, any> {
    static defaultProps: any;
    constructor(props: any);
    componentDidMount(): void;
    render(): JSX.Element;
}

export class IrsDatePicker extends React.Component<IDatePicker, any> {
    static defaultProps: any;
    constructor(props: any);
    componentDidMount(): void;
    handleChange: (date: moment.Moment, dateString: string) => void;
    handleRangeChange: (dates: RangePickerValue, dateStrings: [string, string]) => void;
    handlePanelChange: (value?: RangePickerValue, mode?: string | string[]) => void;
    handleDisabledTime: (current: moment.Moment) => {
        disabledHours?: () => number[];
        disabledMinutes?: () => number[];
        disabledSeconds?: () => number[];
    };
    handleDisabledDate: (current: moment.Moment) => boolean;
    handleDateOnOk: (selectedTime: moment.Moment | RangePickerValue) => void;
    handleRangeOnOk: (selectedTime: moment.Moment | RangePickerValue) => void;
    handleOpenChange: (status: boolean) => void;
    render(): JSX.Element;
}
export class IrsTimePicker extends React.Component<ITimePicker, any> {
    static defaultProps: any;
    constructor(props: any);
    componentDidMount(): void;
    handleChange: (time: moment.Moment, timeString: string) => void;
    handleOpenChange: (open: boolean) => void;
    render(): JSX.Element;
}

export class IrsPagination extends React.Component<IPagination, any> {
    static defaultProps: any;
    constructor(props: any);
    componentDidMount(): void;
    onChange: (page:number, pageSize:number) => void;
    onShowSizeChange: (current:number, size:number) => void;
    render(): JSX.Element;
}

export class IrsTab extends React.Component<ITab, any> {
    static defaultProps: any;
    constructor(props: any);
    componentDidMount(): void;
    getTabTitleView: (item:any) => React.ReactNode;
    onChange: (activeKey: string) => void;
    render(): JSX.Element;
}

export class ICalendar extends React.Component<ITab, any> {
    static defaultProps: any;
    constructor(props: any);
    componentDidMount(): void;
    handleOpenChange: (date?: moment.Moment, mode?: CalendarMode) => void;
    handleDateCellRender: (date: moment.Moment) => React.ReactNode;
    handleMonthCellRender: (date: moment.Moment) => React.ReactNode;
    handleOnSelect: (date?: moment.Moment) => void;
    handleOnChange: (date?: moment.Moment) => void;
    render(): JSX.Element;
}
export class IrsCheckbox extends React.Component<ICheckbox, any> {
    static defaultProps: any;
    constructor(props: ICheckbox);
    componentDidMount(): void;
    handleChange: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    handleGroupChange: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    render(): JSX.Element;
}

export class IrsRadio extends React.Component<IRadio, any> {
    static defaultProps: any;
    constructor(props: IRadio);
    componentDidMount(): void;
    handleGroupChange: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    render(): JSX.Element;
}

export class IrsSelect extends React.Component<ISelect, any> {
    static defaultProps: any;
    constructor(props: ISelect);
    componentDidMount(): void;
    handleChange: (value: any, option: React.ReactElement<any> | React.ReactElement<any>[]) => void;
    handleFocus: () => void;
    handleBlur: (value: any) => void;
    render(): JSX.Element;
}

export class IrsSwitch extends React.Component<ISwitch, any> {
    static defaultProps: any;
    constructor(props: ISwitch);
    componentDidMount(): void;
    switchChange: (checked: boolean) => void;
    render(): JSX.Element;
}

export class IrsModal extends React.Component<IModal, any> {
    static defaultProps: any;
    constructor(props: any);
    componentDidMount(): void;
    static modalFunc(type:any, data:any): void;
    handleOk: (e: React.MouseEvent<any>) => void;
    handleCancel: (e: React.MouseEvent<any>) => void;
    render(): JSX.Element;
}

export class IrsMessage extends React.Component<IMessage, any> {
    static defaultProps: any;
    constructor(props: any);
    componentDidMount(): void;
    static messageFun(type: string, content: any, duration?: number): void;
    handleClick: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    render(): JSX.Element;
}

export class IrsSteps extends React.Component<ISteps, any> {
    static defaultProps: any;
    constructor(props: ISteps);
    componentDidMount(): void;
    render(): JSX.Element;
}

export class IrsTransfer extends React.Component<ITransfer, any> {
    static defaultProps: any;
    constructor(props: ITransfer);
    componentDidMount(): void;
    onChange?: (targetKeys: string[], direction: string, moveKeys: any) => void;
    onSelectChange?: (sourceSelectedKeys: string[], targetSelectedKeys: string[]) => void;
    onSearchChange?: (direction: TransferDirection, e: React.ChangeEvent<HTMLInputElement>) => void;
    onScroll?: (direction: TransferDirection, e: React.SyntheticEvent<HTMLDivElement>) => void;
    render(): JSX.Element;
}

export class IrsBreadcrumb extends React.Component<IBreadcrumb, any> {
    constructor(props: IBreadcrumb);
    componentDidMount(): void;
    render(): JSX.Element;
}

export class IrsError extends React.Component<IError, any> {
    constructor(props: IError);
    componentDidMount(): void;
    handleClick: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    render(): JSX.Element;
}


export class IrsMenu extends React.Component<IMenu, any> {
    static defaultProps: any;
    constructor(props: IMenu);
    componentDidMount(): void;
    onOpenChange?: (openKeys: string[]) => void;
    onSelect?: (param: SelectParam) => void;
    onDeselect?: (param: SelectParam) => void;
    onClick?: (param: ClickParam) => void;
    render(): JSX.Element;
}

export class IrsSpin extends React.Component<ISpin, any> {
    static defaultProps: any;
    constructor(props: ISpin);
    componentDidMount(): void;
    render(): JSX.Element;
}

export class IrsProgress extends React.Component<IProgress, any> {
    static defaultProps: any;
    constructor(props: IProgress);
    componentDidMount(): void;
}

export class IrsTable extends React.Component<ITable, any> {
    static defaultProps: any;
    constructor(props: ITable);
    componentDidMount(): void;
    refSort: (item: any, instance: any) => void;
    onInputValueChange: (item: any, event: any) => void;
    inputPressEnter: (item: any, event: any) => void;
    selectSerarchValueChange: (item: any, text: any) => void;
    selectValueChange: (item: any, value: any) => void;
    dataPickerValueChange: (item: any, date: any, dateString: string) => void;
    setSortValue: (dataIndex: string, value: any, time?: any) => void;
    setSortDefaultValue: (item: any) => void;
    getSortValue: (dataIndex: string) => string;
    getSortDefaultValue: (dataIndex: string) => string;
    sortValueChanged: () => void;
    clearFliterData: () => void;
    setSortChildren: (item: any) => void;
    fixData: (props: any) => void;
    componentWillMount(): void;
    componentWillReceiveProps(nextProps: any): void;
    tableOnChange: (pagination: any, filters: any, sorter: any) => void;
    hasLeftFixedField: () => boolean;
    getContinerClassName: () => string;
    render(): JSX.Element;
}
export class IrsTooltip extends React.Component<IProgress, any> {
    static defaultProps: any;
    constructor(props: IrsTooltip);
    componentDidMount(): void;
    render(): JSX.Element;
}

export class IrsPopover extends React.Component<IProgress, any> {
    static defaultProps: any;
    constructor(props: IrsPopover);
    componentDidMount(): void;
    render(): JSX.Element;
}

export class IrsPopconfirm extends React.Component<IProgress, any> {
    static defaultProps: any;
    constructor(props: IrsPopconfirm);
    componentDidMount(): void;
    render(): JSX.Element;
}
export class IrsTableConfigure extends React.Component<ITableConfigure, any> {
    static defaultProps: any;
    constructor(props: ITableConfigure);
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: any): void;
    setOriginData(props: any): void;
    deepCopy(obj: any): void;
    arrDeepCopy(obj: any): void;
    canFixData: () => boolean;
    clickIcon: (type: number, item: any, event: any) => void;
    renderTransferListContent: (item: any) => JSX.Element;
    filterOption: (inputValue: string, option: any) => boolean;
    handleChange: (targetKeys: any, direction: any, moveKeys: any) => void;
    getRightRendView: (item:any) => void;
    downClick: (item:any, event:Event) => void;
    upClick: (item:any, event:Event) => void;
    onSelectChange: (sourceSelectedKeys: any[], targetSelectedKeys: any) => void;
}
export class IrsAutocomplete extends React.Component<IAutocomplete, any> {
    static defaultProps: any;
    constructor(props: IAutocomplete);
    componentDidMount(): void;
    onSelect: (value: SelectValue, option: Object) => any;
    onSearch: (value: string) => any;
    onChange: (value: SelectValue) => void;
    render(): JSX.Element;
}

export class IrsCard extends React.Component<IProgress, any> {
    static defaultProps: any;
    constructor(props: IrsTooltip);
    componentDidMount(): void;
}
export class IrsImport extends React.Component<IImport, any> {
    static defaultProps: any;
    constructor(props: IPropsInterface);
    componentDidMount(): void;
    cancel: () => void;
    render(): JSX.Element;
}
export class IrsApprover extends React.Component<IApprover, any> {
    static defaultProps: any;
    constructor(props: IPropsInterface);
    componentDidMount(): void;
    addApprove: () => void;
    render(): JSX.Element;
}

export class IrsUpload extends React.Component<IrsUpload, any> {
    static defaultProps: any;
    constructor(props: IrsUpload);
    beforeUpload: (file:IrsUploadFile, fileList:IrsRcFile[]) => boolean;
    render(): JSX.Element;
}

export  class IreAuthority extends React.Component<IreAuthority, any> {
    constructor(props: IreAuthority);
    componentDidMount(): void;
    getLocalStorage: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    isContainPermissionCode: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    render(): JSX.Element;
}

export  class IrsDepartmentSelector extends React.Component<IrsDepartmentSelector, any> {
    constructor(props: IrsDepartmentSelector);
    componentDidMount(): void;
    componentWillReceiveProps(): void;
    getParentKey: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    changeKeyName: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    getName: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    generateList: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    onExpand: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    onChange: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    onCheck: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    loop: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    render(): JSX.Element;
}

export  class IrsFAQ extends React.Component<IrsFAQ, any> {
    constructor(props: IrsFAQ);
    componentDidMount(): void;
    clickGuide: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    clickFAQ: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    render(): JSX.Element;
}

export  class IrsStaffAndDepartmentSelector extends React.Component<IrsStaffAndDepartmentSelector, any> {
    constructor(props: IrsStaffAndDepartmentSelector);
    componentWillMount(): void;
    componentWillReceiveProps(): void;
    getParentKey: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    changeKeyName: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    getName: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    generateList: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    onExpand: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    onChange: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    onCheck: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    loop: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    render(): JSX.Element;
}

export  class IrsStaffSelector extends React.Component<IrsStaffSelector, any> {
    constructor(props: IrsStaffSelector);
    componentWillMount(): void;
    componentWillReceiveProps(): void;
    queryShift: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    selectApprover: (e: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    render(): JSX.Element;
}

export class IrsIcon extends React.Component<any, any> {
    static defaultProps: any;
    constructor(props: any);
    render(): JSX.Element;
}

export class IrsFetchHttp {
    contentType: string;
    credentials: string;
    mode: string;
    constructor();
    handlerErr(): any;
    fetchData(url: string, method: string, options: any): Promise<any>;
    get(url: string, options: any): Promise<any>;
    post(url: string, options: any, file?: any, payload?: any): Promise<any>;
    put(url: string, options: any, file?: any, payload?: any): Promise<any>;
    delete(url: string, options: any): Promise<any>;
    serializeParme(url: string, options: any): string;
}

