/**
 * @date 2018.12.08
 * @version 0.0.1
 * @author Gail.Chen
 */

import * as React from 'react';
import * as module from './module';
import { others } from 'fit-transmit-transparently';
import './style.less';
import ImgWaitUrl from './images/icon_daishenpi.png';
import ImgFailUrl from './images/icon_shenpibutongguo.png';
import ImgSuccessUrl from './images/icon_shenpitongguo.png';

class IrsApprover extends React.Component<module.IPropsInterface, any> {
    static defaultProps = {
        backgroundColor: '#f5f5f5',
        theme: '#19AA8D',
        fontSize: '12px',
        ImgWaitUrl,
        ImgFailUrl,
        ImgSuccessUrl
    }
    constructor(props: module.IPropsInterface) {
        super(props)
    }

    //添加审批人
    handleAddApprove = () => {
        if (this.props.addApprove) {
            return this.props.addApprove();
        }
    }

    public render() {
        others(IrsApprover.defaultProps, this.props);
        const {
            handleAddApprove
        } = this;
        return (
            <div id={this.props.approverId}>
                <div className="approve-box">
                    {this.props.approverMap.map((staff: any, i: number) => (
                        <div className="approve-item" key={i}>
                            <span className="avatar">
                                <img src={staff.staffImageUrl ? `${staff.staffImageUrl}` : require("./images/avatar.png")} alt="" />
                            </span>
                            <img
                                className={(this.props.approverArrow && (i !== (this.props.approverMap.length - 1))) || this.props.addApprove ? "arrow" : "hide"}
                                src={staff.applicationStatus === 'wait' || !staff.applicationStatus ? require("./images/arrow.png") : require("./images/arrowhover.png")}
                            />
                            <span className={this.props.type === 'result' ? "info" : "hide"}>
                                <span
                                    className={
                                        staff.applicationStatus === "fail"
                                            ? "status error"
                                            : "status"
                                    }
                                >
                                    <img src={staff.applicationStatus === 'success' ? this.props.ImgSuccessUrl :
                                            staff.applicationStatus === 'fail' ? this.props.ImgFailUrl :
                                            staff.applicationStatus === 'wait' ? this.props.ImgWaitUrl : ''}
                                        alt=""
                                    />
                                </span>
                                <span>
                                    <span className="name">{staff.staffName}</span>
                                    <span className="time">
                                        {staff.applicationName}
                                        <br />
                                        <span className="comment" title={staff.approvalComment}>{staff.approvalComment ? staff.approvalComment : ""}</span>
                                    </span>
                                </span>
                            </span>
                            <span className={this.props.type === 'basic' ? "info" : "hide"}>
                                <span className="staff-name">{staff.staffName}</span>
                            </span>
                        </div>
                    ))}
                    <div 
                        className={this.props.addApprove ? "approve-item-add" : "hide"}
                        onClick={handleAddApprove}>
                        <span className="avatar-add">
                            +
                        </span>
                        <span className="info">
                            <span className="staff-name">添加审批人</span>
                        </span>
                    </div>
                </div>
            </div>
        )
    }
}

export default IrsApprover;
