### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.1 | V0.0.1 | Gail | 新增审批人组件

<br><br/>
### 2.安装方式
<code>
npm install irs-approver
</code>

<br><br/><br><br/>
### 3. 调用方式
#### 第一种表现形式：type为basic，只显示审批人名称
```jsx
;<div className="App" >
    <IrsApprover 
    approverArrow={true}
    type="basic"
    approverMap={[{
      staffName: '审批人1',
      staffImageId: '',
    },{
      staffName: '审批人2',
      staffImageId: '',
    },{
      staffName: '审批人3',
      staffImageId: '',
    }]} />
  </div>
```
#### 第二种表现形式：type为basic，显示审批人名称和新增审批人
```jsx
const IrsMessage = require('../../../elements/irs-message/src/message.tsx');
class IrsApproverDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        activeType: '',
        visible: false,
        selectedId:[],
        staffList:[],
        approverMap: []
    }
    this.addApprove = this.addApprove.bind(this);
    this.onCancel = this.onCancel.bind(this);
    this.showModal = this.showModal.bind(this);
    this.returnData = this.returnData.bind(this);
    this.onOk = this.onOk.bind(this);
  }
  onCancel() {
    this.setState({visible: false});
  }
  onOk() {
    this.setState({visible: false, approverMap:[...this.state.staffList] });
  }
  showModal(type) {
    this.setState({activeType: type, visible: true});
  }
  addApprove() {
    this.setState({visible: true});
  }
  returnData(data, list) {
    const idList = data;
    const staffList = list;
    this.setState({
        staffList,
        selectedId:idList,
    })
  }
  render() {
    const {visible, staffList, selectedId, showStaffList, approverMap} = this.state;
    return (
      <div className="App" >
        <IrsApprover 
        approverArrow={true}
        addApprove={this.addApprove}
        type="basic"
        approverMap={approverMap} />
        <IrsModal 
          title="选择审批人"
          width={600}
          visible={visible} 
          onOk={this.onOk} 
          footer={[
            <div>
              <IrsButton onClick={this.onCancel}>取消</IrsButton>
            </div>
          ]}
          onCancel={this.onCancel}
          content={<div style={{height: 300}}><IrsStaffSelector 
            returnData={this.returnData}  
            selectedId={selectedId} 
            selectedList={staffList}/> </div>} />
      </div>
    )
  }
}
;<IrsApproverDemo />
```
#### 第三种表现形式：type为basic，显示审批人名称，不显示箭头
```jsx
//测试数据源mock传入组件
;<div className="App" >
    <IrsApprover 
    approverArrow={false}
    type="basic"
    approverMap={[{
      staffName: '审批人1'
    },{
      staffName: '审批人2'
    },{
      staffName: '审批人3'
    }]} />
  </div>
```
#### 第四种表现形式：type为result，显示审批人名称，箭头以及状态
#### 状态有3中：wait：未审批；success：审批通过；fail：审批失败；
```jsx
//测试数据源mock传入组件
;<div className="App" >
    <IrsApprover 
    approverArrow={true}
    type="result"
    approverMap={[{
      staffName: '审批人1',
      staffImageId: '',
      applicationStatus: 'wait',
      applicationName: '未审批'
    },{
      staffName: '审批人2',
      staffImageId: '',
      applicationStatus: 'success',
      applicationName: '2017.11.7',
      approvalComment: '审批成功啦'
    },{
      staffName: '审批人3',
      staffImageId: '',
      applicationStatus: 'fail',
      applicationName: '2017.11.8',
      approvalComment: '审批失败啦'
    }]} />
  </div>
```
