/**
 * The only true authority.
 * @date 2018.12.1
 * @version 0.0.1
 * @author Campbell.Jiao
 */

 import * as React from 'react';
 import * as module from './module';
//  import { others } from 'fit-transmit-transparently';

class IrsAuthority extends React.Component<module.IPropsInterface, any> {
    constructor(props: module.IPropsInterface) {
        super(props)
        this.state = {
            showModal:true
        }
        this.getLocalStorage = this.getLocalStorage.bind(this);
        this.isContainPermissionCode = this.isContainPermissionCode.bind(this);
    }

    componentDidMount () {
        const authorityCode = this.props.authorityCode ? this.props.authorityCode.split(",") : [];
        const identifierFlag = this.isContainPermissionCode(authorityCode);
        if(!identifierFlag) {
            this.setState({
                showModal:false
            })
        } 
    }

    //获取iframe上级页面的localStorage
    getLocalStorage = () => {
        return (window as any).top.getLocalStorage();
    }

    //判断USER_AUTHORITY的function_PROPERTY_MAP中是否包含authorityCode的值
    isContainPermissionCode = (authorityCode:any) => {
        let userAuthority:any = '';
        let permissionHoldList:any = '';
        if (!authorityCode || authorityCode.length <= 0) {
           return true;
        }
        const identifier = {};
        authorityCode.map((value:any,index:any) => {
            identifier[value] = true
        })
        //获取localStorage的权限标识
        const storage:any = this.getLocalStorage();
        if(storage.getItem("USER_AUTHORITY")) {
            userAuthority = JSON.parse(storage.getItem("USER_AUTHORITY") || '');
        }
        if(userAuthority) {
            permissionHoldList = userAuthority.function_PROPERTY_MAP || [];
        }
        //遍历权限的list
        let isContain = false;
        for(const key in permissionHoldList) {
            if(key) {
                permissionHoldList[key].map((content:any) => {
                    if(identifier[content]) {
                        isContain = true;
                    }
                })
            }
        }
        return isContain;
    }

    public render () {
        const {showModal} = this.state
        return (
            <div style={{display:showModal ? 'inline-block':'none'}}>
                {this.props.children}
            </div>
        )
    }

}

 export default IrsAuthority