/**
 * The only true faq.
 * @date 2018.12.1
 * @version 0.0.1
 * @author Campbell.Jiao
 */

import * as React from 'react';
import * as module from './module';
import { others } from 'fit-transmit-transparently';

class IrsFAQ extends React.Component<module.IPropsInterface, any> {
    static defaultProps = {
        guideBgColor:'#19AA8D',
        guideColor:'#fff',
        faqBgColor:'#ec971f',
        faqColor:'#fff',
        assBottom:'60px',
        assRight:'36px',
        isPostion:true
    }
    constructor(props: module.IPropsInterface) {
        super(props)
        this.clickGuide = this.clickGuide.bind(this);
        this.clickFAQ = this.clickFAQ.bind(this);
    }

    //点击操作指南跳转
    clickGuide = (guideUrl:any) => {
        if(guideUrl) {
            window.open(guideUrl);
        }
    }

    //点击FAQ跳转页面
    clickFAQ = (faqUrl:any) => {
        if(faqUrl){
            window.open(faqUrl);
        }
    }

    public render() {
            others(IrsFAQ.defaultProps, this.props);
        return (
            <div 
            style={{width:'48px',height:'106px',position:this.props.isPostion ? 'fixed':'relative',
            right:this.props.assRight,bottom:this.props.assBottom}}
            id = {this.props.faqId}
            >
                <div 
                style={{width:'48px',height:'48px',borderRadius:'50%',color:this.props.guideColor,fontSize:'12px',
                textAlign:'center',cursor:'pointer',paddingTop:'8px',backgroundColor:this.props.guideBgColor,
                boxShadow:'0 2px 4px 0 rgba(25,170,141,0.40)',marginBottom:'10px'}}
                onClick={this.clickGuide.bind(this,this.props.guideUrl)}>
                    操作<br/>
                    指南
                </div>
                <div 
                onClick={this.clickFAQ.bind(this,this.props.faqUrl)} 
                style={{lineHeight:'48px',backgroundColor:this.props.faqBgColor,boxShadow:'0 2px 4px 0 rgba(248,172,89,0.40)',
                width:'48px',height:'48px',borderRadius:'50%',color:this.props.faqColor,fontSize:'12px',textAlign:'center',
                cursor:'pointer'}}>
                    FAQ
                </div>
            </div>
        )
    }
}

export default IrsFAQ;
