/**
 * @date 2018.12.08
 * @version 0.0.1
 * @author Gail.Chen
 */
import * as React from 'react';
import * as module from './module';
import { others } from 'fit-transmit-transparently';
import { Form, Select } from 'antd';
import IrsSteps from '../../../../packages/elements/irs-steps/index';
import IrsButton from '../../../../packages/elements/irs-button/index';
import IrsInput from '../../../../packages/elements/irs-input/index';
import IrsProgress from '../../../../packages/elements/irs-progress/index';
import IrsSwitch from '../../../../packages/elements/irs-switch/index';
import IrsCheckbox from '../../../../packages/elements/irs-checkbox/index';
import IrsUpload from '../../../../packages/elements/irs-upload/index';

import IrsFetchHttp from '../../../http/irs-fetch/http';
const FormItem = Form.Item;
const Option = Select.Option;
import './style.less';

class IrsImport extends React.Component<module.IPropsInterface, any> {
    //  GET /excel/errorFile
    //     下载错误文件
    //    POST /excel/excelfile
    //     下载文件
    //    POST /excel/importResult
    //     获取所有正确的数据
    //    POST /excel/interruptProgress
    //     中断流程
    //    POST /excel/progress
    //     获取文件上传进度接口
    //    POST /excel/upload
    //     excel文件上传
    static defaultProps = {
    }
    constructor(props: module.IPropsInterface) {
        super(props);
        this.state = {
            visible: false,
            loading: false,
            percent: 0,
            eventId: '',
            progressId: '',
            errorNumber: 0,
            totalNumber: 0,
            step: 1,
            fileData: {},
            errorMessageList: [],
            fileList: [],
            uploading: false,
            checkedInputList: [],
            checkedNonInputList: [],
            indeterminate: true,
            checkInputAll: true,
            checkNonInputAll: false,
            inputItem: [],
            nonInputItem: [],
            inputOptions: [],
            nonInputOptions: [],
            isExportChecked: false,
            activeType: '',
            stepDataArray: [
                {
                    status: 'process',
                    title: '上传文件'

                },
                {
                    status: 'wait',
                    title: '数据校验',

                },
                {
                    status: 'wait',
                    title: '导入完成'
                }
            ],
            percentStatus: "active",
            percent1Status: "active",
            percent2Status: "active",
            correctDatas: []
        };
    }
    componentWillMount() {
        if (this.props.type === 'complex' && this.props.needItem) {
            this.getOptions();
        } else if (this.props.type === 'simple') {
            this.setState({ activeType: this.props.activeType ? this.props.activeType : '' });
        }
    }
    componentWillReceiveProps(nextProps: any) {
        // 判断传入的选项值是否更新
        if ((nextProps.inputOptions !== this.state.inputOptions
            || nextProps.nonInputOptions !== this.state.nonInputOptions) && nextProps.type === 'complex' && nextProps.needItem) {
            this.getOptions();
        }
        // 判断传入的选中模板是否更新
        if (nextProps.activeType !== this.state.activeType) {
            this.setState({
                activeType: nextProps.activeType
            })
        }
        if (nextProps.visible !== this.state.visible) {
            this.setState({ visible: nextProps.visible,  step: nextProps.step || 1, fileData: {}, fileList: [] });
        }
        //  else {
        //     //props更新时触发的函数
        //     this.setState({ step: nextProps.step });
        // }
    }
    // 下拉框值变化
    changeImportType = (value: any) => {
        this.setState({ activeType: value });
    }
    // 给是否导出已有数据赋值
    getOptions = () => {
        const { inputOptions, nonInputOptions, checkedInputList } = this.state;
        if (this.props.inputItem) {
            this.props.inputItem.forEach((i: any) => {
                inputOptions.push(i.name);
                checkedInputList.push(i.name)
            })
        }
        if (this.props.nonInputItem) {
            this.props.nonInputItem.forEach((i: any) => {
                nonInputOptions.push(i.name)
            })
        }

    }
    // 获取数据上传以及解析进度
    getAnalysisDemo = () => {
        const timer = setInterval(() => {
            new IrsFetchHttp().post(`${this.props.progressUrl}?moduleCode=${this.props.moduleCode}`, null).then((res: any) => {
                if (res.stepSuccess) {
                    switch (res.currentStep) {
                        case 1:
                            this.setState({
                                percent: res.stepProgress,
                                percent1: 0,
                                percent2: 0
                            })
                            break;
                        case 2:
                            this.setState({
                                percent: 100,
                                percent1: res.stepProgress,
                                percent2: 0
                            })
                            break;
                        case 3:
                            this.setState({
                                percent: 100,
                                percent1: 100,
                                percent2: res.stepProgress
                            }, () => {
                                if (+res.stepProgress === 100 && +this.state.percent2 === 100) {
                                    clearInterval(timer);
                                    new IrsFetchHttp().post(`${this.props.importResult}?moduleCode=${this.props.moduleCode}`, null).then((result: any) => {
                                        if (result && result.rowLogs.length !== 0) {
                                            const errorMessageList: any = [];
                                            result.rowLogs.map((i: any) => {
                                                errorMessageList.push(`第${i.rowNum}行：${i.defaultLogMsg}`);
                                            })
                                            this.setState({
                                                correctResultData: result,
                                                correctDatas: result.correctDatas,
                                                errorMessageList,
                                                loading: false
                                            })
                                        } else if (result && result.rowLogs.length === 0) {
                                            this.setState({
                                                correctResultData: result,
                                                correctDatas: result.correctDatas,
                                                loading: false
                                            })
                                        }
                                    })
                                }
                            });
                            break;
                        default:
                            break;
                    }
                } else {
                    clearInterval(timer);
                    this.setState({
                        percent: res.currentStep === 1 ? res.stepProgress : 100,
                        percent1: res.currentStep === 2 ? res.stepProgress : res.currentStep === 3 ? 100 : 0,
                        percent2: res.currentStep === 3 ? res.stepProgress : 0,
                        percentStatus: res.currentStep === 1 ? "exception" : "active",
                        percent1Status: res.currentStep === 2 ? "exception" : "active",
                        percent2Status: res.currentStep === 3 ? "exception" : "active"
                    }, () => {
                        const errorMessageList: any = [];
                        res.errorLog.map((i: any) => {
                            errorMessageList.push(i.rowNum ? `第${i.rowNum}行：${i.defaultLogMsg}` : i.defaultLogMsg);
                        })
                        this.setState({
                            correctResultData: [],
                            correctDatas: [],
                            errorMessageList,
                            loading: false
                        })
                    });
                }
            });
        }, 500);
        this.setState({ timer })
    }
    // doChange = () => {
    //     const { fileList, stepDataArray } = this.state;
    //     const formData = new FormData();
    //     stepDataArray[0].status = 'finish';
    //     stepDataArray[1].status = 'process';
    //     fileList.forEach((file: any) => {
    //         formData.append("file", file);
    //     });
    //     this.setState({
    //         stepDataArray,
    //         loading: false
    //     });
    // }
    //获取上传进度
    getSimpleDemo = () => {
        let count = 0;
        //
        const timer = setInterval(() => {
            if (+count !== 100) {
                this.setState({
                    percent: count
                });
            } else {
                clearInterval(timer);
                this.setState({
                    percent: 100
                });
                this.getLastResult();
            }
            count++;
        }, 100);
    }
    getProgress = () => {
        // let percent: any = 0;
        const polling: any = setInterval(() => {
            new IrsFetchHttp().get(`${this.props.resultUrl}?moduleCode=${this.props.moduleCode}&spreadSheetId=${this.state.correctResultData.spreadSheetId}`, null).then((res: any) => {
                if (res && +res !== 100) {
                    this.setState({
                        importPercent: res
                    })
                } else {
                    if (+res === 100) {
                        clearInterval(polling);
                        this.setState({ importPercent: 100 }, () => {
                            setTimeout(() => {
                                this.setState({ importResult: true, importLoading: false })
                            }, 200);
                        });
                    } else {
                        this.setState({ importResult: false, importLoading: false });
                    }
                }
            })
        }, 500)
    }
    //获取最终上传结果
    getLastResult = () => {
        const { stepDataArray } = this.state;
        stepDataArray[0].status = 'finish';
        stepDataArray[1].status = 'finish';
        stepDataArray[2].status = 'finish';
        this.setState({
            importLoading: false,
            step: 3,
            importPercent: 0
        })
    }
    //开始上传

    // 获取进度
    //上传开始后获取上传状态

    handleUpload = (type: any) => {
        switch (type) {
            case 'complex':
                const { fileList, stepDataArray } = this.state;
                const formData = new FormData();
                stepDataArray[0].status = 'finish';
                stepDataArray[1].status = 'process';
                fileList.forEach((file: any) => {
                    formData.append("file", file);
                });
                const extraParams = JSON.stringify(this.props.extraParams);
                new IrsFetchHttp().post(`${this.props.uploadUrl}?moduleCode=${this.props.moduleCode}&extraParams=${encodeURIComponent(extraParams)}`, formData, null, null).then((res: any) => {
                    if (res === undefined) {
                        this.setState({ step: 2, loading: true }, () => {
                            this.getAnalysisDemo();
                        })
                    }
                });
                break;
            case 'simple':
                this.setState({ step: 2, loading: true }, () => {
                    this.getSimpleDemo();
                })
                break;
            default:
                break;
        }

        // this.setState({
        //     uploading: true
        // });
        // this.setState({ uploading: false, step: 2, stepDataArray });
        // commonUpload(
        //     this.props.uploadUrl +
        //     "?progressId=" +
        //     Math.random()
        //         .toString()
        //         .replace("0.", ""),
        //     formData,
        //     { isHeader: false, isStringify: false }
        // ).data.then((res: any) => {
        //     if (res.result) {
        //         if (res.errorMessageList.length === 0) {
        //             this.setState({ uploading: false, step: 2, fileData: { ...res.data } });
        //         } else {
        //             this.setState({
        //                 uploading: false, step: 2,
        //                 validateErrorNumber: res.errorNumber,
        //                 errorMessageList: res.errorMessageList,
        //                 fileData: { ...res.data }
        //             })
        //         }
        //     } else {
        //         this.setState({ uploading: false })
        //         message.error(res.errorMessage)
        //     }
        // });
    };
    getId = (name: any, type: any) => {
        let id = '';
        switch (type) {
            case 'input':
                this.props.inputItem.forEach((i: any) => {
                    if (i.name.toString() === name.toString()) {
                        id = i.id;
                    }
                })
                break;
            case 'nonInput':
                this.props.nonInputItem.forEach((i: any) => {
                    if (i.name.toString() === name.toString()) {
                        id = i.id;
                    }
                })
                break;
            default:
                break;
        }
        return id;
    }
    //下载模板
    downLoadTemplate = (type: any) => {
        switch (type) {
            case 'complex':
                if (this.props.needItem) {
                    if (this.state.isExportChecked) {
                        const getInputList: any = [];
                        const getNonInputList: any = [];
                        this.state.checkedInputList.map((i: any) => {
                            getInputList.push(this.getId(i, 'input'));
                        })
                        this.state.checkedNonInputList.map((i: any) => {
                            getNonInputList.push(this.getId(i, 'nonInput'));
                        })
                    }
                    window.location.href = this.props.downUrl;
                } else {
                    window.location.href = this.props.downUrl;
                }
                break;
            case 'simple':
                let downLoadUrl = '';
                this.props.importTypeDataArray.map((i: any) => {
                    if (i.code === this.state.activeType) {
                        downLoadUrl = i.downUrl;
                    }
                })
                window.location.href = downLoadUrl;
                break;
            default:
                break;
        }

    };
    changeIsExportChecked = (checked: any) => {
        this.setState({ isExportChecked: checked });
    }
    // 全选输入项
    onCheckAllInputChange = (e: any) => {
        this.setState({
            checkedInputList: e.target.checked ? this.state.inputOptions : [],
            indeterminate: false,
            checkInputAll: e.target.checked,
        });
    }
    // 全选非输入项
    onCheckAllNoInputChange = (e: any) => {
        this.setState({
            checkedNonInputList: e.target.checked ? this.state.nonInputOptions : [],
            indeterminate: false,
            checkNonInputAll: e.target.checked,
        });
    }
    // 输入项变化
    onInputChange = (checkedInputList: any) => {
        this.setState({
            checkedInputList,
            indeterminate: !!checkedInputList.length && (checkedInputList.length < this.state.inputOptions.length),
            checkInputAll: checkedInputList.length === this.state.inputOptions.length,
        });
    }
    // 非输入项变化
    onNoInputChange = (checkedNonInputList: any) => {
        this.setState({
            checkedNonInputList,
            indeterminate: !!checkedNonInputList.length && (checkedNonInputList.length < this.state.nonInputOptions.length),
            checkNonInputAll: checkedNonInputList.length === this.state.nonInputOptions.length,
        });
    }
    //导入正确数据
    importData = () => {
        new IrsFetchHttp().post(`${this.props.confirmUrl}`, this.props.extraParams ?
            { extraParams: this.props.extraParams, ...this.state.correctResultData, moduleCode: this.props.moduleCode } :
            { ...this.state.correctResultData, moduleCode: this.props.moduleCode }).then((res: any) => {
                if (res && !res.errorResult) {
                    this.setState({ step: 3, importLoading: true }, () => {
                        this.getProgress();
                    });
                }
            });
    }
    //取消下载
    cancel = () => {
        const { stepDataArray } = this.state;
        stepDataArray[0].status = 'process';
        stepDataArray[1].status = 'wait';
        stepDataArray[2].status = 'wait';
        this.setState({
            errorNumber: 0,
            step: 1,
            percent: 0,
            percent1: 0,
            percent2: 0,
            importPercent: 0,
            eventId: '',
            errorMessageList: [],
            fileData: {},
            fileList: [],
            uploading: false,
            stepDataArray,
            percentStatus: "active",
            percent1Status: "active",
            percent2Status: "active",
            correctDatas: []
        })
    }
    //下载错误数据
    downError = () => {
        // /excel/errorFile
        window.location.href = `${this.props.downErrUrl}?moduleCode=${this.props.moduleCode}&onlyError=true`;
    }
    //关闭
    close = () => {
        if (this.props.importComplete) {
            this.props.importComplete()
        }
        this.cancel();
        if (this.props.cancel) {
            this.props.cancel();
        }
    }
    // 放弃
    abandon = () => {
        new IrsFetchHttp().post(`${this.props.abandonUrl}?moduleCode=${this.props.moduleCode}`, null).then((res: any) => {
            console.log(res)
        })
        clearInterval(this.state.timer);
        this.cancel();
    }
    public render() {
        others(IrsImport.defaultProps, this.props);
        const { uploading } = this.state;
        const props = {
            name: "file",
            headers: {
                authorization: "authorization-text",
                Accept: "application/json"
            },
            multiple: false,
            actions:
                this.props.uploadUrl +
                "?progressId=" +
                Math.random()
                    .toString()
                    .replace("0.", ""),
            onRemove: (file: any) => {
                this.setState(({ fileList }: any) => {
                    const index = fileList.indexOf(file);
                    const newFileList = fileList.slice();
                    newFileList.splice(index, 1);
                    return {
                        fileList: newFileList
                    };
                });
            },
            beforeUpload: (file: any) => {
                this.setState(({ fileList }: any) => ({
                    fileList: [file]
                }));
                return false;
            },
            fileList: this.state.fileList
        };
        let content = null;
        switch (this.props.type) {
            case 'complex':
                content =
                    <div className="common-import">
                        <div className="import-step">
                            <IrsSteps
                                current={this.state.current}
                                status={this.state.status}
                                stepDataArray={this.state.stepDataArray}
                            />
                        </div>
                        {((): any => {
                            switch (this.state.step) {
                                case 1:
                                    return (
                                        <div className="download-template">
                                            <div className="form-inline">
                                                <div className="form-inline-export">
                                                    <IrsButton
                                                        type="default"
                                                        className="download-btn"
                                                        onClick={this.downLoadTemplate.bind(this, 'complex')}
                                                    >
                                                        下载模板
                                                    </IrsButton>
                                                    <div className="switch-box">
                                                        <span>是否导出已有数据：</span>
                                                        <IrsSwitch onChange={this.changeIsExportChecked} />
                                                    </div>
                                                </div>

                                                <Form layout="inline" style={{ float: "right" }}>
                                                    <FormItem>
                                                        <IrsUpload {...props}>
                                                            <IrsInput
                                                                className="b-size"
                                                                placeholder=""
                                                            />
                                                            <IrsButton
                                                                type="default"
                                                                // className="b-size"
                                                                style={{ marginLeft: "10px" }}
                                                            >
                                                                选择文件
                                                            </IrsButton>

                                                        </IrsUpload>
                                                    </FormItem>
                                                    <FormItem>
                                                        <IrsButton
                                                            className="b-size"
                                                            type="primary"
                                                            onClick={this.handleUpload.bind(this, 'complex')}
                                                            disabled={this.state.fileList.length === 0}
                                                            loading={uploading}
                                                        >
                                                            开始导入
                                                        </IrsButton>
                                                    </FormItem>
                                                </Form>
                                            </div>
                                            <div className={this.props.needItem ? "field-content" : "hide"}>
                                                <div className="title">
                                                    表头字段选择<span>(注：下载模板前，请选择需要导出的列)</span>
                                                </div>
                                                <div className="input-item">
                                                    <IrsCheckbox
                                                        onChange={this.onCheckAllInputChange}
                                                        checked={this.state.checkInputAll}
                                                        defaultChecked={true}
                                                    >
                                                        输入项
                                                    </IrsCheckbox>
                                                    <div className="input-item-group">
                                                        <IrsCheckbox
                                                            isCompose={true}
                                                            composeOpts={this.state.inputOptions}
                                                            checkedOpts={this.state.checkedInputList}
                                                            onChange={this.onInputChange} />
                                                    </div>
                                                    <IrsCheckbox
                                                        onChange={this.onCheckAllNoInputChange}
                                                        checked={this.state.checkNonInputAll}
                                                    >
                                                        非输入项
                                                    </IrsCheckbox>
                                                    <div className="input-item-group">
                                                        <IrsCheckbox
                                                            isCompose={true}
                                                            composeOpts={this.state.nonInputOptions}
                                                            checkedOpts={this.state.checkedNonInputList}
                                                            onChange={this.onNoInputChange} />
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    );
                                case 2:
                                    return this.state.loading ? (
                                        <div className="data-valid">
                                            <div style={{ width: '60%', margin: '20px auto' }}>
                                                <label>上传中</label>
                                                <IrsProgress percent={this.state.percent} type="line" status={this.state.percentStatus} />
                                                {/* exception */}
                                            </div>
                                            <div style={{ width: '60%', margin: '20px auto' }}>
                                                <label>待解析</label>
                                                <IrsProgress percent={this.state.percent1} type="line" status={this.state.percent1Status} />
                                            </div>
                                            <div style={{ width: '60%', margin: '20px auto' }}>
                                                <label>待匹配</label>
                                                <IrsProgress percent={this.state.percent2} type="line" status={this.state.percent2Status} />
                                            </div>
                                            <IrsButton
                                                onClick={this.abandon}
                                                className="abandon-IrsButton"
                                            >放弃上传
                                            </IrsButton>
                                        </div>
                                    ) : (
                                            <div className="data-valid">
                                                {this.state.errorMessageList.length > 0 ? (
                                                    <div className="status-wrapper error">
                                                        <div className="status-icon">
                                                            <span className="error-icon" />
                                                        </div>
                                                        <div className="status-mess">
                                                            <div className="status-mess-content">
                                                                有<span className="error">
                                                                    {this.state.errorMessageList.length}
                                                                </span>条数据存在逻辑错误或系统数据重复错误<br />
                                                                <span>
                                                                    {
                                                                        this.state.errorMessageList.map((item: any) => (
                                                                            <span>{item}<br /></span>
                                                                        ))
                                                                    }
                                                                </span>
                                                            </div>
                                                        </div>
                                                    </div>
                                                ) : (
                                                        <div className="status-wrapper success">
                                                            <div className="status-icon">
                                                                <span className="success-icon" />
                                                            </div>
                                                            <div className="status-mess">当前页面数据全部通过校验，请您确认后点击导入</div>
                                                        </div>
                                                    )}
                                                <div className="content">
                                                    <IrsButton
                                                        className={this.state.correctDatas.length !== 0 ? "btn btn-primary float-right" : "btn btn-primary float-right"}
                                                        onClick={this.importData}
                                                    >
                                                        导入正确的数据
                                                    </IrsButton>
                                                    <IrsButton
                                                        className="btn btn-default float-right"
                                                        onClick={this.cancel}
                                                    >
                                                        取消
                                                    </IrsButton>
                                                </div>
                                            </div>
                                        );
                                case 3:
                                    return this.state.importLoading ? (
                                        <div className="data-valid">
                                            <div style={{ width: '60%', margin: '20px auto' }}>
                                                <IrsProgress percent={this.state.importPercent} type="line" status="active" />
                                            </div>
                                        </div>
                                    ) : (
                                            <div className="import-success">
                                                {this.state.importResult ?
                                                    <div className="content">
                                                        <img
                                                            src={require("./images/success.png")}
                                                            alt=""
                                                        />
                                                        <h1>导入完成!</h1>
                                                        <p>
                                                            您已成功导入<span className="success">{this.state.correctDatas.length}</span>条数据,
                                                                <span className="error">
                                                                {this.state.errorMessageList.length}
                                                            </span>条数据（存在问题）忽略导入
                                                                <a
                                                                href="javascript:;"
                                                                onClick={this.downError}
                                                                className={this.state.errorMessageList.length === 0 ? "hide" : "pointer"}
                                                            >
                                                                <span
                                                                    style={{ fontSize: "12px", color: "#5AB2EC" }}
                                                                >
                                                                    (点击下载)
                                                                    </span>
                                                            </a>
                                                        </p>
                                                        <IrsButton type="primary" onClick={this.close}>
                                                            确认
                                                        </IrsButton>
                                                    </div> : <div className="content">
                                                        <img
                                                            src={require("./images/success.png")}
                                                            alt=""
                                                        />
                                                        <h1>导入失败!</h1>
                                                        <p>
                                                            导入数据时出现错误，请重新导入
                                                        </p>
                                                        <IrsButton type="primary" onClick={this.close}>
                                                            确认
                                                    </IrsButton>
                                                    </div>
                                                }

                                            </div>
                                        );
                            }
                        })()}
                    </div>
                break;
            case 'simple':
                content =
                    <div className="simple-import">
                        {((): any => {
                            switch (this.state.step) {
                                case 1:
                                    return (
                                        <div>
                                            <span>1.选择需要导入的类型或模版下载</span>
                                            <div className="switch">
                                                <span>是否导出已有数据：</span>
                                                <IrsSwitch onChange={this.changeIsExportChecked} />
                                            </div>
                                            <ul>
                                                <li>
                                                    <Select
                                                        placeholder="请选择导入类型"
                                                        style={{ width: 300 }}
                                                        value={this.state.activeType}
                                                        onChange={this.changeImportType}
                                                    >
                                                        {
                                                            this.props.importTypeDataArray ?
                                                                this.props.importTypeDataArray.map((i: any, index: any) => (
                                                                    <Option value={i.code}>{i.typeName}</Option>
                                                                )) : []
                                                        }
                                                    </Select>
                                                    <IrsButton onClick={this.downLoadTemplate.bind(this, 'simple')}>下载模板</IrsButton>
                                                </li>
                                                <li>
                                                    <p>2.填写模版文件选择文件，可开始导入</p>
                                                    <Form layout="inline" style={{ float: "right" }}>
                                                        <FormItem>
                                                            <IrsUpload {...props}>
                                                                <IrsInput
                                                                    className="b-size"
                                                                    placeholder=""
                                                                    style={{ width: 300 }}
                                                                />
                                                                <IrsButton
                                                                    type="default"
                                                                    className="b-size"
                                                                    style={{ marginLeft: "10px" }}
                                                                >
                                                                    选择文件
                                                                </IrsButton>
                                                            </IrsUpload>
                                                        </FormItem>
                                                        <FormItem>
                                                            <IrsButton
                                                                className="b-size"
                                                                type="primary"
                                                                onClick={this.handleUpload.bind(this, 'simple')}
                                                                disabled={this.state.fileList.length === 0}
                                                                loading={uploading}
                                                            >
                                                                开始导入
                                                            </IrsButton>
                                                        </FormItem>
                                                    </Form>
                                                </li>
                                            </ul>
                                        </div>
                                    )
                                case 2:
                                    return (
                                        this.state.loading ?
                                            <div className="data-valid">
                                                <div style={{ width: '60%', margin: '20px auto' }}>
                                                    <IrsProgress percent={this.state.percent} type="line" status="active" />
                                                </div>
                                            </div> : <div className="status-wrapper error">
                                                <div className="status-icon">
                                                    <span className="error-icon" />
                                                </div>
                                                <div className="status-mess">
                                                    <div className="status-mess-content">
                                                        有<span className="error">
                                                            {this.state.validateErrorNumber}
                                                        </span>条数据存在逻辑错误或系统数据重复错误<br />
                                                        <span>
                                                            {
                                                                this.state.errorMessageList.map((item: any) => (
                                                                    <span>{item}<br /></span>
                                                                ))
                                                            }
                                                        </span>
                                                    </div>
                                                </div>
                                            </div>
                                    )
                                case 3:
                                    return (
                                        <div className="import-success">
                                            <div className="content">
                                                {
                                                    this.state.importResult ?
                                                        <div>
                                                            <img
                                                                src={require("./images/success.png")}
                                                                alt=""
                                                            />
                                                            <h1>导入完成!</h1>
                                                            <p>
                                                                您已成功导入<span className="success">{this.state.correctDatas.length}</span>条数据,
                                                                <span className="error">
                                                                    {this.state.errorMessageList.length}
                                                                </span>条数据（存在问题）忽略导入
                                                                <a
                                                                    href="javascript:;"
                                                                    onClick={this.downError}
                                                                    className={this.state.errorMessageList.length === 0 ? "hide" : "pointer"}
                                                                // style={{
                                                                //     borderBottomWidth: this.state.errorNumber
                                                                //         ? "1px"
                                                                //         : "0",
                                                                //     cursor: this.state.this.state.errorMessageList.length ? "pointer" : "initial"
                                                                // }}
                                                                >
                                                                    <span
                                                                        style={{ fontSize: "12px", color: "#5AB2EC" }}
                                                                    >
                                                                        (点击下载)
                                                                    </span>
                                                                </a>
                                                            </p></div> : <div><img
                                                                src={require("./images/success.png")}
                                                                alt=""
                                                            />
                                                            <h1>导入完成!</h1>
                                                            <p>
                                                                您已成功导入<span className="success">{0}</span>条数据,
                                                                <span className="error">
                                                                    {0}
                                                                </span>条数据导入忽略<br />
                                                                <a
                                                                    href="javascript:;"
                                                                    onClick={this.downError}
                                                                    style={{
                                                                        borderBottomWidth: this.state.errorNumber
                                                                            ? "1px"
                                                                            : "0",
                                                                        cursor: this.state.errorNumber ? "pointer" : "initial"
                                                                    }}
                                                                >
                                                                    <span className="error">
                                                                        {0}
                                                                    </span>条数据存在逻辑错误或系统数据重复错误
                                                                    <span
                                                                        style={{ fontSize: "12px", color: "#5AB2EC" }}
                                                                        ng-show="errorNumber"
                                                                    >
                                                                        (点击下载)
                                                                    </span>
                                                                </a>
                                                            </p></div>
                                                }

                                            </div>
                                        </div>
                                    )
                            }
                        })()}
                    </div>
                break;
            default:
                break;
        }
        return (
            <div>
                {content}
            </div>

        );
    }
}

export default IrsImport;
