
export interface IPropsInterface {
    /** 导入组件类型 */
    type?: 'simple' | 'complex',

    /** 导入组件自定义样式 */
    style?: any,

    /** 是否显示 */
    visible: boolean,

    /** 设置组件的ID */
    importId?: string,

    /** 导入模块的注册code */
    moduleCode: string,

    /** 上传接口 */
    uploadUrl: string,

    /** 下载模板接口 */
    downUrl: string,

    /** 导入进度接口 */
    progressUrl: string,

    /** 进度条完毕后，获取导入结果接口 */
    importResult: string,

    /** 放弃导入接口 */
    abandonUrl: string,

    /** 导入正确数据接口 第二步点击确定 */
    confirmUrl: string,

    /** 获取最终上传结果接口 最后一步 */
    resultUrl: string,

    /** 下载错误数据接口  最后一步链接 */
    downErrUrl: string,

    /** 是否需要展示输入项，非输入项 */
    needItem: boolean,

    /** 输入项数组 */
    inputItem?:any [],

    /** 非输入项数组 */
    nonInputItem?:any [],

     /** 导入数据类型 */
    importTypeDataArray?: any,

    /** 当前显示得导入数据类型 */
    activeType?: any,

    /** 导入正确数据需要带的参数 */
    extraParams?: object,

    /** 点击取消操作，用来刷新界面 */
    cancel?: () => void

    /** 导入完成的回调，用来刷新界面 */
    importComplete?: () => void,
}