### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.1 | V0.0.2 | Gail | 新增导入组件

<br><br/>
### 2.安装方式
<code>
npm install irs-import
</code>
### 3.基本接口地址
##### 前缀地址： 线上：/web/gateway/cnb/aggregate/excel， 本地： /gateway/cnb/aggregate/excel
##### (记得带前缀地址)
##### 上传模块uploadUrl: /upload
##### 上传进度progressUrl /progress
##### 上传后，获取导入结果的接口importResult /importResult
##### 放弃导入abandonUrl /interruptProgress
##### 获取最后上传接口resultUrl /progress/importresult(前缀为 线上：/web/gateway/spreadsheet/api， 本地：/gateway/spreadsheet/api)
##### 下载错误数据downErrUrl /errorFile

<br><br/><br><br/>
### 4. 调用方式
#### 第一种表现形式：type为complex
```jsx
class IrsImportDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        inputItem: [{
          name: '姓名',
          id: 1
        }, {
          name: '证件号',
          id: 2
        }, {
          name: '手机号',
          id: 3
        }],
        nonInputItem: [{
          name: '纳税人身份',
          id: 1
        },{
          name: '基本工资',
          id: 2
        },{
          name: '岗位工资',
          id: 3
        }]
    }
  }
  render() {
    return (
      <div className="App">
        <IrsImport
            type="complex"
            visible={true}
            moduleCode='SalaryDataAcquisitionMeta'
            needItem={false}
            extraParams= {{'summaryTableName':'测试导入'}}
            downErrUrl={"/gateway/cnb/aggregate/excel/errorFile"} // 下载错误数据接口
            uploadUrl={"/gateway/cnb/aggregate/excel/upload"} // 上传接口
            progressUrl={"/gateway/cnb/aggregate/excel/progress"} // 上传进度
            importResult={"/gateway/cnb/aggregate/excel/importResult"} // 获取最终上传结果接口
            abandonUrl = {"/gateway/cnb/aggregate/excel/interruptProgress"} // 放弃导入接口
            resultUrl = {"/gateway/spreadsheet/api/progress/importresult"} // 获取最终上传结果接口 最后一步
            downUrl={'/gateway/spreadsheet/api/gateway/payroll/api/salaryDataAcquisitionMeta/download/template'} // 下载设置模板
            confirmUrl={'/gateway/spreadsheet/api/gateway/payroll/api/salaryDataAcquisitionMeta/upload'} // 最后一步导入，保存接口
            cancel={this.cancel}
        />
      </div>
    )
  }
}
;<IrsImportDemo />
```
#### 第二种表现形式：type为simple
```jsx
class IrsImportDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        importTypeDataArray: [{
          code: "1",
          typeName: '直属领导',
          downUrl: '/lianjie1'
        },{
          code: "2",
          typeName: '教育经历',
          downUrl: '/lianjie2'
        },{
          code: "3",
          typeName: '工作经历',
          downUrl: '/lianjie3'
        }],
        activeType: '',
        visible: false
    }
    this.onOk = this.onOk.bind(this);
    this.onCancel = this.onCancel.bind(this);
    this.showModal = this.showModal.bind(this);
  }
  onCancel() {
    this.setState({visible: false});
  }
  onOk() {
    this.setState({visible: false});
  }
  showModal(type) {
    this.setState({activeType: type, visible: true});
  }
  render() {
    return (
      <div className="App">
        <IrsRow gutter={24}>
          <IrsCol span={8}>
            <IrsButton onClick={this.showModal.bind(this, '1')}>直属领导</IrsButton>
          </IrsCol>
          <IrsCol span={8}>
            <IrsButton onClick={this.showModal.bind(this, '2')} >教育经历</IrsButton>
          </IrsCol>
          <IrsCol span={8}>
            <IrsButton onClick={this.showModal.bind(this, '3')} >工作经历</IrsButton>
          </IrsCol>
        </IrsRow>
        <IrsModal 
          title="导出"
          width={550}
          visible={this.state.visible} 
          onOk={this.onOk} 
          onCancel={this.onCancel}
          content={<IrsImport 
            type="simple"
            moduleCode="StaffSalary"
            visible={true}
            step={1}
            importTypeDataArray={this.state.importTypeDataArray}
            activeType={this.state.activeType}
            />} />
      </div>
    )
  }
}
;<IrsImportDemo />
```