/**
 * The only true department-selector.
 * @date 2018.12.8
 * @version 0.0.1
 * @author Campbell.Jiao
 */

import * as React from 'react';
import * as module from './module';
import { others } from 'fit-transmit-transparently';
import { Tree,Icon } from 'antd';
import "./style.less";
import IrsFetchHttp from '../../../http/irs-fetch/http';
const TreeNode = Tree.TreeNode;
const dataList:any = [];
let parentKey = '';
let parentText = '';
const isEmpty = (obj: any) => {
    if (typeof obj === "undefined" || obj === null || obj === "") {
        return true;
    }
    return false;
}
const getDepartmentAndStaff = () => {
    const settingData = new IrsFetchHttp().get(
        "/web/common/department/getScheduleScopeStaffTree.do",
        null
    );
    return {
        data:settingData
    }
}
class IrsStaffAndDepartmentSelector extends React.Component<module.IPropsInterface, any> {
    static defaultProps = {
        selectWidth:'300px'
    }
    constructor(props:module.IPropsInterface) {
        super(props)
        this.state = {
            gData:[],
            disabledIds: [],
            searchValue:'',
            checkedKeys:{checked:[],halfChecked:[]}, 
        }
    }
    componentWillMount() {
        getDepartmentAndStaff().data.then((res:any) => {
            if(res && res.staffTreeList) {
                this.setState({gData: res.staffTreeList},() => {
                    this.setState({expandedKeys: this.state.gData.length !== 0 ? [this.state.gData[0].departmentId.toString()] : []});
                });
            }
        }).then(() => {
            this.changeKeyName(this.state.gData);
        }).then(() => {
            this.setState({selectedValue: isEmpty(this.props.value) ? '' : this.getName(this.props.value, this.state.gData)});
            this.generateList(this.state.gData,'');
        })
       
        
        
    } 
    componentWillReceiveProps(nextProps: any) {//props更新时触发的函数
        const applicPreson = nextProps.value;
        const checkedKeys:any = {checked:[],halfChecked:[]}
        checkedKeys.checked = applicPreson
        this.setState({
            checkedKeys,
        })
        if (isEmpty(nextProps.value)) {//如果是空，则值清空
            this.setState({selectedValue:''})
        } else if (nextProps.value!==this.state.selectedValue && !isEmpty(nextProps.value)) {
            this.setState({selectedValue: isEmpty(nextProps.value) ? '' : this.getName(nextProps.value, this.state.gData)});
        }
    }
    getParentKey = (title:any, tree:any) => {
        tree.forEach((i:any, index:any) => {
            const node = i;
            if (node.children) {
                if (node.children.some((item:any) => item.text === title)) {
                    parentKey = node.key;
                } else if (this.getParentKey(title, node.children)) {
                    parentKey = this.getParentKey(title, node.children);
                }
            }
        })
        return parentKey.toString();
    };
    changeKeyName = (tree:any) => {
        tree.forEach((i:any, index:any) => {
            const node = i;
            node.key = node.id;
            if (node.children) {
                this.changeKeyName(node.children);
            }
        })
    }   
    getName = (key:any, tree:any) => {
        tree.forEach((i:any, index:any) => {
            const node = i;
            if (+node.departmentId === +key) {
                parentText = node.text;
            } else {
                if (node.children) {
                    this.getName(key, node.children);
                }
            }
        })
        return parentText;
    }
    generateList = (data:any,parentName:any) => {
        data.forEach((i:any, index:any) => {
            const node = i;
            const akey = node.key;
            dataList.push({key:akey, title: node.text});
            if (node.children) {
                this.generateList(node.children,node.text);
            }
        })
        this.setState({dataList});
    };

    onExpand = (expandedKeys:any) => {
        this.setState({
            expandedKeys,
            autoExpandParent: false,
        });
    };

    onChange = (e:any) => {
        const value = e.target.value;
        const expandedKeys = this.state.dataList.map((item:any) => {
            if (item.title.indexOf(value) > -1) {
                return this.getParentKey(item.title, this.state.gData);
            }
            return null;
        }).filter((item:any, i:any, self:any) => item && self.indexOf(item) === i);
        this.setState({
            expandedKeys,
            searchValue: value,
            autoExpandParent: true,
        });
    };

    onCheck = (checkedKeys:any) => {
        const checkedKey = this.state.checkedKeys;
        const lastCheckedKeys = checkedKey.checked;
        let allChecked = true;
        let selectedId;
        const checked = checkedKeys.checked;
        if(lastCheckedKeys.length > checked.length) {
            allChecked = false;
            for (const value of lastCheckedKeys) {
                if (checked.indexOf(value) < 0) {
                    selectedId = value;
                    break;
                }
            }
        } else {
            for (const value of checked) {
                if (lastCheckedKeys.indexOf(value) < 0) {
                    selectedId = value;
                    break;
                }
            }
        }
        const tree = this.state.gData;

        if (selectedId.length < 10) {
            this.getCheckedKeys(tree, allChecked, checked, selectedId);
        } else {
            this.cancelParent(tree, checked, selectedId, allChecked);
        }
        const List = this.state.dataList;
        const selectId = checkedKeys.checked;
        // let departmentString = '';
        const StaffListSelected:any = []
        selectId.map((value:any) => {
            List.map((context:any) => {
                if((value + "") === context.key) {
                    if(context.key.length === 36) {
                        StaffListSelected.push(context);
                    }    
                }
            })
        })
        this.props.onChange(StaffListSelected,selectId);
    }
    getCheckedKeys = (tree:any, allChecked:any, checked:any, selectedId:any) => {
        tree.map((value:any) => {
            if (value.id === selectedId) {
                this.allCheckedOrAllCancel(value.children, allChecked, checked);
            } else if (value.children.length > 0) {
                this.getCheckedKeys(value.children, allChecked, checked, selectedId);
            }
        })
    }
    allCheckedOrAllCancel = (tree:any, allChecked:any, checked:any) => {
        tree.map((value:any) => {
            const id = value.id;
            const index = checked.indexOf(id);
            if (allChecked && index < 0) {
                checked.push(id);
            }
            if (!allChecked && index > -1) {
                checked.splice(index, 1);
            }
            if (value.children.length > 0) {
                this.allCheckedOrAllCancel(value.children, allChecked, checked);
            }
        })
    }
    cancelParent = (tree:any, checked:any, selectedId:any, allChecked:any) => {
        tree.map((value:any) => {
            const children:any = value.children;
            if (children.length > 0) {
                // 是否取消父级的选中
                let cancel = true;
                // 是否继续递归
                let recursion = true;
                // 是否根据子节点全选了而选中父节点
                let checkParent = true;
                children.map((item:any) => {
                    if (checked.indexOf(item.id) > -1) {
                        cancel = false;
                    }
                    if (checked.indexOf(item.id) < 0) {
                        checkParent = false;
                    }
                    if (item.id === selectedId) {
                        recursion = false;
                    }
                })
                if (recursion) {
                    this.cancelParent(children, checked, selectedId, allChecked);
                } else {
                    const index = checked.indexOf(value.id);
                    if (cancel && index > -1) {
                        checked.splice(index, 1);
                    }
                    if (checkParent && index < 0) {
                        checked.push(value.id);
                    }
                }
            }
        })
    }
    loop = (data:any) => data.map((item:any,num:any) => {
        const {searchValue} = this.state;
        const index = item.text.indexOf(searchValue);
        const beforeStr = item.text.substr(0, index);
        const afterStr = item.text.substr(index + searchValue.length);
        const title = index > -1 ? (
            <span key={num} style={{background:searchValue.length > 0 ? '#ff0':'#fff'}}><Icon type="user" style={{display:item.staffId ? 'inline-block':'none'}}/>
                <Icon type="home" style={{display:item.staffId ? 'none':'inline-block'}}/>&nbsp;&nbsp;
                {beforeStr}
                <span style={{color: '#f50'}}>{searchValue}</span>
                {afterStr}
                <span style={{display:item.staffId ? 'none':'inline-block'}}>({item.onJobHeadCount}/{item.onJobTotalHeadCount})</span>
                </span>
        ) : <span key={num} >
                <Icon type="user" style={{display:item.staffId ? 'inline-block':'none'}}/>
                <Icon type="home" style={{display:item.staffId ? 'none':'inline-block'}}/>&nbsp;&nbsp;{item.text}
                <span style={{display:item.staffId ? 'none':'inline-block'}}>({item.onJobHeadCount}/{item.onJobTotalHeadCount})</span>
            </span>;
        if (item.children) {
            return (
                <TreeNode key={item.key} title={title} dataRef={item} disabled={item.disabled}>
                    {this.loop(item.children)}
                </TreeNode>
            );
        }
        return <TreeNode dataRef={item} key={item.key} title={title} disabled={item.disabled} />;
    });

    public render() {
        others(IrsStaffAndDepartmentSelector.defaultProps, this.props);
        return(
            <div style={{width:this.props.selectWidth}}>
                <span className="ant-input-search ant-input-affix-wrapper" style={{ marginBottom: '8px' }}>
                    <input placeholder="输入部门或人员名称" className="ant-input" type="text" onChange={this.onChange} />
                    <span className="ant-input-suffix">
                        <i className="anticon anticon-search ant-input-search-icon" />
                    </span>
                </span>
                <Tree checkable={true}
                    onCheck={this.onCheck}
                    checkedKeys={this.state.checkedKeys}
                    onExpand={this.onExpand}
                    expandedKeys={this.state.expandedKeys}
                    // defaultExpandAll={true}
                    autoExpandParent={this.state.autoExpandParent}
                    checkStrictly={true}
                >
                    {this.loop(this.state.gData)}
                </Tree>
            </div>
        )
    }
}
export default IrsStaffAndDepartmentSelector