/**
 * The only true staff-selector.
 * @date 2018.12.8
 * @version 0.0.1
 * @author Campbell.Jiao
 */

import * as React from 'react';
import * as module from './module';
import {Input,message,Radio,Modal,Tree,Table,Button,Icon} from 'antd';
import { others } from 'fit-transmit-transparently';
import IrsEditableCell from "../../../elements/irs-editable-cell/src/editable-cell";
import "./style.less";
import IrsFetchHttp from  '../../../http/irs-fetch/http';
import IrsChooseApprover from "../../../elements/irs-choose-approver/src/choose-approver"
const TreeNode = Tree.TreeNode;
const applicationInfo = () => {
    const settingData = new IrsFetchHttp().get('/web/user/getApproverConfig.do',null);
    return {
      data: settingData
    }
  }
const getStaff = (parmas:any) => {
    const settingData = new IrsFetchHttp().post("/web/common/staffSelector/search.do",
    {criteria:parmas,staffStatusList:["IN_SERVICE"],validatePrivilege:false});
    return {
      data: settingData
    }
}
const saveUserConfig = (id:any,data:any) => {
    const settingData = new IrsFetchHttp().post(`/web/user/saveUserConfig.do?id=${id}`,data);
    return {
      data: settingData
    }
  }
class IrsStaffSelector extends React.Component<module.IPropsInterface, any> {
    static defaultProps = {
        selectWidth:'300px'
    }
    constructor(props:module.IPropsInterface) {
        super(props)
        this.state = {
            staffList:[],
            staffListA:[],
            selectedId:[],
            initApprover:[],//常用人
            currentIndex: 0,
            groupList:[]
        }
    }
    componentWillMount () {
        const selectedId = this.props.selectedId;
        const selectedList = this.props.selectedList;
        applicationInfo().data.then((res:any) => {
            if(res) {
                this.setState({
                    selectedId,
                    staffList: res.staffSelectorHistoryList,
                    staffListA:res.staffSelectorHistoryList,
                    selectedList,
                    initApprover:res.staffSelectorHistoryList
                    ? res.staffSelectorHistoryList
                    : [],
                    groupList: res.staffSelectorGroupList
                    ? res.staffSelectorGroupList.length > 0
                    ? res.staffSelectorGroupList
                    : []
                    : []    
                })
            }
        })        
        
    }
    
    componentWillReceiveProps (nextProps:any) {
        const selectedId = nextProps.selectedId;
        const selectedList = nextProps.selectedList;
        this.setState({
            selectedId,
            selectedList
        })
    }

    //模糊查询
  queryShift = (e:any) => {
    const inputVal = e.target.value.trim();
    getStaff(inputVal).data.then((res:any) => {
        if (res) {
            this.setState({ 
                staffListA: res.content,
                staffList: res.content,
            });
        }
    })
  }

  //选中人员
  selectApprover = (data: any) => {
    const selectedId = this.state.selectedId;
    const selectedList:any = this.state.selectedList;
    if (!selectedId.includes(data.staffId)) {
        selectedId.push(data.staffId);
        selectedList.push(data);
        this.setState({
            selectedId
        });
        this.props.returnData(selectedId,selectedList);
    } else {
        message.warning('该员工已被添加!');
    }
  };
  //打开自定义组设置
  showModal = () => {
    this.setState({
      visible: true
    });
  };
  //更新常用审批人
  updateApprover = (data:any) => {
    const { initApprover } = this.state;
    if (initApprover.length>0) {
      const ids:any[] = [];
      for(const approve of initApprover) {
        ids.push(approve.staffId);
      }
      if (ids.indexOf(data.staffId)===-1) {
        initApprover.push(data);
      }
    } else {
      initApprover.push(data);
    }
    this.setState({initApprover});
    saveUserConfig(
      'staffSelectorHistoryList',{
        staffSelectorHistoryList: initApprover
    });
  }
  //选中自定义组添加到审批人中
  selectTheGroup = (i: number) => {
    const list = this.state.groupList[i].list;
    list.map((staff: any) => {
      if (!this.state.selectedId.includes(staff.staffId)) {
        this.selectApprover(staff);
      }
    });
  };
  //保存自定义组
  handleOk = () => {
    this.setState({
      confirmLoading: true
    });
    saveUserConfig(
      'staffSelectorGroupList',{
      staffSelectorGroupList: this.state.groupList
    }).data.then((res: any) => {
      if (res) {
        this.setState({
          visible: false,
          confirmLoading: false
        });
      } else {
        message.error(res.errorMessage);
      }
    });
  };
  handleCancel = () => {
    this.setState({
      visible: false
    });
  };
  //删除自定义组的审批人
  delApprover = (i:number) => {
    const groupList = this.state.groupList;
    const data = groupList[this.state.currentIndex].list;
    data.splice(i, 1);
    this.setState({ groupList });
  }
  //删除自定义组
  delGroup = (i: number) => {
    const groupList = this.state.groupList;
    groupList.splice(i, 1);
    if (this.state.currentIndex === i) {
      this.setState({ currentIndex: 0 });
    }
    this.setState({ groupList }, () => {
      console.log(this.state.groupList);
    });
  };
  //下移
  downData = (type: string, i: number) => {
    const data =
      type === "groupList"
        ? this.state[type]
        : this.state.groupList[this.state.currentIndex].list;
    if (i < data.length - 1) {
      const temp = data[i + 1];
      data[i + 1] = data[i];
      data[i] = temp;
    }
    if (type === "groupList") {
      this.setState({ groupList: data });
    } else {
      const groupList = this.state.groupList;
      groupList[this.state.currentIndex].list = data;
      this.setState({ groupList });
    }
  };
  //上移
  upData = (type: string, i: number) => {
    const data =
      type === "groupList"
        ? this.state[type]
        : this.state.groupList[this.state.currentIndex].list;
    if (i > 0 && data.length > 1) {
      const temp = data[i - 1];
      data[i - 1] = data[i];
      data[i] = temp;
    }
    if (type === "groupList") {
      this.setState({ groupList: data });
    } else {
      const groupList = this.state.groupList;
      groupList[this.state.currentIndex].list = data;
      this.setState({ groupList });
    }
  };
  //新增组
  addGroup = () => {
    const data = this.state.groupList;
    data.push({
      key: data.length + 1 + "1",
      checked: null,
      name: "",
      list: []
    });
    this.setState({ groupList: data });
  }
  onCellChange = (obj: any, dataIndex: any) => {
    return (value: any) => {
      const dataSource = [...this.state.groupList];
      const target = dataSource.find(item => JSON.stringify(item) === JSON.stringify(obj));
      if (target) {
        target[dataIndex] = value;
        this.setState({ dataSource });
      }
    };
  };
  //切换选中组
  changeGroup = (e: any) => {
    if (e.target.checked) {
      this.setState({ currentIndex: e.target["data-index"] });
    }
  };
  //组中新增人
  addStaffAtGroup = (id: any, staff: any) => {
    const groupList = this.state.groupList;
    const list = groupList[this.state.currentIndex].list?groupList[this.state.currentIndex].list:[];
    const idsList:any[] = 
    list.reduce((prev:any,next:any) => {
      prev.push(next.staffId)
      return prev
    },[]);
    if (staff) {
      if (idsList.indexOf(staff.staffId)===-1) {
        groupList[this.state.currentIndex].list.push(staff);
      } else {
        message.warning('该员工已存在')
      }
    }
    this.setState({ groupList });
  };

    

    public render() {
        others(IrsStaffSelector.defaultProps, this.props);
        const columns = [
            {
              title: "选中",
              dataIndex: "checked",
              render: (text: any, record: any, i:number) => (
                <Radio 
                  checked={i === this.state.currentIndex}
                  defaultChecked={i === this.state.currentIndex}
                  data-index={i}
                  onChange={this.changeGroup}
                />
              )
            },
            {
              title: "组名",
              dataIndex: "name",
              render: (text:string, record:any,i:any) => (
                <IrsEditableCell 
                  value={ this.state.groupList[i].name } 
                  onChange={this.onCellChange(record, 'name')}
                />
              )
            },
            {
              title: "操作",
              dataIndex: "operate",
              render: (text: any, record: any, index: number) => (
                <span>
                  <a href="javascript:;" onClick={this.upData.bind(this,'groupList',index)}>
                    <img
                      src={require(`./images/icon/up${index === 0
                        ? "_disabled"
                        : ""}.png`)}
                      alt=""
                    />
                  </a>
                  <a href="javascript:;" onClick={this.downData.bind(this,'groupList',index)}>
                    <img
                      src={require(`./images/icon/down${index ===
                      this.state.groupList.length - 1
                        ? "_disabled"
                        : ""}.png`)}
                      alt=""
                    />
                  </a>
                  <a href="javascript:;">
                    <span className="del" onClick={this.delGroup.bind(this,index)}>删除</span>
                  </a>
                </span>
              )
            }
        ];
        const columns1 = [
            {
              key: 1,
              title: "姓名",
              dataIndex: "staffName"
            },
            {
              key: 2,
              title: "工号",
              dataIndex: "groupName"
            },
            {
              key: 3,
              title: "部门",
              dataIndex: "departmentName"
            },
            {
              title: "操作",
              dataIndex: "operate",
              render: (text: any, record: any, index: number) => (
                <span>
                  <a href="javascript:;" onClick={this.upData.bind(this,'data',index)}>
                    <img
                      src={require(`./images/icon/up${index === 0
                        ? "_disabled"
                        : ""}.png`)}
                      alt=""
                    />
                  </a>
                  <a href="javascript:;" onClick={this.downData.bind(this,'data',index)}>
                    <img
                      src={require(`./images/icon/down${index ===
                        this.state.groupList.length - 1
                        ? "_disabled"
                        : ""}.png`)}
                      alt=""
                    />
                  </a>
                  <a href="javascript:;">
                    <span className="del" onClick={this.delApprover.bind(this,index)}>删除</span>
                  </a>
                </span>
              )
            }
        ];
        return(
            <div className="box">
                <div className="left" style={{width:this.props.selectWidth}}>
                    <div className="box">{}</div>
                    <Input placeholder="请输入员工姓名查询" name="staffName"  autoComplete="off"
                    onChange={this.queryShift} onPressEnter={this.queryShift}/>
                    <div className="staff-list">
                        <span className="noMessage"
                        style={{display:this.state.staffList.length === 0 ?'block':'none'}}>未查找到数据</span>
                        {this.state.staffListA.map((item: any, i: number) => {
                            return (
                            <div
                                key={i}
                                className={this.state.selectedId.findIndex((value:any) => value===item.staffId)>-1?'item active':'item'}
                                onClick={this.selectApprover.bind(this, item)}
                            >
                                <div className="name">
                                    {item.staffName}
                                    {/* <img className="icon" src={require('../assets/images/icon/true.png')} alt=""/> */}
                                </div>
                                <div className="depart">
                                <span className="department" title={item.departmentName}>部门：{item.departmentName}</span>
                                <span className="position">职位：{item.positionName}</span>
                                </div>
                            </div>
                            )
                        })}
                    </div>
                </div>
                <div className="right">
                    <div className="set-title">
                        自定义组
                        <Icon type="setting" className="set" onClick={this.showModal} />
                    </div>
                    {this.state.groupList.length > 0 ? (
                    <Tree>
                            {this.state.groupList.map((item: any, i: number) => (
                            <TreeNode
                                selectable={false}
                                title={
                                <span onClick={this.selectTheGroup.bind(this, i)}>
                                    {item.name}({item.list.length})
                                </span>
                                }
                                key={`${i}`}
                            >
                                {item.list.map((staff: any, j: number) => (
                                <TreeNode
                                    selectable={false}
                                    title={
                                    <span
                                        onClick={this.selectApprover.bind(this, staff,false)}
                                    >
                                        {staff.staffName}
                                    </span>
                                    }
                                    key={`${i}-${j}`}
                                />
                                ))}
                            </TreeNode>
                            ))}
                        </Tree>
                        ) : (
                        ""
                        )}
                </div>
                <Modal
                    title="员工组管理"
                    width="936px"
                    bodyStyle={{ height: "340px" }}
                    visible={this.state.visible}
                    onOk={this.handleOk}
                    confirmLoading={this.state.confirmLoading}
                    onCancel={this.handleCancel}
                    >
                    <div className="set-approver-group">
                        <div className="left-content">
                        <div className="table-header">
                            <span className="title">已有组：</span>
                            <Button type="primary" onClick={this.addGroup}>新增组</Button>
                        </div>
                        <Table style={{maxHeight:'260px',overflow:'auto'}}
                            columns={columns}
                            dataSource={ this.state.groupList}
                            size="small"
                            pagination={false}
                        />
                        </div>
                        <div className="right-content">
                        <div className="table-header">
                            <span className="title">已有组：</span>
                            <IrsChooseApprover onChange={this.addStaffAtGroup} />
                        </div>           
                        <Table style={{maxHeight:'230px',overflow:'auto'}}
                            columns={columns1}
                            dataSource={
                            this.state.groupList.length > 0
                                ? this.state.groupList[this.state.currentIndex].list
                                : []
                            }
                            size="small"
                            pagination={false}
                        />
                        </div>
                    </div>
                </Modal>
            </div>
        )
    }
}

export default IrsStaffSelector