/**
 * The only true button.
 * @date 2018.12.8
 * @version 0.0.1
 * @author Danae.Zhang
 */
import * as React from 'react';
import * as module from './module';
import { Transfer } from 'antd'
import { others } from 'fit-transmit-transparently';
import { TransferDirection } from 'antd/lib/transfer';
class IrsTransfer extends React.Component<module.IPropsInterface, any> {
    static defaultProps = {

    }

    constructor(props: module.IPropsInterface) {
        super(props);
    }

    handleChange = (targetKeys: string[], direction: string, moveKeys: any) => {
        if(this.props.onChange) {
            this.props.onChange(targetKeys, direction, moveKeys);
        }
    }

    handleSelectChange = (sourceSelectedKeys: string[], targetSelectedKeys: string[]) => {
        if(this.props.onSelectChange) {
            this.props.onSelectChange(sourceSelectedKeys, targetSelectedKeys)
        }
    }

    handleScroll = (direction: TransferDirection, e: React.SyntheticEvent<HTMLDivElement>) => {
        if(this.props.onScroll){
            this.props.onScroll(direction, e)
        }
    }

    handleSearch = (direction: TransferDirection, e: React.ChangeEvent<HTMLInputElement>) => {
        if(this.props.onSearchChange){
            this.props.onSearchChange(direction, e)
        }
    }


    render() {
        others(IrsTransfer.defaultProps, this.props);
        return (
            <Transfer
                {...this.props}
                dataSource={this.props.dataSource}
                render={this.props.render}
                titles={this.props.titles}
                onChange={this.handleChange}
                onSelectChange={this.handleSelectChange}
                onScroll={this.handleScroll}
                onSearchChange={this.handleSearch}
            />
        )
    }
}

export default IrsTransfer;
