
export interface IPropsInterface {
    /** 默认属性 */
    props: any,

    /** 警告提示内容 */
    message: React.ReactNode,

    /** 指定警告提示的样式，有四种选择 success、info、warning、error */
    type?: 'success' | 'info' | 'warning' | 'error';

    /** 是否显示辅助图标 */
    showIcon?: boolean;

    /** 警告提示的辅助性文字介绍 */
    description?: React.ReactNode;

    /** 自定义关闭按钮 */
    closeText?: React.ReactNode;

    /** 默认不显示关闭按钮 */
    closable?: boolean;

    /** 关闭时触发的回调函数 */
    onClose?: React.MouseEventHandler<HTMLAnchorElement>;

    /** 按钮类型 */
    iconType?: string;


    /** style样式 */
    style?: React.CSSProperties;

    /** classname */
    className?: string;

    id?: string;

    /** 自定义图标，showIcon 为 true 时有效 */
    icon?: React.ReactNode;

}

