/**
 * The only true autocomplete.
 * @date 2018.12.22
 * @version 0.0.1
 * @author Amber.Yang
 */
import * as React from "react";
import * as module from "./module";
import { AutoComplete } from "antd";
import { SelectValue } from 'antd/lib/select';

import IrsIcon from "../../irs-icon";
import IrsInput from "../../irs-input";
import IrsButton from "../../irs-button";
import { others } from "fit-transmit-transparently";
import  "../src/style.less";

class IrsAutocomplete extends React.Component<module.IPropsInterface, any> {
  static defaultProps = {
    isSearch:false,
    isBtnIcon:false,
    placeholder:"请输入",
    optionLabelProp: "children"
  };
  onSelect = (value: SelectValue, option: object) => {
    if(this.props.onSelect) {
      this.props.onSelect(value, option);
    }
  }
  onSearch = (value:string) => {
    if(this.props.onSearch) {
       this.props.onSearch(value);
    }
  }
  onChange = (value: SelectValue) => {
    if(this.props.onChange){
      this.props.onChange(value);
    }
  }
  render() {
    others(IrsAutocomplete.defaultProps, this.props);
    if (!this.props.isSearch){
        return (
        <AutoComplete      
        dataSource={this.props.dataSource}
        backfill={this.props.backfill}
        onSelect={this.onSelect}
        onSearch={this.onSearch}
        onChange={this.onChange}  
        className={this.props.className}   
        placeholder={this.props.placeholder} 
        />
            );
    }
    return (
        <AutoComplete     
        dataSource={this.props.dataSource}
        backfill={this.props.backfill}
        onSelect={this.onSelect}
        onSearch={this.onSearch}
        onChange={this.onChange}  
        className={this.props.isBtnIcon ? ("global-search " + this.props.className) : this.props.className}  
        >
          {
            !this.props.isBtnIcon ? <IrsInput type="text" placeholder={this.props.placeholder}  suffix={<IrsIcon  icon={this.props.iconType} />} /> : 
            <IrsInput type="text"  suffix={
              (
                <IrsButton  type="primary" sizeOwn="styleLarge" className="search-btn"  >
                  <IrsIcon icon={this.props.iconType} />
                </IrsButton>
              )
              } />
          }
        </AutoComplete>
    )   
  }
}

export default IrsAutocomplete;
