import { SelectValue,OptionProps,OptGroupProps } from 'antd/lib/select';
export interface IdataSourceItemObject {
    value: string;
    text: string;
}

export declare type DataSourceItemType = string | IdataSourceItemObject | React.ReactElement<OptionProps> | React.ReactElement<OptGroupProps>;

export interface IPropsInterface  {
    /** 类名 */
    className?: string;
    /** 是否带搜索 */
    isSearch?: boolean;
    /** 搜索，是否带button的自定义图标 */
    isBtnIcon?: boolean;
    /** 图标类型 */
    iconType?: string;
    /** 自动完成的数据源数组 */
    dataSource?: DataSourceItemType[];
   /** 使用键盘选择选项的时候把选中项回填到输入框中 */
    backfill?: boolean;
   /** 回填到选择框的 Option 的属性值，默认是 Option 的子元素 */
    optionLabelProp?: string;
    /** 提示内容 */
    placeholder?: string;
    /** 选中 option，或 input 的 value 变化时，调用此函数 */
    onChange?: (value: SelectValue) => void;
    /** 被选中时调用，参数为选中项的 value 值 */
    onSelect?: (value: SelectValue, option: object) => any;
    /** 搜索补全项的时候调用 */
    onSearch?: (value: string) => any;
}

