### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.22 | V0.0.1 | Amber | 新增AutoComplete组件

<br><br/>
### 2.安装方式
<code>
npm install irs-autocomplete
</code>

<br><br/><br><br/>
### 3. 调用方式


#### 基本使用,通过 dataSource 设置自动完成的数据源
```jsx
class IrsAutocompleteDemo extends React.Component {
    constructor() {
    super()
    this.state = {
        dataSource:[],
        totalData:[ 
                {name:"name1",age:18,id:"1"},
                {name:"name2",age:19,id:"2"},
                {name:"name3",age:20,id:"3"},
                {name:"name4",age:20,id:"4"},
            ]
    }
    this.onSelect = this.onSelect.bind(this)
    this.onSearch = this.onSearch.bind(this)
    }
    onSelect(value){
    console.log("onSelect" + value);
    }
    onSearch(value){
        const arr = []
        this.state.totalData.map((item) => {
            if (item.name.indexOf(value) !== -1) {
                arr.push(item.name)
            }
        })
        this.setState({
          dataSource: arr
        });
    }
    render() {
        return (
            <IrsAutocomplete
                dataSource = {this.state.dataSource}
                onSelect={this.onSelect}
                onSearch={this.onSearch}
            />     
        )
    }
}
;<IrsAutocompleteDemo />
```

#### 搜索，自定义图标
```jsx
class IrsAutocompleteDemo extends React.Component {
    constructor() {
    super()
    this.state = {
        dataSource:[],
        totalData:[ 
            {name:"name1",age:18,id:"1"},
            {name:"name2",age:19,id:"2"},
            {name:"name3",age:20,id:"3"},
            {name:"name4",age:20,id:"4"},
        ],
        isSearch:true,
        iconType:"icon-approval",
        placeholder:"请输入自定义内容"

    }
    this.onSelect = this.onSelect.bind(this)
    this.onSearch = this.onSearch.bind(this)
    }
    onSelect(value){
    console.log("onSelect" + value);
    }
    onSearch(value){
        const arr = []
        this.state.totalData.map((item) => {
            if (item.name.indexOf(value) !== -1) {
                arr.push(item.name)
            }
        })
         this.setState({
          dataSource: arr
        });
    }
    render() {
        return (
            <IrsAutocomplete
            dataSource = {this.state.dataSource}
            onSelect={this.onSelect}
            onSearch={this.onSearch}
            isSearch={this.state.isSearch}
            iconType={this.state.iconType}
            placeholder={this.state.placeholder}
            />     
        )
    }
}
;<IrsAutocompleteDemo />
```

#### 搜索，带button的自定义图标
```jsx
class IrsAutocompleteDemo extends React.Component {
    constructor() {
    super()
    this.state = {
        dataSource:[],
        totalData:[ 
            {name:"name1",age:18,id:"1"},
            {name:"name2",age:19,id:"2"},
            {name:"name3",age:20,id:"3"},
            {name:"name4",age:20,id:"4"},
        ],
        isSearch:true,
        isBtnIcon:true,
        iconType:"icon-approval"
    }
    this.onSelect = this.onSelect.bind(this)
    this.onSearch = this.onSearch.bind(this)
    }
   
    onSelect(value){
    console.log("onSelect" + value);
    }
    onSearch(value){
        const arr = []
        this.state.totalData.map((item) => {
            if (item.name.indexOf(value) !== -1) {
                arr.push(item.name)
            }
        })
         this.setState({
          dataSource: arr
        });
    }
    render() {
        return (
            <IrsAutocomplete
            dataSource = {this.state.dataSource}
            onSelect={this.onSelect}
            onSearch={this.onSearch}
            isSearch={this.state.isSearch}
            isBtnIcon={this.state.isBtnIcon}
            iconType={this.state.iconType}
            />     
        )
    }
}
;<IrsAutocompleteDemo />
```