
import { BadgeProps } from 'antd/lib/badge';

export interface IPropsInterface extends BadgeProps {
    /** 展示的数字,大于 overflowCount 时显示为 ${overflowCount}+,为 0 时隐藏 */
    count?: number | string | null;

    /** 不展示数字,只有一个小红点 */
    dot?: boolean;

    /** 展示封顶的数字值 */
    overflowCount?: number;

    /** 设置状态点的位置偏移,格式为 [x, y] */
    offset?: [number | string, number | string];

    /** 当数值为 0 时,是否展示 Badge */
    showZero?: boolean;

    /** 设置 Badge 为状态点 */
    status?: 'success' | 'processing' | 'default' | 'error' | 'warning';

    /** 在设置了 status 的前提下有效，设置状态点的文本 */
    text?: string;

    /** 设置鼠标放在状态点上时显示的文字 */
    title?: string;

    className?: string;

    style?: React.CSSProperties;

    id?: any;

    children?: any;
}