/**
 * The only true button.
 * @date 2018.12.01
 * @version 0.0.1
 * @author Reci.Lu
 */
import * as React from 'react';
import * as module from './module';
import { Button } from 'antd';
import { others } from 'fit-transmit-transparently';

class IrsButton extends React.Component<module.IPropsInterface, any> {
    static defaultProps = {
        type: "primary",
        // htmlType: "button",
        disabled: false,
        sizeOwn: 'styleNormal',
        loading: false,
        ghost: false,
        block: false
    }



    constructor(props: module.IPropsInterface) {
        super(props);
        this.handleClick = this.handleClick.bind(this);
    }

    handleClick = (event: React.MouseEvent<any>) => {
        if ((this.props.disabled || this.props.loading) && this.props.onClick) {
            return;
        };
        this.props.onClick(event);
    }


    render() {
        others(IrsButton.defaultProps, this.props);
        //自定义按钮样式大小
        let className = ''
        if (this.props.sizeOwn === 'styleNormal') {
            className = 'styleNormal, ' + this.props.className
        } else if (this.props.sizeOwn === 'styleSmall') {
            className = 'styleSmall, ' + this.props.className
        } else {
            className = 'styleLarge, ' + this.props.className
        }

        return (
            <Button
                {...this.props}
                type={this.props.type}
                className={className}
                style={this.props.style}
                disabled={this.props.disabled}
                loading={this.props.loading}
                onClick={this.handleClick}>
                {/* {this.props.text} */}
                {
                    this.props.children
                }
            </Button>
        )
    }
}

export default IrsButton;
