import * as React from 'react';
import { } from 'antd/lib/button'

export declare type ButtonType = 'default' | 'primary' | 'ghost' | 'dashed' | 'danger';
export declare type ButtonShape = 'circle' | 'circle-outline';

export interface IPropsInterface {
    /** 点击跳转的地址，指定此属性 button 的行为和 a 链接一致 */
    href?: string,

    /** 设置 button 原生的 type 值 */
    // htmlType?: string,

    /** 设置按钮载入状态 */
    loading?: boolean | {
        delay?: number;
    };

    /** 按钮失效状态 */
    disabled?: boolean,

    /** 相当于 a 链接的 target 属性，href 存在时生效 */
    target?: string,


    /** 左侧icon */
    addonLeft?: any,

    /** 右侧icon */
    addonRight?: any,

    /** 数据源接口 */
    propData?: any,

    /** 按钮类型 */
    type?: ButtonType;

    /** 按钮大小 */
    // size?: 'small' | 'default' | 'large';

    /** 按钮大小：正常、大、小 */
    sizeOwn?: "styleNormal" | "styleSmall" | "styleLarge",



    /** 设置按钮的图标类型 */
    icon?: string;

    /** 设置按钮形状,可选值为 circle 或者不设 */
    shape?: ButtonShape;

    prefixCls?: string;

    className?: string;

    /** 幽灵属性，使按钮背景透明 */
    ghost?: boolean;


    /** 将按钮宽度调整为其父宽度的选项 */
    block?: boolean;

    style?: any;

    id?: any;

    children?: any;

    /** click 事件的 handler */
    onClick?: (event?: React.MouseEvent<any>) => void

}

