/**
 * The only true datePicker.
 * @date 2018.11.27
 * @version 0.0.1
 * @author Gail.Chen
 */
import * as React from 'react';
// import * as classNames from 'classnames';
import * as module from './module';
import * as moment from "moment";
import { Calendar } from 'antd';
import { others } from 'fit-transmit-transparently';

export declare type CalendarMode = 'month' | 'year';
class IrsCalendar extends React.Component<module.IPropsInterface, any> {
    static defaultProps = {
    }
    constructor(props: module.IPropsInterface) {
        super(props);
    }
    handleOpenChange = (date?: moment.Moment, mode?: CalendarMode) => {
        if (this.props.onPanelChange) {
            this.props.onPanelChange(date, mode);
        }
    }
    handleDateCellRender = (date: moment.Moment) => {
        return this.props.dateCellRender ? this.props.dateCellRender(date) : undefined;
    }
    handleMonthCellRender = (date: moment.Moment) => {
        return this.props.monthCellRender ? this.props.monthCellRender(date) : undefined;
    }
    handleOnSelect = (date?: moment.Moment) => {
        if (this.props.onSelect) {
            this.props.onSelect(date);
        }
    }
    handleOnChange = (date?: moment.Moment) => {
        if (this.props.onChange) {
            this.props.onChange(date);
        }
    }
    render() {
        others(IrsCalendar.defaultProps, this.props);
        const { 
            handleOpenChange,
            handleDateCellRender,
            handleMonthCellRender,
            handleOnSelect,
            handleOnChange } = this;
        return (
            <Calendar 
                {...this.props}
                onPanelChange={handleOpenChange} 
                dateCellRender={handleDateCellRender}
                monthCellRender={handleMonthCellRender}
                onSelect={handleOnSelect}
                onChange={handleOnChange}
                />
                
        )
    }
} 

export default IrsCalendar;
