// import { CalendarProps } from 'antd/lib/calendar/index';
import * as moment from 'moment';
export declare type CalendarMode = 'month' | 'year';

export interface IPropsInterface {
    /** 自定义class名称 */
    className?: string;
    /** 展示日期 */
    value?: moment.Moment;
    /** 默认展示的日期 */
    defaultValue?: moment.Moment;
    /** 初始模式，month/year */
    mode?: CalendarMode;
    /** 是否全屏显示 */
    fullscreen?: boolean;
    /** 自定义渲染日期单元格，返回内容会被追加到单元格 */
    dateCellRender?: (date: moment.Moment) => React.ReactNode;
    /** 自定义渲染月单元格，返回内容会被追加到单元格 */
    monthCellRender?: (date: moment.Moment) => React.ReactNode;
    /** 自定义渲染日期单元格，返回内容覆盖单元格 */
    dateFullCellRender?: (date: moment.Moment) => React.ReactNode;
    /** 自定义渲染月单元格，返回内容覆盖单元格 */
    monthFullCellRender?: (date: moment.Moment) => React.ReactNode;
    /** 国际化配置 */
    locale?: any;
    /** 自定义样式 */
    style?: React.CSSProperties;
    /** 日期面板变化回调 */
    onPanelChange?: (date?: moment.Moment, mode?: CalendarMode) => void;
    /** 点击选择日期回调 */
    onSelect?: (date?: moment.Moment) => void;
    /** 日期变化回调 */
    onChange?: (date?: moment.Moment) => void;
    /** 不可选择的日期 */
    disabledDate?: (current: moment.Moment) => boolean;
    /** 设置可以显示的日期 */
    validRange?: [moment.Moment, moment.Moment];
}

