### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.01 | V0.0.1 | Gail | 新增Calendar组件

<br><br/>
### 2.安装方式
<code>
npm install irs-calendar
</code>

<br><br/><br><br/>
### 3. 调用方式
#### 基础组件格式
```jsx
  <div className="App">
     <IrsCalendar />
  </div>
```
#### 一个复杂的应用示例，用 dateCellRender 和 monthCellRender 函数来自定义需要渲染的数据
```jsx
  getListData = (value) => {
    let listData;
    switch (value.date()) {
      case 8:
        listData = [
          { content: 'event1' },
          { content: 'event2' },
        ]; break;
      case 10:
        listData = [
          { content: 'event1.' },
          { content: 'event2.' },
          { content: 'event3.' },
        ]; break;
      case 15:
        listData = [
          { content: 'event1' },
          { content: 'event2' },
          { content: 'event3' },
          { content: 'event4' },
          { content: 'event5' },
          { content: 'event6' },
        ]; break;
      default:
    }
    return listData || [];
  }
  dateCellRender = (value) => {
    const listData = getListData(value);
    return (
      <ul className="events">
        {
          listData.map(item => (
            <li key={item.content}>
              <span>{item.content}</span>
            </li>
          ))
        }
      </ul>
    );
  }
  getMonthData = (value) => {
    if (value.month() === 8) {
      return 1394;
    }
  }

  monthCellRender = (value) => {
    const num = getMonthData(value);
    return num ? (
      <div className="notes-month">
        <section>{num}</section>
        <span>Backlog number</span>
      </div>
    ) : null;
  }
  <div className="App">
      <IrsCalendar dateCellRender={dateCellRender} monthCellRender={monthCellRender} />
  </div>
```

#### 卡片模式，用于嵌套在空间有限的容器中。
```jsx
  onPanelChange = (value, mode) => {
    // console.log(value, mode);
  }
  <div className="App">
      <IrsRow style={{ width: 300, border: '1px solid #d9d9d9', borderRadius: 4 }}>
        <IrsCol>
          <IrsCalendar fullscreen={false} onPanelChange={onPanelChange} />
        </IrsCol>
      </IrsRow>
  </div>
```

#### 一个通用的日历面板，支持年/月切换。
```jsx
const moment = require('../../../../node_modules/moment');
class IrsCalendarDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        selectedValue: new Date(),
        value: new Date()
    }
    this.onPanelChange = this.onPanelChange.bind(this);
    this.onSelect = this.onSelect.bind(this);
  }

  onSelect(value) {
    this.setState({
      selectedValue: value,
      value
    })
  }
  onPanelChange(value) {
    this.setState({value})
  }
  render() {
    return (
      <div className="App">
          <IrsRow>
            <IrsCol>
              {`You selected date: ${moment(this.state.selectedValue).format('YYYY-MM-DD')}`}
            </IrsCol>
          </IrsRow>
          <IrsRow>
            <IrsCol>
              <IrsCalendar value={moment(this.state.value)} onSelect={this.onSelect} onPanelChange={this.onPanelChange} />
            </IrsCol>
          </IrsRow>
      </div>
    )
  }
}
;<IrsCalendarDemo />
```








