/**
 * The only true tab.
 * @date 2018.12.22
 * @version 0.0.1
 * @author Jita.Song
 */
import * as React from 'react';
import * as module from './module';
import { others } from 'fit-transmit-transparently';
import { Card } from 'antd';
import './style.less'; 

class IrsCard extends React.Component<module.IPropsInterface,any>{
    static defaultProps = {
         style:{width:300},
         bordered:true,
         isMate: false,
         mateProps: {
            avatar:false,
            className:false,
            description:false,
            style:false,
            title:false
         }
    }

    constructor(props:module.IPropsInterface){
        super(props)
    }

    render(){
        others(IrsCard.defaultProps, this.props);

        return(
            <Card
                className={this.props.className}
                style={this.props.style}
                title={this.props.title}
                cover={this.props.cover}
                bordered={this.props.bordered} 
                extra={this.props.extra}
                actions={this.props.actions}
                tabList={this.props.tabList}
                activeTabKey={this.props.activeTabKey}
                onTabChange={this.props.onTabChange}
                headStyle={this.props.headStyle}
                bodyStyle={this.props.bodyStyle}
                hoverable={this.props.hoverable}
                loading={this.props.loading}
            >
                {
                    this.props.children
                }
            </Card>
        )
    }
}

export default IrsCard;