import { ReactNode } from "react";

export interface ICardTabListType {
    key: string;
    tab: React.ReactNode;
    disabled?: boolean;
}

export interface IMateInterface {
    avatar?: ReactNode;
    className?:string;
    description?:ReactNode;
    style?:object;
    title?:ReactNode;	
}

export interface IPropsInterface{
    /** 自定义容器类名 */
    className?:string

    /** 卡片的样式 */
    style?:object

    /** 卡片标题 */
    title?:string|ReactNode

    /** 是否有边框 */
    bordered?:boolean
    
    /** 卡片封面 */
    cover?:ReactNode

    /** 卡片右上角的操作区域 */
    extra?:string|ReactNode

    /** 卡片操作组，位置在卡片底部 */
    actions?:ReactNode[];

    /** 页签标题列表 */
    tabList?: ICardTabListType[];

    /** 当前激活页签的 key */
    activeTabKey?:string

    /** 页签切换的回调 */
    onTabChange?:(key: string) => void;

    /** 自定义标题区域样式 */
    headStyle?:React.CSSProperties

    /** 内容区域自定义样式 */
    bodyStyle?:React.CSSProperties

    /** 鼠标移过时可浮起 */
    hoverable?:boolean

    /** 当卡片内容还在加载中时，可以用 loading 展示一个占位 */
    loading?:boolean
}
