### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.15 | V0.0.1 | Jita | 新增card组件

<br><br/>
### 2.安装方式
<code>
npm install irs-card
</code>

<br><br/><br><br/>
### 3. 调用方式
#### 基础组件格式:包含标题、内容、操作区域。
```jsx
  <div>
    <IrsCard
      style={{width:300}}
      title="Card title"
      extra={<a href="#">More</a>}
    >
      <p>Card content</p>
      <p>Card content</p>
      <p>Card content</p>
    </IrsCard>
  </div>
```

#### 带页签的卡片。
```jsx
  const tabList = [{
    key: 'tab1',
    tab: 'tab1',
  }, {
    key: 'tab2',
    tab: 'tab2',
  }];

  const contentList = {
    tab1: <p>content1</p>,
    tab2: <p>content2</p>,
  };

  const tabListNoTitle = [{
    key: 'article',
    tab: 'article',
  }, {
    key: 'app',
    tab: 'app',
  }, {
    key: 'project',
    tab: 'project',
  }];

  const contentListNoTitle = {
    article: <p>article content</p>,
    app: <p>app content</p>,
    project: <p>project content</p>,
  };

  class TabsCard extends React.Component {
    constructor(){
      super()
      this.state = {
        key: 'tab1',
        noTitleKey: 'app',
      }
    }

    onTabChange(key, type){
      this.setState({ [type]: key });
    }

    render(){
      return(
        <div>
          <IrsCard
            style={{ width: '100%' }}
            title="Card title"
            extra={<a href="#">More</a>}
            tabList={tabList}
            activeTabKey={this.state.key}
            onTabChange={(key) => { this.onTabChange(key,'key');}}
          >
            {contentList[this.state.key]}
          </IrsCard>
          <br /><br />
          <IrsCard
            style={{ width: '100%' }}
            tabList={tabListNoTitle}
            activeTabKey={this.state.noTitleKey}
            onTabChange={(key) => { this.onTabChange(key,'noTitleKey');}}
          >
            {contentListNoTitle[this.state.noTitleKey]}
          </IrsCard>
        </div>
      )
    }
  };<TabsCard />
```
#### 支持右上角,封面,内容区,底部操作区可自定义
```jsx

  class MessageCard extends React.Component{
    render(){
      return(
           <IrsCard
              style={{ width: 300 }}
              extra={<a href="#">More</a>}
              cover={<img className="img1" alt="example" src="https://gw.alipayobjects.com/zos/rmsportal/JiqGstEfoWAOHiTxclqi.png" />}
              actions={[<a href="#">查看</a>,<a href="#">编辑</a>]}
           >
            <p>Card content</p>
            <p>Card content</p>
            <p>Card content</p>
           </IrsCard>
      )
    }
  };<MessageCard/>
```




