/**
 * The only true checkbox.
 * @date 2018.11.27
 * @version 0.0.1
 * @author Rebecca.Zhang
 */

import * as module from './module';
import * as React from 'react';
import { others } from 'fit-transmit-transparently';
import { Checkbox } from 'antd';

const CheckboxGroup = Checkbox.Group;

class IrsCheckbox extends React.Component<module.IPropsInterface, any> {
    static defaultProps = {
        checked: false,
        defaultChecked: false,
        disabled: false,
        indeterminate: false,
        isCompose: false,
        composeOpts: [] as any,
        checkedOpts: [] as any
    }
    
    constructor(props: module.IPropsInterface) {
        super(props);
    }

    handleChange = (event: any) => {
        if (!this.props.onChange) {
            return;
        };
        this.props.onChange(event);
    }

    handleGroupChange = (event: any) => {
        if (!this.props.onCheckBoxGroupChange) {
            return;
        };
        this.props.onCheckBoxGroupChange(event);
    }

    render() {
        others(IrsCheckbox.defaultProps, this.props);
        if (!this.props.isCompose) {
            if (this.props.checkedCompose === undefined) {
                return (
                    <Checkbox
                        defaultChecked={this.props.defaultChecked}
                        disabled={this.props.disabled}
                        onChange={this.handleChange}
                    >{this.props.checkText}</Checkbox>
                )
            } else {
                return (
                    <Checkbox
                        defaultChecked={this.props.defaultChecked}
                        disabled={this.props.disabled}
                        checked={this.props.checkedCompose}
                        onChange={this.handleChange}
                    >{this.props.checkText}</Checkbox>
                )
            }

        } else {
            return (
                <CheckboxGroup options={this.props.composeOpts} value={this.props.checkedOpts} onChange={this.handleGroupChange} />
            )
        }
    }
}

export default IrsCheckbox