### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.11.21 | V0.0.1 | Rebecca | 新增checkbox

<br><br/>
### 2.安装方式
<code>
npm install irs-checkbox
</code>

<br><br/><br><br/>
### 3. 调用方式

#### 基本用法 简单的 checkbox
```jsx
checkboxChangeHandle = (e) => {
   console.log(e.target.checked);
}
;<IrsRow type="flex" gutter="6">
    <IrsCol span="6">
       <IrsCheckbox onChange={checkboxChangeHandle} checkText="姓名" />
    </IrsCol>
    <IrsCol span="6">
       <IrsCheckbox disabled={true} checkText="年龄" />
    </IrsCol>
</IrsRow>
```
#### 多级checkbox，实现全选效果
```jsx
const plainOptions = ['姓名', '性别', '国籍']; 
class IrsGroupCheckBoxDemo extends React.Component {
  constructor() {
    super();
    this.state = {
      checkedList: [],
      indeterminate: true,
      checkAll: false
    }
    this.onCheckAllChange = this.onCheckAllChange.bind(this);
    this.onGroupCheckChange = this.onGroupCheckChange.bind(this);
  }

  onCheckAllChange(e) {
      this.setState({
        checkedList: e.target.checked ? plainOptions : [],
        indeterminate: false,
        checkAll: e.target.checked,
      });
  }

  onGroupCheckChange(checkedList) {
     this.setState({
      checkedList,
      indeterminate: !!checkedList.length && (checkedList.length < plainOptions.length),
      checkAll: checkedList.length === plainOptions.length,
    });
  }

  render() {
    return (
     <div>
        <IrsRow type="flex" gutter="6">
          <IrsCol span="8">
              <IrsCheckbox onChange={this.onCheckAllChange} indeterminate={this.state.indeterminate} checkText="全选"  checkedCompose={this.state.checkAll} />
          </IrsCol>
        </IrsRow>
        <IrsRow type="flex" gutter="8">
            <IrsCol span="8">
              <IrsCheckbox isCompose={true} composeOpts={plainOptions} checkedOpts={this.state.checkedList} onCheckBoxGroupChange={this.onGroupCheckChange} />
            </IrsCol>
        </IrsRow>
     </div>
    )
  }
}
;<IrsGroupCheckBoxDemo />

```