import * as React from 'react';
// import { connect } from "react-redux";
// import { bindActionCreators } from "redux";
import IChooseApproverProps from './module';
import { Select, Spin } from 'antd';
import { isEmpty } from './config-data';
const Option = Select.Option;
import IrsFetchHttp from '../../../http/irs-fetch/http';
const getStaff = (parmas:any) => {
    const settingData = new IrsFetchHttp().post(
      "/web/common/staffSelector/search.do",
      {criteria:parmas,staffStatusList:["IN_SERVICE"],validatePrivilege:false}
    );
    return {
        data: settingData
    };
  };
class IrsChooseApprover extends React.Component<IChooseApproverProps,any> {
    constructor(props: any) {
        super(props);
        this.state = {
            optionArr: [],
            data: [],
            fetching: false,
            value: this.props.value,
            id: this.props.value,
            type: this.props.type
        }
    }
    componentWillMount() {
        // console.log(this.props);
        this.getApplicationInfo();
    }
    componentWillReceiveProps(nextProp:any) {
        // console.log(nextProp);
        if (!this.props.type) {
            if (this.props.value) {
                this.setState({value: ''}, () => {
                    this.setState({value: this.props.value});
                })
            }
        }
        // this.setState({
        //     optionArr: []
        // });
        if (nextProp.applicationInfo !== this.state.optionArr) {
            this.getApplicationInfo();
        }
    }
    getApplicationInfo = () => {
        if( this.props.applicationInfo ) {
            this.setState({optionArr: this.props.applicationInfo });
        }

        // applicationInfo().data.then((res:any) => {
        //     if (res.hasOwnProperty('staffSelectorHistoryList')) {
        //         this.setState({optionArr: res.staffSelectorHistoryList});
        //     }
        // })
    }
    getList = (value:any) => {
        this.setState({optionArr: [] });
        getStaff(value).data.then((res:any) => {
            if (res) {
                this.setState({optionArr: res.content});
            }
        })
    }
    fetchUser = (value:any) => {
        this.getList(value);
    }
    handleChange = (value:any, e:any) => {
        this.setState({
             value,
             optionArr: []
        });
        if (isEmpty(value)) {
            if (this.props.onChange) {
                return this.props.onChange(value, '');
            }
        }
    }
    handleSelect = (value:any, e:any) => {
        this.setState({
            value,
            data: [],
            optionArr: [],
            fetching: false
          });
        if (this.props.onChange) {
            return this.props.onChange(value, e.props.title);
        }
    }
    // filter = (input:any, option:any) => {
    //     // console.log(option);
    //     return option.props.value.toLowerCase().indexOf(input.toLowerCase()) >= 0;
    // }

    render() {
        const { fetching, optionArr } = this.state;
        return (
            <div style={{width:'200px'}}> 
                <Select
                    mode="combobox"
                    labelInValue={false}
                    value={this.state.value}
                    placeholder="请输入员工姓名查询"
                    notFoundContent={fetching ? <Spin size="small" /> : null}
                    filterOption={false}
                    onSearch={this.fetchUser}
                    onChange={this.handleChange}
                    onSelect={this.handleSelect}
                    style={{ width: '100%' }}
                    allowClear={true}
                >
                    {optionArr.map((item:any, index:any) => 
                        <Option key={item.staffName + '（'+ item.mobileNo + '）'} title={item}>
                            <div className="name" style={{fontSize: '15px', fontWeight: 'bold'}}>{item.staffName}</div>
                                <div className="detail" style={{fontSize: '12px'}}>
                                    <span style={{display:'inline-block',width: '120px'}}>部门：{item.departmentName}</span>
                                    <span>职位：{item.positionName}</span>
                                </div>
                        </Option>
                    )}
                </Select>
            </div>
        )
    }
}

// function mapStateToProps(state: any, ownProps: any) {
//     return {
//         applicationInfo: state.homeReducer.applicationInfo,
//         ...ownProps
//     };
// }

// function mapDispatchToProps(dispatch: any) {
//     return {
//     };
// }

// export default connect(mapStateToProps, mapDispatchToProps)(ChooseApprover);
export default IrsChooseApprover;
