// import * as React from 'react';
import * as moment from "moment";
// import { PickerProps } from 'antd/lib/date-picker/interface';
import { TimePickerProps } from 'antd/lib/time-picker';
// SinglePickerProps
export declare type RangePickerValue = undefined[] | [moment.Moment] | [undefined, moment.Moment] | [moment.Moment, moment.Moment];
export interface IPropsInterface {
    /** 组件id */
    id?: number | string,
    /** 设置日期格式，为数组时支持多格式匹配，展示以第一个为准 */
    format?: string,
    /** 禁用 */
    disabled?: boolean,
    /** 是否允许清除 */
    allowClear?: boolean,
    /** 组件类名 */
    className?: string,
    /** 组件样式 */
    style?: React.CSSProperties,
    /** 国际化配置 */
    locale?: any;
    /** 输入框大小 */
    size?: 'large' | 'small' | 'default',
    /** 控制弹层是否展开 */
    open?: boolean;
    /** 面板收起/打开回调 */
    onOpenChange?: (status: boolean) => void;
    /** 需要显示的名称 */
    label?: string,
    /** 显示方式，垂直/水平 */
    labelType?: 'vertical' | 'level',
    /** DatePicker类型：年，月 */
    type?: string,
    /** 是否增加时间选择功能，在type为datepicker，rangepicker有效 */
    showTime?: TimePickerProps | boolean;
    /** 是否展示今天按钮, 在type为datepicker有效 */
    showToday?: boolean,
    /** 默认日期，针对范围时间控件 */
    defaultValue?: moment.Moment,
    /** 默认日期，针对范围时间控件外得所有时间控件 */
    rangeDefaultValue?: RangePickerValue,
    /** 默认日期，必须配合isDefinedValue一起用 */
    value?: any,
    /** 组件是否需要value在页面上自定义, 必须配合value一起用 */
    isDefinedValue?: boolean,
    /** 组件是否需要自定义open */
    isDefinedRange?: boolean,
    /** 不可选择的时间, 需要和showTime一起用 */
    disabledTime?: (current: moment.Moment) => {
        disabledHours?: () => number[];
        disabledMinutes?: () => number[];
        disabledSeconds?: () => number[];
    },
    /** 不可选择的日期 */
    disabledDate?: (current: moment.Moment) => boolean,
    /** 输入框提示文字，针对范围时间控件 */
    rangePlaceholder?: [string, string],
    /** 输入框提示文字，针对除范围时间控件外得所有时间控件 */
    placeholder?: string,
    /** 点击确定按钮的回调, datePicker和rangePicker有效 */
    onOk?: (selectedTime: moment.Moment | RangePickerValue) => void,
    /** 除范围选择控件外的change 事件的 handler */
    onChange?: (date: moment.Moment, dateString: string) => void,
    /** 范围选择控件的change 事件的 handler */
    onRangeChange?: (dates: RangePickerValue, dateStrings: [string, string]) => void,
    /** 日期面板变化时的回调 */
    onPanelChange?: (value?: RangePickerValue, mode?: string | string[]) => void

}

