### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.01 | V0.0.1 | Gail | 新增datepicker组件

<br><br/>
### 2.安装方式
<code>
npm install irs-datepicker
</code>

<br><br/><br><br/>
### 3. 调用方式
#### 基础组件格式, type为时间选择控件类型，默认为datepicker
```jsx
  <div className="App">
    <IrsRow gutter={24}>
      <IrsCol span={6}>
        <IrsDatePicker type="datepicker" />
      </IrsCol>
      <IrsCol span={6}>
        <IrsDatePicker type="monthpicker" />
      </IrsCol>
      <IrsCol span={6}>
        <IrsDatePicker type="rangepicker" />
      </IrsCol>
      <IrsCol span={6}>
        <IrsDatePicker type="weekpicker" />
      </IrsCol>
    </IrsRow>
  </div>
```
#### 基础组件格式, 需要label展示字段名
```jsx
  <div className="App">
    <IrsRow gutter={24}>
      <IrsCol span={8}>
        <IrsDatePicker type="datepicker" label='日期默认' />
      </IrsCol>
      <IrsCol span={8}>
        <IrsDatePicker type="datepicker" label='日期水平' labelType="level" />
      </IrsCol>
      <IrsCol span={8}>
        <IrsDatePicker type="datepicker" label='日期垂直' labelType="vertical" />
      </IrsCol>
    </IrsRow>
  </div>
```
####  禁用，选择框的不可用状态。
```jsx
;
  <div className="App">
     <IrsDatePicker type="datepicker" disabled="true" />
  </div>
```
####  onChange事件（范围选择控件与其他的类型不同）
```jsx
const moment = require('../../../../node_modules/moment');
class IrsDatePickerDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        value: new Date(),
        rangeValue: []
    }
    this.onChange = this.onChange.bind(this);
    this.onRangeChange = this.onRangeChange.bind(this);
  }

  onChange(date, dateString) {
    this.setState({value: dateString})
  }
  onRangeChange(dates, dateStrings) {
    this.setState({rangeValue: dateStrings})
  }
  render() {
    return (
      <div className="App">
        <IrsRow gutter={24}>
          <IrsCol span={6}>
            <IrsDatePicker type="datepicker" value={moment(this.state.value)} onChange={this.onChange} isDefinedValue={true} />
          </IrsCol>
          <IrsCol span={6}>
            <IrsDatePicker type="rangepicker" value={[moment(this.state.rangeValue[0]), moment(this.state.rangeValue[1])]} onRangeChange={this.onRangeChange} isDefinedValue={true} style={{width: 220}} />
          </IrsCol>
        </IrsRow>
      </div>
    )
  }
}
;<IrsDatePickerDemo />
```

####  当日期组件为编辑状态（组件上带有value传值）和非编辑状态（组件上不带有value传值）
```jsx
const moment = require('../../../../node_modules/moment');
class IrsDatePickerDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        value: new Date()
    }
    this.changeValue = this.changeValue.bind(this);
  }

  changeValue(date, dateString) {
    this.setState({value: dateString})
    // 给value赋值
  }
  render() {
    return (
      <div className="App">
        <IrsRow gutter={24}>
          <IrsCol span={6}>
              <IrsDatePicker type="datepicker" value={moment(this.state.value)} isDefinedValue={true} onChange={this.changeValue} />
          </IrsCol>
          <IrsCol span={6}>
              <IrsDatePicker type="datepicker" />
          </IrsCol>
        </IrsRow>
      </div>
    )
  }
}
;<IrsDatePickerDemo />
```
####  自定义日期范围选择，当 RangePicker 无法满足业务需求时，可以使用两个 DatePicker 实现类似的功能。
```jsx
const moment = require('../../../../node_modules/moment');
class IrsDatePickerDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        startValue: new Date(),
        endValue: new Date(),
        startOpen: false,
        endOpen: false
    }
    this.changeStartValue = this.changeStartValue.bind(this);
    this.changeEndValue = this.changeEndValue.bind(this);
    this.changeStartOpen = this.changeStartOpen.bind(this);
    this.changeEndOpen = this.changeEndOpen.bind(this);
  }

  changeStartValue(date, dateString) {
    // 给value赋值
    this.setState({startValue: dateString})
  }
  changeEndValue(date, dateString) {
    // 给value赋值
    this.setState({endValue: dateString})
  }
  changeStartOpen(status) {
    // 给open传值
    this.setState({startOpen: status})
  }
  changeEndOpen(status) {
    // 给open传值
    console.log(status)
    this.setState({endOpen: status})
  }
  render() {
    return (
      <div className="App">
        <IrsRow gutter={24}>
          <IrsCol span={6}>
            <IrsDatePicker 
              type="datepicker" 
              isDefinedRange={true}
              value={moment(this.state.startValue)} 
              isDefinedValue={true} 
              onChange={this.changeStartValue}
              open={this.state.startOpen}
              onOpenChange={this.changeStartOpen}
              />
          </IrsCol>
          <IrsCol span={6}>
            <IrsDatePicker 
              type="datepicker" 
              isDefinedRange={true}
              value={moment(this.state.endValue)} 
              isDefinedValue={true} 
              onChange={this.changeEndValue}
              open={this.state.endOpen}
              onOpenChange={this.changeEndOpen}
              />
          </IrsCol>
        </IrsRow>
      </div>
    )
  }
}
;<IrsDatePickerDemo />
```


