import * as React from "react";
import { Input, Icon } from "antd";

export default class IrsEditableCell extends React.Component<any,any> {
  constructor(props: any) {
    super(props);
    this.state = {
      value: this.props.value,
      editable: false
    };
  }
  handleChange = (e: any) => {
    const value = e.target.value;
    this.setState({ value });
  };
  check = () => {
    this.setState({ editable: false });
    if (this.props.onChange) {
      this.props.onChange(this.state.value);
    }
  };
  edit = () => {
    this.setState({ editable: true });
  };
  render() {
    const { value, editable } = this.state;
    return (
      <div className="editable-cell">
        {editable ? (
          <Input
            value={value}
            onChange={this.handleChange}
            onPressEnter={this.check}
            suffix={
              <Icon
                type="check"
                className="editable-cell-icon-check"
                onClick={this.check}
              />
            }
          />
        ) : (
          <div style={{ paddingRight: 24 }}>
            {value || " "}
            <Icon
              type="edit"
              className="editable-cell-icon"
              onClick={this.edit}
            />
          </div>
        )}
      </div>
    );
  }
}
