/**
 * The only true error.
 * @date 2018.12.08
 * @version 0.0.1
 * @author Rebecca
 */
import * as React from 'react';
import * as module from './module';
import IrsButton from '../../irs-button'
import Bg403 from './img/403.png'
import Bg404 from './img/404.png'
import Bg500 from './img/500.png'


class IrsError extends React.Component<module.IPropsInterface, any> {

    constructor(props: module.IPropsInterface) {
        super(props);
        this.handleClick = this.handleClick.bind(this);
    }

    handleClick = () => {
        window.location.href = this.props.link
    }

    render() {
        let status = null
        if (this.props.type === '404') {
            status = (
                <div style={{ textAlign: 'center', margin: '0 auto' }}>
                    <div style={{ width: '382px', height: '300px', backgroundImage: `url(${Bg404})`, backgroundSize: '382px 300px', margin: '0 auto' }} />
                    <div style={{ fontSize: '20px', color: 'rgba(0, 0, 0, 0.427450980392157)', lineHeight: '28px', fontWeight: 400, margin: '40px 0 20px 0' }}>{this.props.text}</div>
                    <IrsButton onClick={this.handleClick}>{this.props.title}</IrsButton>
                </div>
            )
            return status
        } else if (this.props.type === '403') {
            status = (
                <div style={{ textAlign: 'center', margin: '0 auto' }}>
                    <div style={{ width: '250px', height: '300px', backgroundImage: `url(${Bg403})`, backgroundSize: '250px 300px', margin: '0 auto' }} />
                    <div style={{ fontSize: '20px', color: 'rgba(0, 0, 0, 0.427450980392157)', lineHeight: '28px', fontWeight: 400, margin: '40px 0 20px 0' }}>{this.props.text}</div>
                    <IrsButton onClick={this.handleClick}>{this.props.title}</IrsButton>
                </div>
            )
            return status
        } else if (this.props.type === '500') {
            status = (
                <div style={{ textAlign: 'center', margin: '0 auto' }}>
                    <div style={{ width: '486px', height: '224px', backgroundImage: `url(${Bg500})`, backgroundSize: '486px 224px', margin: '0 auto' }} />
                    <div style={{ fontSize: '20px', color: 'rgba(0, 0, 0, 0.427450980392157)', lineHeight: '28px', fontWeight: 400, margin: '40px 0 20px 0' }}>{this.props.text}</div>
                    <IrsButton onClick={this.handleClick} >{this.props.title}</IrsButton>
                </div>
            )
            return status
        }
        return (
            <div id="error">
                {status}
            </div>
        )
    }
}

export default IrsError;
