/**
 * The only true button.
 * @date 2018.12.1
 * @version 0.0.1
 * @author Rebecca.Zhang
 */
import * as React from 'react';
import * as module from './module';
import { Input, InputNumber } from 'antd';
import { others } from 'fit-transmit-transparently';

const { TextArea } = Input;
const Search = Input.Search;

class IrsInput extends React.Component<module.IPropsInterface, any> {

    static defaultProps = {
        type: "text",
        placeholder: '请输入内容...',
        size: "default",
        disabled: false,
        isSpace: true
    }

    constructor(props: module.IPropsInterface) {
        super(props);
    }

    changeHandler = (e: any) => {
        if (this.props.onChange) {
            // console.log('e2'+e.target.value)
            // const isSpace = this.props.space;
            // if(isSpace) {

            // }
            // 禁止输入空格
            this.props.onChange(e)
        }
    }
    
    // input按下回车的回调
    pressEnter = (e: any) => {
        if (this.props.onPressEnter) {
            this.props.onPressEnter(e)
        }
    }

    // search 按下回车的回调
    search = (value: any, event: any) => {
        this.props.onSearch(value, event)
    }

    // inputNumber 变化回调
    changeInputNumber = (value: any) => {
        if (this.props.onChange) {
            this.props.onChange(value)
        }
    }

    // 失焦事件
    blur = (value?: any) => {
        if (!this.props.onBlur) {
            return;
        };
        // 复制粘贴去掉空格
        this.props.onBlur(value);
    }
    // 聚焦事件
    focus = () => {
        if (!this.props.onFocus) {
            return;
        };
        this.props.onFocus();
    }
    getTypeView = (type: any) => {
        if (type === 'text') {
            return (
                // <span>
                //     <label htmlFor="">{this.props.lableText}</label>
                    <Input
                        {...this.props}
                        placeholder={this.props.placeholder}
                        defaultValue={this.props.defaultValue}
                        disabled={this.props.disabled}
                        style={this.props.defineStyle}
                        size={this.props.size}
                        // space={true}
                        onChange={this.changeHandler}
                        onPressEnter={this.pressEnter}
                        onBlur = {this.blur}
                        onFocus = {this.focus}
                    />
                // </span>
                
            )
        } else if (type === 'textArea') {
            return (
                // <span>
                //      <label htmlFor="">{this.props.lableText}</label>
                    <TextArea
                         {...this.props}
                        placeholder={this.props.placeholder}
                        defaultValue={this.props.defaultValue}
                        disabled={this.props.disabled}
                        rows={this.props.rows}
                        onChange={this.changeHandler}
                        onPressEnter={this.pressEnter}
                        style={this.props.defineStyle}
                    />
                // </span>
                
            )
        } else if (type === 'search') {
            return (
                // <span>
                //      <label htmlFor="">{this.props.lableText}</label>
                    <Search
                        {...this.props}
                        placeholder={this.props.placeholder}
                        defaultValue={this.props.defaultValue}
                        size={this.props.size}
                        disabled={this.props.disabled}
                        onChange={this.changeHandler}
                        onSearch={this.search}
                        onPressEnter={this.pressEnter}
                        style={this.props.defineStyle}
                    />
                // </span>
                
            )
        } else if (type === 'number') {
            let min = this.props.min;
            min = Number(min);

            let max = this.props.max
            max = Number(max)

            // let value = this.props.value
            return (
                // <span>
                //     <label htmlFor="">{this.props.lableText}</label>
                    <InputNumber
                        min={min}
                        max={max}
                        defaultValue={Number(this.props.defaultValue)}
                        step={this.props.step}
                        autoFocus={this.props.autoFocus}
                        size={this.props.size}
                        disabled={this.props.disabled}
                        onChange={this.changeInputNumber}
                        placeholder={this.props.placeholder}
                        style={this.props.defineStyle}
                        className={this.props.className}
                    />
                // </span>
            )
                
            
        }
        return ''
    }

    render() {
        others(IrsInput.defaultProps, this.props);
        return (
            // <div id="inputs">
                // {
                    this.getTypeView(this.props.type)
                // }
            // </div>
        )
    }
}

export default IrsInput;
