### 1.变更记录
变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.01 | V0.0.1 | Rebecca | 新增input组件

<br><br/>
### 2.安装方式
<code>
npm install irs-input
</code>

<br><br/><br><br/>
### 3. 调用方式

#### input基础输入框，包括 default、large、small三种默认尺寸，还可通过defineStyle属性自定义样式
```jsx
inputValueChange = (e) =>{
    console.log('e1',+ e.target.value)
}
// 按下回车的回调函数
pressenter = (e) => {
    console.log(e)
}
blur = (value) => {
    console.log(value)
}
<IrsRow type="flex" gutter="6">
    <IrsCol span="6">
        <IrsInput type="text" lableText='姓名：' defineStyle={{width:'80%'}} onBlur={blur} onChange={inputValueChange} isSpace={true}/>
    </IrsCol>
    <IrsCol span="6">
        <IrsInput type="text" size="large" />
    </IrsCol>
    <IrsCol span="6">
        <IrsInput type="text" size="small" />
    </IrsCol>
    <IrsCol span="6">
        <IrsInput type="text" defineStyle={{width: '200px', height: '60px'}} />
    </IrsCol>
</IrsRow>
```

#### input输入框禁用状态
```jsx
<IrsRow type="flex" gutter="6">
    <IrsCol span="6">
        <IrsInput type="text" disabled={true} />
    </IrsCol>
</IrsRow>
```

#### input输入框添加前缀、后缀
```jsx
<IrsRow type="flex" gutter="6">
    <IrsCol span="8">
        <IrsInput type="text" placeholder="请填写域名..." addonBefore="https://" addonAfter=".com"/>
    </IrsCol>
</IrsRow>
```

#### input输入框添加前、后图标

```jsx
const Icon = require('../../../../node_modules/antd/lib/icon');
<IrsRow type="flex" gutter="6">
    <IrsCol span="8">
        <IrsInput type="text"  prefix={<Icon type="user" style={{ color: 'rgba(0,0,0,.25)' }} />} />
    </IrsCol>
    <IrsCol span="8">
        <IrsInput type="text"  suffix={<Icon type="close-circle" />} />
    </IrsCol>
</IrsRow>
```


#### search类型输入框
```jsx
search= (e) => {
  console.log(e);
}
change= (e) => {
 console.log(e);
}
pressEnter = (e) => {
 console.log(e);
}
<IrsRow type="flex" gutter="6">
    <IrsCol span="8">
        <IrsInput type="search" onSearch={search} onPressEnter={pressEnter} lableText="部门：" defineStyle={{width:'80%'}}/>
    </IrsCol>
    <IrsCol span="8">
        <IrsInput type="search" enterButton="Search" onSearch={search} onChange={change}/>
    </IrsCol>
    <IrsCol span="8">
        <IrsInput type="search" disabled={true} />
    </IrsCol>
</IrsRow>
```

#### input数字类型输入框
```jsx
<IrsRow type="flex" gutter="6">
    <IrsCol span="8">
        <IrsInput type="number" min={1} max={10} defaultValue={2} lableText="年龄："/>
    </IrsCol>
</IrsRow>
```

#### textArea类型输入框
```jsx
<IrsRow type="flex" gutter="6">
    <IrsCol span="20">
        <IrsInput type="textArea" rows={6} defaultValue="测试textArea输入框内容" lableText="个人简介："/>
    </IrsCol>
</IrsRow>
```

