/**
 * The only true button.
 * @date 2018.12.1
 * @version 0.0.1
 * @author Danae.Zhang
 */
import * as React from 'react';
import * as module from './module';
import { Menu } from 'antd'
import { others } from 'fit-transmit-transparently';
import { SelectParam, ClickParam } from 'antd/lib/menu';

class IrsMenu extends React.Component<module.IPropsInterface, any> {
    static defaultProps = {
        
    }
    
    constructor(props: module.IPropsInterface) {
        super(props);
    }

    handleOpenChange = (openKeys: string[]) => {
        if(this.props.onOpenChange) {
            this.props.onOpenChange(openKeys)
        }
    }
    handleSelect = (param: SelectParam) => {
        if(this.props.onSelect) {
            this.props.onSelect(param)
        }
    }

    handleDeselect = (param: SelectParam) => {
        if(this.props.onDeselect) {
            this.props.onDeselect(param)
        }
    }

    handleClick = (param: ClickParam) => {
        if(this.props.onClick){
            this.props.onClick(param)
        }
    }
    
    
    render() {
        others(IrsMenu.defaultProps, this.props);
        const content = (
            this.props.dataSource.map((item: any) => {
                return (
                    <Menu.Item
                        key={1}
                        title={item.title}
                        disabled={item.disabled}
                    >{item.text}</Menu.Item>
                )
            })
        )
        
        return (
            <Menu
                {...this.props}
                onOpenChange={this.handleOpenChange}
                onSelect={this.handleSelect}
                onDeselect={this.handleDeselect}
                onClick={this.handleClick}
            >
                {content}
            </Menu>
        )
    }
}

export default IrsMenu;
