/**
 * The only true message.
 * @date 2018.12.01
 * @version 0.0.1
 * @author Reci.Lu
 */
import * as React from 'react';
import * as module from './module';
import { message } from 'antd';
import { others } from 'fit-transmit-transparently';

class IrsMessage extends React.Component<module.IPropsInterface, any> {
    static defaultProps = {
        content: 'This is a normal message',
        duration: 3
    }

    public static messageFun(type: string, content: any, duration?: number) {
        switch (type) {
            case 'info':
                message.info(content, duration);
                break;
            case 'success':
                message.success(content, duration);
                break;
            case 'error':
                message.error(content, duration);
                break;
            case 'warning':
                message.warning(content, duration);
                break;
            case 'loading':
                message.loading(content, duration);
                break;
            default:
                break;
        }
    }

    constructor(props: module.IPropsInterface) {
        super(props);
        this.handleClick = this.handleClick.bind(this);
    }

    handleClick = (event: React.MouseEvent<any>) => {
        if (this.props.onClick) {
            return;
        };
        this.props.onClick(event);
    }

    render() {
        others(IrsMessage.defaultProps, this.props);
        return (
            <div />
        )
    }
}

export default IrsMessage;
