
import { ConfigOnClose, ArgsProps, MessageType, ConfigOptions } from 'antd/lib/message';

declare type ConfigContent = React.ReactNode | string;
declare type ConfigDuration = number | (() => void);

export interface IMessageApi {
    info(content: ConfigContent, duration?: ConfigDuration, onClose?: ConfigOnClose): MessageType;
    success(content: ConfigContent, duration?: ConfigDuration, onClose?: ConfigOnClose): MessageType;
    error(content: ConfigContent, duration?: ConfigDuration, onClose?: ConfigOnClose): MessageType;
    warn(content: ConfigContent, duration?: ConfigDuration, onClose?: ConfigOnClose): MessageType;
    warning(content: ConfigContent, duration?: ConfigDuration, onClose?: ConfigOnClose): MessageType;
    loading(content: ConfigContent, duration?: ConfigDuration, onClose?: ConfigOnClose): MessageType;
    open(args: ArgsProps): MessageType;
    config(options: ConfigOptions): void;
    destroy(): void;
}

export interface IPropsInterface {
    /** 提示内容 */
    content?: any,

    /** 自动关闭的延时，单位秒。设为 0 时不自动关闭。 */
    duration?: number,

    /** 关闭时触发的回调函数 */
    onClose?: any,

    style?: any;

    className?: any;

    id?: any;

    /** click 事件的 handler */
    onClick?: (event?: React.MouseEvent<any>) => void

}

