// import { ModalProps } from 'antd/lib/modal/Modal';
import { ButtonType, NativeButtonProps } from 'antd/lib/button/button';
export interface IPropsInterface {
    /** 组件id */
    id?:any, 
    /** 组件style */
    style?: React.CSSProperties,
    /** 调用confirm方法 */
    modalFunc?: (type: string, data: object) => void;
    /** 传入需要展示得内容 */
    content?: any;
    /** 对话框是否可见 */
    visible?: boolean;
    /** 确定按钮 loading */
    confirmLoading?: boolean;
    /** 标题 */
    title?: React.ReactNode | string;
    /** 是否显示右上角的关闭按钮 */
    closable?: boolean;
    /** 点击确定回调 */
    onOk?: (e: React.MouseEvent<any>) => void;
    /** 点击模态框右上角叉、取消按钮、Props.maskClosable 值为 true 时的遮罩层或键盘按下 Esc 时的回调 */
    onCancel?: (e: React.MouseEvent<any>) => void;
    /** 居中 */
    centered?: boolean;
    /** 宽度 */
    width?: string | number;
    /** 底部内容 */
    footer?: React.ReactNode;
    /** 确认按钮文字 */
    okText?: string;
    /** 确认按钮类型 */
    okType?: ButtonType;
    /** 取消按钮文字 */
    cancelText?: string;
    /** ok 按钮 props */
    okButtonProps?: NativeButtonProps;
    /** cancel 按钮 props */
    cancelButtonProps?: NativeButtonProps;
    /** 是否展示遮罩层 */
    mask?: boolean;
    /** 关闭时销毁 Modal 里的子元素 */
    destroyOnClose?: boolean;
    /** 设置 Modal 的 z-index */
    zIndex?: number;
    /** 点击蒙层是否允许关闭 */
    maskClosable?: boolean;
}

