export declare type textAlign = 'right' | 'center' | 'left';

export interface IPropsInterface {

    /** id */
    id?: string;

    /** style */
    style?: any;

    /** className */
    className?: string;

    /** 前缀插槽 自定义前缀内容 */
    getHeadView?: () => React.ReactNode;

    /** 默认的单签页数 默认为1 */
    defaultCurrent?: number;

    /** 默认的每页条数 */
    defaultPageSize?: number;

    /** 当前页数 */
    current?: number;

    /** 只有一页时是否隐藏分页器 默认false */
    hideOnSinglePage?: boolean;

    /** 每页条数 */
    pageSize?: number;

    /** 指定每页可以显示多少条 */
    pageSizeOptions?: string[];

    /** 是否可以快速跳转至某页 */
    showQuickJumper?: boolean;

    /** 是否可以改变 pageSize */
    showSizeChanger?: boolean;

    /** 用于显示数据总量和当前数据顺序 */
    showTotal?: (total: number, range: [number, number]) => React.ReactNode;

    /** 当添加该属性时，显示为简单分页 */
    simple?: boolean;

    /** 当为「small」时，是小尺寸分页 提供 large default 和 small 三种大小 */
    size?: string;

    /** 数据总数 */
    total?: number;

    /** 页码改变的回调，参数是改变后的页码及每页条数 */
    onChange?: (page: number, pageSize?: number) => void;

    /** pageSize 变化的回调 */
    onShowSizeChange?: (current: number, size: number) => void;

    /** 对齐方式 'right' | 'center' | 'left'  默认为right */
    textAlign?: string;
}

