/**
 * The only true pagination.
 * @date 2018.12.01
 * @version 0.0.1
 * @author Kang
 */
import * as React from 'react';
import * as module from './module';
import './style.less';
import { Pagination } from 'antd';
import { others } from 'fit-transmit-transparently';

const PaginationStyle = {
    display:"inline-block", 
    verticalAlign:'middle'
}

class IrsPagination extends React.Component<module.IPropsInterface, any> {

    static defaultProps = {
        defaultCurrent:1,
        defaultPageSize:10,
        hideOnSinglePage: false,
        pageSizeOptions:['10', '20', '50', '100'],
        showQuickJumper: false,
        showSizeChanger: false,
        simple: false,
        size:'default',
        total:0,
        textAlign:'right'
    }
    constructor(props: module.IPropsInterface) {
        super(props);
        this.state = {
            paginationContainer: {
                textAlign: this.props.textAlign
            },
            current:1,
            pageSize:10,
        },
        this.onChange = this.onChange.bind(this)
        this.onShowSizeChange = this.onShowSizeChange.bind(this)
    }

    componentWillMount() { 
       if (!this.props.current) {
           this.setState({
             current: this.props.defaultCurrent
           })
       }
       
       if (!this.props.pageSize) {
            this.setState({
                pageSize: this.props.defaultPageSize
            })
        }
    }

    onChange(page:number, pageSize:number) {
        if (!this.props.current) {
            this.setState({
                current:page
            })
        }

        if (!this.props.pageSize) {
            this.setState({
                pageSize
            })
        }

        if (this.props.onChange) {
            this.props.onChange(page, pageSize)
        }
    }

    onShowSizeChange(current:number, size:number) {
        if (!this.props.current) {
            this.setState({
                current
            })
        }

        if (!this.props.pageSize) {
            this.setState({
                pageSize:size
            })
        }

        if (this.props.onShowSizeChange) {
            this.props.onShowSizeChange(current, size)
        }
    }

    render() {   
        others(IrsPagination.defaultProps, this.props);

        return ( 
            <div style = {this.state.paginationContainer}>
                <span>
                {
                    this.props.getHeadView ? this.props.getHeadView() : ''
                }
                </span>
                <Pagination 
                    {...this.props}
                    style={PaginationStyle}
                    defaultCurrent={this.props.defaultCurrent}
                    defaultPageSize={this.props.defaultPageSize}
                    current={ this.props.current ? this.props.current : this.state.current}
                    hideOnSinglePage={this.props.hideOnSinglePage}
                    pageSize={this.props.pageSize ? this.props.pageSize : this.state.pageSize} 
                    pageSizeOptions ={this.props.pageSizeOptions}
                    showQuickJumper={this.props.showQuickJumper}
                    showSizeChanger={this.props.showSizeChanger} 
                    showTotal={this.props.showTotal}
                    simple={this.props.simple}
                    size={this.props.size} 
                    total={this.props.total} 
                    onChange={this.onChange} 
                    onShowSizeChange={this.onShowSizeChange} 
                />
            </div>
        )
    }
} 

export default IrsPagination;
