### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.01 | V0.0.1 | Kang | 新增Pagination组件

<br><br/>
### 2.安装方式
<code>
npm install irs-tab
</code>

<br><br/><br><br/>
### 3. 调用方式

#### 左对齐 + 自定义左边视图
```jsx
const style = {
    margin:'20px 0'
}

const customSpanStyle = {
    marginRight:'10px'
}

class IrsPaginationDemo extends React.Component {
  constructor() {
    super()
    this.state = {
      total:100,
    }
    this.getHeadView = this.getHeadView.bind(this)
  }

getHeadView() {
    return (
        <span style={customSpanStyle}>自定义的前缀</span>
    )
}

render() {
    return (
        <IrsRow>
            <IrsCol span={24}>
                <IrsPagination
                    textAlign = 'left'
                    getHeadView = {this.getHeadView}
                    showQuickJumper = {true}
                    showSizeChanger = {true}
                    total = {this.state.total}
                />
            </IrsCol>
        </IrsRow>
    )
}
}
;<IrsPaginationDemo />
```

#### 居中对齐 + 默认选中第二页 + 默认每页20条 + 不显示快速跳转至某页
```jsx
class IrsPaginationDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        current:2,
        pageSize:20,
        total:100
    }
    this.onChange = this.onChange.bind(this)
    this.onShowSizeChange = this.onShowSizeChange.bind(this)
  }


onChange(page, pageSize) {
    this.setState({
        current: page
    })
}

onShowSizeChange(current, size) {
    this.setState({
        pageSize:size
    })
}

  render() {
    return (
        <IrsRow>
            <IrsCol span={24}>
                <IrsPagination
                    textAlign = 'center'
                    current = {this.state.current}
                    pageSize = {this.state.pageSize}
                    showQuickJumper = {false}
                    showSizeChanger = {true}
                    onChange = {this.onChange}
                    onShowSizeChange = {this.onShowSizeChange}
                    total = {this.state.total}
                />
            </IrsCol>
        </IrsRow>    
    )
  }
}
;<IrsPaginationDemo />
```

#### 右对齐 + size为small 
```jsx
class IrsPaginationDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        current:3,
        pageSize:20,
        total:100,
    }
    this.onChange = this.onChange.bind(this)
  }

onChange(page, pageSize) {
    this.setState({
        current: page
    })
}

render() {
    return (
        <IrsRow>
            <IrsCol span={24}>
                <IrsPagination
                    textAlign = 'right'
                    size='small'
                    defaultCurrent={1}
                    defaultPageSize={10}
                    current = {this.state.current}
                    pageSize = {this.state.pageSize}
                    showQuickJumper = {true}
                    showSizeChanger = {false}
                    onChange = {this.onChange}
                    total = {this.state.total}
                />
            </IrsCol>
        </IrsRow>
    )
  }
}
;<IrsPaginationDemo />
```



