import { ReactNode } from 'react';
// import { PopconfirmProps }from 'antd/lib/popconfirm/index'
import { ButtonType } from 'antd/lib/button/button'

export declare type placement = 'top' | 'left' | 'right' | 'bottom' | 'topLeft' | 'topRight' | 'bottomLeft' | 'bottomRight' | 'leftTop' | 'leftBottom' | 'rightTop' | 'rightBottom';

export declare type trigger = 'hover' | 'focus' | 'click' | 'contextMenu';

export interface IPropsInterface {

    /** 确认框的描述 */
    title: string | ReactNode

    /** 点击确认的回调 */
    onConfirm?: (e?: React.MouseEvent<any>) => void
    
    /** 点击取消的回调 */
    onCancel?: (e?: React.MouseEvent<any>) => void

    /** 确认按钮类型 */
    okType?: ButtonType;

    /** 取消按钮文字 */
    cancelText?: string;

    /** 确认按钮文字 */
    okText?: string;

    /** 自定义弹出气泡 Icon 图标 */
    icon?: React.ReactNode

    /** 箭头是否指向目标元素中心,默认true */
    arrowPointAtCenter?: boolean

    /** 气泡被遮挡时自动调整位置,默认true */
    autoAdjustOverflow?: boolean

    /** 默认是否显隐,默认false */
    defaultVisible?: boolean

    /** 鼠标移入后延时多少才显示 Tooltip，单位:秒,默认0 */
    mouseEnterDelay?: number

    /** 鼠标移出后延时多少才隐藏 Tooltip，单位:秒,默认0.1 */
    mouseLeaveDelay?: number

    /** 气泡框位置,可选,默认top */
    placement?: placement

    /** 自定义类名 */
    overlayClassName?: string

    /** 自定义卡片样式 */
    overlayStyle?: {}
}
