/**
 * The only true tab.
 * @date 2018.12.15
 * @version 0.0.1
 * @author Jita.Song
 */
import * as React from 'react';
import * as module from './module';
import { others } from 'fit-transmit-transparently';

import { Popconfirm } from 'antd';
import './style.less';

class IrsPopconfirm extends React.Component<module.IPropsInterface,any>{
    static defaultProps = {
        arrowPointAtCenter:false,
        autoAdjustOverflow:true,
        mouseEnterDelay:0,
        mouseLeaveDelay:0.1,
        placement:"top",
        okText:'确定',
        cancelText:'取消'


    }

    constructor(props:module.IPropsInterface){
        super(props)
    }

    render(){
        others(IrsPopconfirm.defaultProps, this.props);
        return(
            <Popconfirm
                //确认框的描述
                title={this.props.title}
                //取消按钮文字
                cancelText={this.props.cancelText}
                //确认按钮文字
                okText={this.props.okText}
                //点击取消的回调
                onCancel={this.props.onCancel}
                //点击确认的回调
                onConfirm={this.props.onConfirm}
                //确认按钮类型
                okType={this.props.okType}
                //自定义弹出气泡 Icon 图标
                icon={this.props.icon}
                //箭头是否指向目标元素中心,默认false
                arrowPointAtCenter={this.props.arrowPointAtCenter}
                //气泡被遮挡时自动调整位置
                autoAdjustOverflow={this.props.autoAdjustOverflow}
                //鼠标移入后延时多少才显示 Tooltip，单位：秒
                mouseEnterDelay={this.props.mouseEnterDelay}
                //鼠标移出后延时多少才隐藏 Tooltip，单位：秒
                mouseLeaveDelay={this.props.mouseLeaveDelay}
                //气泡框位置，可选 top left right bottom topLeft topRight bottomLeft bottomRight leftTop leftBottom rightTop rightBottom
                placement={this.props.placement}
                //自定义卡片类名
                overlayClassName={this.props.overlayClassName}	
                //自定义样式
                overlayStyle={this.props.overlayStyle}
            >
            {
                this.props.children
            }   
            </Popconfirm>
        )
    }
}

export default IrsPopconfirm;