/**
 * The only true tab.
 * @date 2018.12.15
 * @version 0.0.1
 * @author Jita.Song
 */
import * as React from 'react';
import * as module from './module';
import { others } from 'fit-transmit-transparently';

import { Popover } from 'antd';
import './style.less';

class IrsPopover extends React.Component<module.IPropsInterface,any>{
    static defaultProps = {
        arrowPointAtCenter:false,
        autoAdjustOverflow:true,
        defaultVisible:false,
        mouseEnterDelay:0,
        mouseLeaveDelay:0.1,
        placement:"top",
        trigger:"hover"

    }

    constructor(props:module.IPropsInterface){
        super(props)
    }

    render(){
        others(IrsPopover.defaultProps, this.props);
        return(
            <Popover 
                //卡片标题
                title={this.props.title}
                //卡片内容
                content={this.props.content}
                //箭头是否指向目标元素中心,默认false
                arrowPointAtCenter={this.props.arrowPointAtCenter}
                //气泡被遮挡时自动调整位置
                autoAdjustOverflow={this.props.autoAdjustOverflow}
                //默认是否显隐
                defaultVisible={this.props.defaultVisible}
                //鼠标移入后延时多少才显示 Tooltip，单位：秒
                mouseEnterDelay={this.props.mouseEnterDelay}
                //鼠标移出后延时多少才隐藏 Tooltip，单位：秒
                mouseLeaveDelay={this.props.mouseLeaveDelay}
                //气泡框位置，可选 top left right bottom topLeft topRight bottomLeft bottomRight leftTop leftBottom rightTop rightBottom
                placement={this.props.placement}
                //触发行为，可选 hover/focus/click/contextMenu
                trigger={this.props.trigger}
                //自定义卡片类名
                overlayClassName={this.props.overlayClassName}	
                //自定义样式
                overlayStyle={this.props.overlayStyle}
            >
            {
                this.props.children
            }   
            </Popover>
        )
    }
}

export default IrsPopover;