### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.14 | V0.0.1 | Amber | 新增Progress组件

<br><br/>
### 2.安装方式
<code>
npm install irs-progress
</code>

<br><br/><br><br/>
### 3. 调用方式

#### 进度条
```jsx
class IrsProgressDemo extends React.Component {
    constructor() {
        super()
        this.state = {
            percent: 30,
            showInfo:false,
            status:"active"   
        }
    }

    render() {
        return (
            <div className="App">
                <IrsRow gutter={24}>
                    <IrsCol span={8}>
                        <IrsProgress         
                        percent = {this.state.percent}
                        showInfo = {this.state.showInfo}
                        />   
                        <p>不显示进度数值或状态图标</p>  
                    </IrsCol>
                    <IrsCol span={8}>
                        <IrsProgress         
                        percent = {this.state.percent}
                        />  
                        <p>无状态的进度条</p>
                    </IrsCol>
                    <IrsCol span={8}>
                        <IrsProgress         
                        status = {this.state.status}
                        percent = {this.state.percent}
                        />
                        <p>加载状态的进度条</p>
                    </IrsCol>
                </IrsRow>
                <IrsRow gutter={24}>
                    <IrsCol span={8}>
                        <IrsProgress         
                        percent = {100}
                        status = "success"
                        />   
                        <p>成功状态的进度条</p>                         
                    </IrsCol>
                    <IrsCol span={8}>
                        <IrsProgress         
                        percent = {this.state.percent}
                        status = "exception"
                        />  
                        <p>异常状态的进度条</p>
                    </IrsCol>
                </IrsRow>
            </div>
        )
    }
}
;<IrsProgressDemo />
```

#### 进度圈
```jsx
class IrsProgressDemo extends React.Component {
    constructor() {
        super()
        this.state = {
            type:"circle",
            percent: 75,  
            status:"active",
            isTip:true,
            title:"鼠标悬停后的文案自定义提示"

        }
    }

    render() {
        return (
            <div className="App">
                <IrsRow gutter={24}>
                    <IrsCol span={8}>
                        <IrsProgress  
                        type = {this.state.type}
                        percent = {this.state.percent}
                        />  
                       <p>无状态的进度圈</p>
                    </IrsCol>
                    <IrsCol span={8}>
                        <IrsProgress  
                        type = {this.state.type}
                        percent = {this.state.percent}
                        status = {this.state.status}
                        />
                        <p>加载中状态的进度圈</p>
                    </IrsCol>
                     <IrsCol span={8}>
                      <IrsProgress  
                        type = {this.state.type}
                        percent = {this.state.percent}
                        status = {this.state.status}
                        isTip = {this.state.isTip}
                        title={this.state.title}
                        />
                        <p>带有鼠标悬停后的文案提示</p>
                    </IrsCol>
                </IrsRow>
                <IrsRow gutter={24}>
                    <IrsCol span={8}>
                        <IrsProgress  
                        type = {this.state.type}
                        percent = {100}
                        status = "success"
                       /> 
                       <p>成功状态的进度圈</p> 
                    </IrsCol>
                    <IrsCol span={8}>
                        <IrsProgress  
                        type = {this.state.type}
                        percent = {this.state.percent}
                        status = "exception"
                       /> 
                       <p>异常状态的进度圈</p>  
                    </IrsCol>
                   
                </IrsRow>
            </div> 
        )
    }
}
;<IrsProgressDemo />
```

#### 仪表盘
```jsx
class IrsProgressDemo extends React.Component {
    constructor() {
        super()
        this.state = {
            type:"dashboard",
            percent: 75,  
            status:"active"
        }
    }
    render() {
        return (
            <div className="App">
                <IrsRow gutter={24}>
                    <IrsCol span={8}>
                        <IrsProgress  
                        type = {this.state.type}
                        percent = {this.state.percent}
                       /> 
                       <p>无状态的仪表盘</p>
                    </IrsCol>
                    <IrsCol span={8}>
                        <IrsProgress  
                        type = {this.state.type}
                        percent = {this.state.percent}
                        status = {this.state.status}
                       /> 
                       <p>加载中状态的仪表盘</p>
                    </IrsCol>
                    <IrsCol span={8}>
                        <IrsProgress  
                        type = {this.state.type}
                        percent = {100}
                        status = "success"
                       /> 
                       <p>成功状态的仪表盘</p>
                    </IrsCol>
                </IrsRow>
                <IrsRow gutter={24}>
                    <IrsCol span={8}>
                        <IrsProgress  
                        type = {this.state.type}
                        percent = {this.state.percent}
                        status = "exception"
                       /> 
                       <p>异常状态的仪表盘</p>
                    </IrsCol>
                </IrsRow>
            </div>      
        )
    }     
}
;<IrsProgressDemo />
```