/**
 * The only true button.
 * @date 2018.12.1
 * @version 0.0.1
 * @author Rebecca.Zhang
 */

import * as React from 'react';
import * as module from './module';
import { Radio  } from 'antd';

const RadioGroup = Radio.Group;

class IrsRadio extends React.Component<module.IRadioInterface, any> {

    static defaultProps = {
        autoFocus: false,
        checked: false,
        defaultChecked: false,
        disabled: false,
        size: 'default',

    }
    
    constructor(props: module.IRadioInterface) {
        super(props);
    }

    handleGroupChange = (event:any) => {
        if (!this.props.onChange) {
            return;
        };
        this.props.onChange(event);
    }
    
    render() {
        if(!this.props.isCompose) {
            return (
                <div id="radio">
                   <Radio 
                        disabled = { this.props.disabled }
                   >
                   {this.props.checkText}
                   </Radio>
                </div>
            )
        } else {
            return (
                <RadioGroup options={this.props.composeOpts} onChange={this.handleGroupChange} value={this.props.value} />
            )
        }
        
    }
} 

export default IrsRadio;