/**
 * The only true button.
 * @date 2018.12.1
 * @version 0.0.1
 * @author Rebecca.Zhang
 */

import * as React from 'react';
import * as module from './module';
import { Select   } from 'antd';

const Option = Select.Option;

class IrsSelect extends React.Component<module.ISelectInterface, any> {

    static defaultProps = {
        autoFocus: false,
        checked: false,
        defaultChecked: false,
        disabled: false,
        size: 'default',

    }
    
    constructor(props: module.ISelectInterface) {
        super(props);
    }

    handleChange = (value:any,option:any) => {
        if (!this.props.onChange) {
            return;
        };
        this.props.onChange(value,option);
    }

    handleFocus = () => {
        if (!this.props.onFocus) {
            return;
        };
        this.props.onFocus();
    }

    handleBlur = (value:any) => {
        if (!this.props.onBlur) {
            return;
        };
        this.props.onBlur(value);
    }
    
    render() {
        return (
            <span>
                <label htmlFor="">{this.props.lableText}</label>
                <Select 
                    {...this.props}
                    style={this.props.style}
                    defaultValue = { this.props.defaultValue }
                    showSearch = { this.props.showSearch }
                    disabled = { this.props.disabled }
                    optionFilterProp = { this.props.optionFilterProp }
                    onChange = { this.handleChange }
                    onFocus= { this.handleFocus }
                    onBlur= { this.handleBlur }
                    placeholder = { this.props.placeholder }
                    filterOption = { this.props.filterOption}
                >
                    {this.props.types ? this.props.optionChild.map((value:any,index:any) => (
                        value
                    )) : this.props.options.map((values:any,index:any) => (
                        <Option
                            key={index}
                            value = { values.value }
                            disabled = { values.disabled }
                        >
                            { values.text }
                        </Option>
                    ))}
                    
                </Select>
            </span>
            
        )
        
    }
} 

export default IrsSelect;