### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.08 | V0.0.1 | Amber | 新增Steps组件

<br><br/>
### 2.安装方式
<code>
npm install irs-steps
</code>

<br><br/><br><br/>
### 3. 调用方式


#### 当前位于步骤一
```jsx
class IrsStepsDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        current:0,
        status:"wait",
        stepDataArray:[
            {
                status:'process',
                title: '标题1',
                description: '描述内容1',
             
            },
            {
                status:'wait',
                title: '标题2',
                description: '描述内容2',
               
            },
            {
                status:'wait',
                title: '标题3',
                description: '描述内容3',
            }
        ]
    }
  }

render() {
    return (
        <IrsSteps
            current = {this.state.current}
            status={this.state.status}
            stepDataArray={this.state.stepDataArray}
        />     
    )
  }
}
;<IrsStepsDemo />
```

#### 步骤一已完成，当前位于步骤二
```jsx
class IrsStepsDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        current:0,
        status:"wait",
        stepDataArray:[
            {
                status:'finish',
                title: '标题1',
                description: '描述内容1',
                icon:()=>{
                    return <div>123</div>
                }
            },
            {
                status:'process',
                title: '标题2',
                description: '描述内容2',
            },
            {
                status:'wait',
                title: '标题3',
                description: '描述内容3',
            }
        ]
    }
  }

render() {
    return (  
        <IrsSteps
            current = {this.state.current}
            status={this.state.status}
            stepDataArray={this.state.stepDataArray}
        /> 
          
    )
  }
}
;<IrsStepsDemo />
```

#### 步骤一已完成，当前位于步骤二，且当前步骤的状态为错误
```jsx
class IrsStepsDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        current:0,
        status:"wait",
        stepDataArray:[
            {
                status:'finish',
                title: '标题1',
                description: '描述内容1',
            },
            {
                status:'error',
                title: '标题2',
                description: '描述内容2',
            },
            {
                status:'wait',
                title: '标题3',
                description: '描述内容3',
            }
            
        ]
    }
  }

render() {
    return (
        <IrsSteps
            current = {this.state.current}
            status={this.state.status}
            stepDataArray={this.state.stepDataArray}
        />     
    )
  }
}
;<IrsStepsDemo />
```

#### 自定义步骤数，这里举例：四个步骤
```jsx
class IrsStepsDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        current:0,
        status:"wait",
        stepDataArray:[
            {
                status:'finish',
                title: '标题1',
                description: '描述内容1',
            },
            {
                status:'process',
                title: '标题2',
                description: '描述内容2',
            },
            {
                status:'wait',
                title: '标题3',
                description: '描述内容3',
            },
            {
                status:'wait',
                title: '标题4',
                description: '描述内容4',
            }
            
        ]
    }
  }

render() {
    return (
        <IrsSteps
            current = {this.state.current}
            status={this.state.status}
            stepDataArray={this.state.stepDataArray}
        />     
    )
  }
}
;<IrsStepsDemo />
```