// import * as React from 'react';
// import { SwitchProps } from 'antd/lib/switch'

export interface ISwitchInterface {

    /** 开关大小，可选值：default small */
    size?: 'small' | 'default';

    /** Switch 器类名 */
    className?: string;

    /** 指定当前是否选中 */
    checked?: boolean;

    /** 初始是否选中 */
    defaultChecked?: boolean;

    /** 变化时回调函数 */
    onChange?: (checked: boolean) => any;

    /** 选中时的内容 */
    checkedChildren?: React.ReactNode;

    /** 非选中时的内容 */
    unCheckedChildren?: React.ReactNode;

    /** 是否禁用 */
    disabled?: boolean;

    /** loading状态 */
    loading?: boolean; 

    /** 自动获取焦点 */
    autoFocus?: boolean;

    /** 支持lable属性 */
    lableText?: string;
}