/**
 * The only true button.
 * @date 2018.12.1
 * @version 0.0.1
 * @author Rebecca.Zhang
 */

import * as React from 'react';
import * as module from './module';
import { Switch } from 'antd';


class IrsSwitch extends React.Component<module.ISwitchInterface, any> {

    static defaultProps = {
        autoFocus: false,
        checked: false,
        defaultChecked: false,
        disabled: false,
        loading: false,
        size: 'default'
    }
    constructor(props: module.ISwitchInterface) {
        super(props);
    }

    // 变化是回调函数
    switchChange = (checked:any) => {
        if(this.props.onChange) {
          this.props.onChange(checked) 
        }
    }
    
    render() {
        return (
            <span id="switch">
                <label htmlFor="">{this.props.lableText}</label>
               <Switch 
                    autoFocus = { this.props.autoFocus }
                    // checked = { this.props.checked }
                    defaultChecked = { this.props.defaultChecked }
                    checkedChildren = { this.props.checkedChildren }
                    unCheckedChildren = { this.props.unCheckedChildren }
                    disabled = { this.props.disabled }
                    loading = { this.props.loading }
                    size = { this.props.size }
                    onChange = { this.switchChange }
               />
            </span>
        )
    }
} 

export default IrsSwitch;