### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.01 | V0.0.1 | Kang | 新增Tab组件

<br><br/>
### 2.安装方式
<code>
npm install irs-tab
</code>

<br><br/><br><br/>
### 3. 调用方式


#### type = editable-card + 配置左侧Icon + 动画
```jsx
class IrsTabDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        tabData: [
            {
                title:'Tab 1',
                key: 'title1',
                icon:'heart',
                iconTheme:'twoTone',
                twoToneColor:'#eb2f96',
                render:(index) => {
                    return <div>Content of Tab Pane 1</div>
                }
            },
            {
                title:'Tab 2',
                key: 'title2',
                closable: true,
                render:(index) => {
                    return <div>Content of Tab Pane 2</div>
                }
            }
        ],
    }
    this.onEdit = this.onEdit.bind(this)
    this.randomString = this.randomString.bind(this)
  }
//随机数
randomString(len) {
    　　len = len || 32;
    　　var $chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';    /****     默认去掉了容易混淆的字符oOLl,9gq,Vv,Uu,I1****/
    　　var maxPos = $chars.length;
    　　var pwd = '';
    　　for (let i = 0; i < len; i++) {
    　　　　pwd += $chars.charAt(Math.floor(Math.random() * maxPos));
    　　}
    　　return pwd;
}

onEdit(targetKey, action){
    let indexs = 0;
    const tabData = this.state.tabData
    if (action === 'remove') {
        tabData.map((item, index) => {
            if (item.key === targetKey) {
                indexs = index
            }
        })
        tabData.splice(indexs, 1)
    } else {
        const newTab = {
            title:'新增的Tab' ,
            key: this.randomString(10),
            icon:'heart',
            iconTheme:'twoTone',
            twoToneColor:'#eb2f96',
            closable: true,
            render:(index) => {
                return <div>新增的tab</div>
            }
        }
        tabData.push(newTab)
    }

    this.setState({
        tabData
    })
}

render() {
    return (
        <IrsRow>
            <IrsCol span={24}>
                <IrsTab 
                    animated = {true}
                    type ='editable-card' 
                    tabData = {this.state.tabData} 
                    onEdit={this.onEdit} 
                    hideAdd={false}
                />
            </IrsCol>
        </IrsRow>
    )
  }
}
;<IrsTabDemo />
```


#### type = card + 右侧自定义控件 + tab间距
```jsx
const style={ 
    marginLeft:'20px', 
    color:'red' 
}
class IrsTabDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        dataSource: [
            {
                key:1,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
                icon:'A',
            },
            {
                key:2,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
                icon:'W',
            },
            {
                key:3,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
                icon:'张',
            },
            {
                key:4,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
                icon:'王',
            }
        ],
        tabData: [
            {
                title:'表格',
                key: 'title1',
                rightRender:() => {
                    return <span style={style}>自定义组件</span>
                },
                render:(index) => {
                    return (<IrsTable
                                scroll={{ x: 1100 }}
                                columns = {this.getColumns()}
                                dataSource = {this.state.dataSource}
                            />)
                }
            },
            {
                title:'ihr360',
                key: 'title2',
                closable: true,
                render:(index) => {
                    return <div>测试页面</div>
                }
            }
        ],
        defaultActiveKey:'title1',
        activeKey:'title2',
        tabBarGutter: 10,
    }
    this.onChange = this.onChange.bind(this)
    this.getColumns = this.getColumns.bind(this)
  }

  getColumns() {
      let columns = [
          {
            title: '姓名',
            dataIndex: 'name',
            fixed:'left',
            sorter: false,
            width:120,
          },
          {
            title: '头像',
            dataIndex: 'icon',
            sorter: false,
            width: 200,
            render: (text, record, index) => {
                const obj = {
                    children: (<IrsAvatar style={{ color: '#f56a00', height: '30px', width: '30px' }}>{text}</IrsAvatar>)
                };
                return obj;
            },
          },
          {

            title: '手机号',
            dataIndex: 'phoneNum',
            sorter: false,
            width: 200,
          },
          {

            title: '性别',
            dataIndex: 'sex',
            sorter: false,
            width: 200,
          },
          {

            title: '职位',
            sorter: false,
            dataIndex: 'postion',
            width: 200,
          },
      ]
      return columns;
  }

onChange(activeKey){
    this.setState({
        activeKey: activeKey
    })
}
  render() {
    return (
        <IrsRow>
            <IrsCol span={24}>
                <IrsTab 
                    type ='card' 
                    tabData = {this.state.tabData} 
                    onChange = {this.onChange} 
                    activeKey = {this.state.activeKey}
                    tabBarGutter = {this.state.tabBarGutter}
                />
            </IrsCol>
        </IrsRow>
    )
  }
}
;<IrsTabDemo />
```


#### type = line + 自定义Tab内容
```jsx
const style={ 
    marginLeft:'20px', 
    color:'red' 
}
class IrsTabDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        tabData: [
            {
                key: 'title1',
                tabRender:() => {
                    return (
                        <IrsAvatar style={{ color: '#f56a00', height: '30px', width: '30px' }}>S</IrsAvatar>
                    )
                },
                render:(index) => {
                    return (<IrsDatePicker type="datepicker" />)
                }
            },
            {
                title:'审批列表',
                key: 'title2',
                closable: true,
                render:(index) => {
                    return (<IrsTable
                                scroll={{ x: 1100 }}
                                columns = {this.getColumns()}
                                dataSource = {this.state.dataSource}
                            />)
                }
            }
        ],

         dataSource: [
            {
                key:1,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
                icon:'A',
            },
            {
                key:2,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
                icon:'W',
            },
            {
                key:3,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
                icon:'张',
            },
            {
                key:4,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
                icon:'王',
            }
        ],
        activeKey:'title1',

    }
    this.onChange = this.onChange.bind(this)
    this.getColumns = this.getColumns.bind(this)
  }

  getColumns() {
      let columns = [
          {
            title: '姓名',
            dataIndex: 'name',
            fixed:'left',
            sorter: false,
            width:120,
          },
          {
            title: '头像',
            dataIndex: 'icon',
            sorter: false,
            width: 200,
            render: (text, record, index) => {
                const obj = {
                    children: (<IrsAvatar style={{ color: '#f56a00', height: '30px', width: '30px' }}>{text}</IrsAvatar>)
                };
                return obj;
            },
          },
          {

            title: '手机号',
            dataIndex: 'phoneNum',
            sorter: false,
            width: 200,
          },
          {

            title: '性别',
            dataIndex: 'sex',
            sorter: false,
            width: 200,
          },
          {

            title: '职位',
            sorter: false,
            dataIndex: 'postion',
            width: 200,
          },
      ]
      return columns;
  }

onChange(activeKey){
    this.setState({
        activeKey: activeKey
    })
}
  render() {
    return (
        <IrsRow>
            <IrsCol span={24}>
                <IrsTab 
                    type ='line' 
                    tabData = {this.state.tabData} 
                    onChange={this.onChange} 
                    activeKey = {this.state.activeKey}
                />
            </IrsCol>
        </IrsRow>
    )
  }
}
;<IrsTabDemo />
```


