/**
 * The only true tab.
 * @date 2018.12.01
 * @version 0.0.1
 * @author Kang
 */
import * as React from 'react';
import * as module from './module';
import './style.less';
import { Tabs, Icon } from 'antd';
import { others } from 'fit-transmit-transparently';

const TabPane = Tabs.TabPane;

class IrsTab extends React.Component<module.IPropsInterface, any> {

    static defaultProps = {
        type: "card",
        animated: false,
        hideAdd: false,
        size: 'default',
        tabBarGutter: 0,
    }
    constructor(props: module.IPropsInterface) {
        super(props);
        this.state = {
            activeKey: ''
        }
        this.getTabTitleView = this.getTabTitleView.bind(this)
        this.onChange = this.onChange.bind(this)
    }

    componentWillMount() {
        if (!this.props.activeKey) {
            this.setState({
                activeKey: this.props.defaultActiveKey ? this.props.defaultActiveKey : this.props.tabData.length > 0 ? this.props.tabData[0].key.toString() : ''
            })
        }
    }

    onChange(activeKey: string) {
        if (!this.props.activeKey) {
            this.setState({
                activeKey
            })
        }

        if (this.props.onChange) {
            this.props.onChange(activeKey)
        }
    }

    getTabTitleView(item: any) {
        return (
            <span>
                {
                    item.icon ? <Icon type={item.icon} theme={item.iconTheme ? item.iconTheme : 'outlined'} twoToneColor={item.twoToneColor} /> : ''
                }
                {
                    <span>{item.title}</span>
                }
                {
                    item.rightRender ? item.rightRender() : item.count ? <span className={item.countClassName}>{'(' + item.count + ')'}</span> : ''
                }
            </span>
        )
    }

    render() {
        others(IrsTab.defaultProps, this.props);

        return (
            <Tabs
                {...this.props}
                defaultActiveKey={this.props.defaultActiveKey ? this.props.defaultActiveKey : this.props.tabData.length > 0 ? this.props.tabData[0].key.toString() : ''}
                type={this.props.type}
                animated={this.props.animated}
                hideAdd={this.props.hideAdd}
                size={this.props.size}
                activeKey={this.props.activeKey ? this.props.activeKey : this.state.activeKey}
                tabBarGutter={this.props.tabBarGutter}
                tabPosition={this.props.tabPosition}
                onChange={this.onChange}
                onEdit={this.props.onEdit}
                onTabClick={this.props.onTabClick}
                onNextClick={this.props.onNextClick}
                onPrevClick={this.props.onPrevClick}
                renderTabBar={this.props.renderTabBar}
            >
                {
                    this.props.tabData.map((item: any, index: any) => {
                        return (
                            <TabPane disabled={item.disabled} closable={item.closable ? true : false} tab={item.tabRender ? item.tabRender() : this.getTabTitleView(item)} key={item.key}>
                                {
                                    item.render(index)
                                }
                            </TabPane>
                        )
                    })
                }
            </Tabs>
        )
    }
}

export default IrsTab;
