### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.08 | V0.0.1 | Kang | 新增Table组件
2018.01.17 | V0.0.2 | Kang | 新增filterClear自定义渲染方法+修复设置scrollY时头部高度的变化
2018.02.19 | V0.0.3 | Kang | 修复Input无法输入中文+筛选可设置默认值

<br><br/>
### 2.安装方式
<code>
npm install irs-table
</code>

<br><br/><br><br/>
### 3. 调用方式


####  默认的一些下拉筛选框 + 排序
```jsx
const btnStyle={ 
    marginBottom:'10px', 
}

const sortbyName = function(a,b){
    return (a.name ? a.name.charCodeAt() : "") -
            (b.name ? b.name.charCodeAt() : "")
}
const sortbyDepartment = function(a,b){
    return (a.department ? a.department.charCodeAt() : "") -
            (b.department ? b.department.charCodeAt() : "")
}
const sortbyPhoneNum = function(a,b){
    return (a.phoneNum ? a.phoneNum : "") -
            (b.phoneNum ? b.phoneNum : "")
}
const sortbySex = function(a,b){
    return (a.sortbySex ? a.sortbySex.charCodeAt() : "") -
            (b.sortbySex ? b.sortbySex.charCodeAt() : "")
}

const sortbyName1 = function(a,b){
    return  (b.name ? b.name.charCodeAt() : "") - 
             (a.name ? a.name.charCodeAt() : "")
}
const sortbyDepartment1 = function(a,b){
    return (b.department ? b.department.charCodeAt() : "") -
            (a.department ? a.department.charCodeAt() : "")   
}
const sortbyPhoneNum1 = function(a,b){
    return (b.phoneNum ? b.phoneNum : "") -
            (a.phoneNum ? a.phoneNum : "")          
}
const sortbySex1 = function(a,b){
    return (b.sortbySex ? b.sortbySex.charCodeAt() : "") -
            (a.sortbySex ? a.sortbySex.charCodeAt() : "")         
}

class IrsTableDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        showSort: false,
        btnTitle: '打开筛选',
        loading: false,
        dataSource1: undefined,
        dataSource: [
            {
                key:1,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
            },
            {
                key:2,
                name: 'Well',
                department: '董事会',
                phoneNum: '13883333333',
                sex: '男',
                postion: '董事会主席',
            },
            {
                key:4,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
            },
            {
                key:3,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
            }
        ],      
        menu: [{
            key: 0,
            text: '查看',
            title: '查看',
        },
        {
            key: 1,
            text: '修改信息',
            title: '修改信息',
        }] 
    }
    this.getColumns = this.getColumns.bind(this)
    this.onClick = this.onClick.bind(this)
    this.sortChange = this.sortChange.bind(this)
    this.filterChange = this.filterChange.bind(this)
    this.getRowSelection = this.getRowSelection.bind(this)
    this.onChange = this.onChange.bind(this)
    this.clearFliterData = this.clearFliterData.bind(this)
  }

  getColumns() {
      const menu = (
         <IrsMenu dataSource={this.state.menu} />
        );
      let columns = [
          {
            title: '姓名',
            dataIndex: 'name',
            canFilter: true,
            width:120,
            tableFilter: {
                sortType: 'Input',
                defaultValue: '123',
                selectArray: [
                    {
                        id: 'Well',
                        name: 'Well'
                    },
                    {
                        id:'张扬',
                        name:'张扬'
                    },
                    {
                        id:'王伟',
                        name:'王伟'
                    },
                    {
                        id:'Allen',
                        name:'Allen'
                    },
                ]
            }
          },
          {
 
            title: '部门',
            dataIndex: 'department',
            canFilter: true,
            // align: 'center',
            width: 100,
            tableFilter: {
                sortType: 'SelectSerarch',
                disabled: true,
                selectArray: [
                    {
                        id:'id2-1',
                        name:'name2-1'
                    },
                    {
                        id:'id2-2',
                        name:'name2-2'
                    },
                ]
            }
          },
          {

            title: '手机号',
            dataIndex: 'phoneNum',
            canFilter: true,
            width: 200,
            tableFilter: {
                sortType:'TimePicker',
            }
          },
          {

            title: '性别',
            dataIndex: 'sex',
            canFilter: true,
            width: 200,
            tableFilter: {
                sortType:'Select',
                selectArray:[
                    {
                        id:'男',
                        name:'男'
                    },
                    {
                        id:'女',
                        name:'女'
                    },
                ]
            }
          },
          {
            title: '操作',
            dataIndex: '',
            width: 80,
            sorter: false,
            // fixed: 'right',
            showClearFilter: true,
            render: (text, record, index) => {
                const obj = {
                    children: (<IrsDropdown overlay={menu} trigger="hover"><a>...</a></IrsDropdown>)
                };
                return obj;
            },
          },
      ]
      return columns;
  }

  getRowSelection () {
      const rowSelection = {
          fixed: 'left',
      }
      return rowSelection
  }

  

  onClick() {
      if (this.state.showSort) {
          this.setState({
              showSort: false,
              btnTitle:'打开筛选'
          })
      } else {
          this.setState({
              showSort: true,
              btnTitle:'关闭筛选'
          })
      }
  }

  sortChange(showSort) {

      if (!showSort) {
          this.setState({
              showSort: false,
              btnTitle:'打开筛选'
          })
      } else {
          this.setState({
              showSort: true,
              btnTitle:'关闭筛选'
          })
      }
  }

  

  filterChange(filter) {
    console.log(filter)

    this.setState({
        loading: true
    })

    setTimeout(() => {
        let dataSources = []

        let hasValue = false
        filter.map((item) => {
            if (item.value){
                hasValue = true
            }
        })

        if (!hasValue) {
            const dataSource1 = undefined
            this.setState({
                dataSource1,
                loading: false
            })
        } else {
            filter.map((item) => {
                if (item.dataIndex === 'name') {
                    this.state.dataSource.map((item1) => {
                        if (item.value === item1.name) {
                            dataSources.push(item1)
                        }
                    })
                }
            })
            if (dataSources.length === 0) {
                dataSources = this.state.dataSource
            }

            let existSex = false
            let dataSource1 = []
            filter.map((item) => {
                if (item.dataIndex === 'sex' && item.value) {
                    existSex = true;
                }
            })

            if (!existSex) {
                dataSource1 = dataSources   
            } else {
                filter.map((item) => {
                    if (item.dataIndex === 'sex') {
                        dataSources.map((item1) => {
                            if (item1.sex === item.value) {
                                dataSource1.push(item1)
                            }
                        })
                    }
                })
            }
            this.setState({
                dataSource1,
                loading: false
            })
        }
    } , 1000);
  }

  clearFliterData() {
      this.setState({
        loading: true
      })

      setTimeout(() => {
        this.setState({
            loading: false,
            dataSource1: undefined
        })
      } , 1000);
  }

  onChange(sorter) {
      console.log(sorter)

      this.setState({
        loading: true
      })

      setTimeout(() => {
            const dataSource = JSON.stringify(this.state.dataSource)
            let dataSource1 = JSON.parse(dataSource);
            
            if (sorter.order === 'descend') {
                if (sorter.field === 'name') {
                    dataSource1 = dataSource1.sort(sortbyName)
                } else if (sorter.field === 'department') {
                    dataSource1 = dataSource1.sort(sortbyDepartment)
                } else if (sorter.field === 'phoneNum') {
                    dataSource1 = dataSource1.sort(sortbyPhoneNum)
                } else if (sorter.field === 'sex') {
                    dataSource1 = dataSource1.sort(sortbySex)
                }
            } else if (sorter.order === 'ascend') {
                if (sorter.field === 'name') {
                    dataSource1 = dataSource1.sort(sortbyName1)
                } else if (sorter.field === 'department') {
                    dataSource1 = dataSource1.sort(sortbyDepartment1)
                } else if (sorter.field === 'phoneNum') {
                    dataSource1 = dataSource1.sort(sortbyPhoneNum1)
                } else if (sorter.field === 'sex') {
                    dataSource1 = dataSource1.sort(sortbySex1)
                }
            } else {
                dataSource1 = []
            }

            if (dataSource1.length === 0) {
                dataSource1 = undefined
            }

            this.setState({
                dataSource1,
                loading: false
            })
      } , 1000);
  }

render() {
    const columns = this.getColumns()
    const rowSelection = this.getRowSelection()
    return (
        <IrsRow>
            <IrsCol span = {24}>
                <IrsButton style={btnStyle} type="Default" onClick={this.onClick}>{ this.state.btnTitle }</IrsButton>
            </IrsCol>
            <IrsCol span = {24}>
                 <IrsTable
                    loading = {this.state.loading}
                    columns = {columns}
                    dataSource = {this.state.dataSource1 !== undefined ? this.state.dataSource1 : this.state.dataSource}
                    showFilter = {this.state.showSort}
                    onChange = {this.onChange}
                    filterChange = {this.filterChange}
                    clearFliterData = {this.clearFliterData}
                />
            </IrsCol>
        </IrsRow>
    )
  }
}
;<IrsTableDemo />
```


#### 自定义下拉筛选框 + 全选 
```jsx
const btnStyle={ 
    marginBottom:'10px', 
}
class IrsTableDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        showSort: false,
        btnTitle: '打开筛选',
        dataSource: [
            {
                key:1,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
                icon: 'A',
            },
            {
                key:2,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
                icon: 'W',
            },
            {
                key:3,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
                icon: '张',
            },
            {
                key:4,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
                icon: '王',
            }
        ],       
       menu: [{
            key: 0,
            text: '查看',
            title: '查看',
        },
        {
            key: 1,
            text: '修改信息',
            title: '修改信息',
        }]
    }
    this.getColumns = this.getColumns.bind(this)
    this.getRowSelection = this.getRowSelection.bind(this)
    this.onClick = this.onClick.bind(this)
  }

  onClick() {
      if (this.state.showSort) {
          this.setState({
              showSort: false,
              btnTitle:'打开筛选'
          })
      } else {
          this.setState({
              showSort: true,
              btnTitle:'关闭筛选'
          })
      }
  }

  sortChange(showSort) {

      if (!showSort) {
          this.setState({
              showSort: false,
              btnTitle:'打开筛选'
          })
      } else {
          this.setState({
              showSort: true,
              btnTitle:'关闭筛选'
          })
      }
  }

  getColumns() {
      const menu = (
         <IrsMenu dataSource={this.state.menu} />
        );
      let columns = [
          {
            title: '姓名',
            dataIndex: 'name',
            fixed:'left',
            sorter: false,
            canFilter: true,
            width:120,
            tableFilter: {
                sortType: 'SelectSerarch',
                selectArray: [
                    {
                        id:'Allen',
                        name:'Allen'
                    },
                    {
                        id:'Well',
                        name:'Well'
                    },
                ]
            }
          },
          {
 
            title: '部门',
            dataIndex: 'department',
            canFilter: false,
            sorter: false,
            align: 'center',
            width: 200,
          },
          {

            title: '手机号',
            dataIndex: 'phoneNum',
            canFilter: true,
            sorter: false,
            width: 200,
            tableFilter: {
                sortType:'Custom',
                sortCustomView: (record) => {
                    return (
                         <span>{ '自定义筛选 '  }</span>
                    )
                }
            }
          },
          {
            title: '性别',
            dataIndex: 'sex',
            sorter: false,
            canFilter: true,
            width: 200,
            tableFilter: {
                sortType:'Select',
                selectArray:[
                    {
                        id:'男',
                        name:'男'
                    },
                    {
                        id:'女',
                        name:'女'
                    },
                ]
            }
          },
          {
            title: '职位',
            sorter: false,
            dataIndex: 'postion',
            canFilter: true,
            width: 200,
          },
          {
            title: '操作',
            dataIndex: '',
            align:'center',
            sorter: false,
            width: 80,
            fixed: 'right',
            showClearFilter: true,
            render: (text, record, index) => {
                const obj = {
                    children: (<IrsDropdown overlay={menu} trigger="hover"><a>...</a></IrsDropdown>)
                };
                return obj;
            },
          },
      ]
      return columns;
  }

  getRowSelection () {
      const rowSelection = {
          
      }
      return rowSelection
  }

render() {
    const columns = this.getColumns()
    const rowSelection = this.getRowSelection()
    return (
        <IrsRow>
            <IrsCol span = {24}>
                <IrsButton type="Default" style={btnStyle}onClick={this.onClick}>{ this.state.btnTitle }</IrsButton>
            </IrsCol>
            <IrsCol span = {24}>
                 <IrsTable
                    size = 'small'
                    bordered = { true }
                    columns = {columns}
                    dataSource = {this.state.dataSource}
                    showFilter = {this.state.showSort}
                    rowSelection = {rowSelection} 
                    scroll = { scroll.x = true }
                />
            </IrsCol>
        </IrsRow>
    )
  }
}
;<IrsTableDemo />
```


####  自定义头部 + 尾部 + 左右列固定
```jsx
class IrsTableDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        showSort: false,
        dataSource: [
            {
                key:1,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
                icon:'A',
            },
            {
                key:2,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
                icon:'W',
            },
            {
                key:3,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
                icon:'张',
            },
            {
                key:4,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
                icon:'王',
            }
        ],  
        menu: [{
            key: 0,
            text: '查看',
            title: '查看',
        },
        {
            key: 1,
            text: '修改信息',
            title: '修改信息',
        }]     
    }
    this.getColumns = this.getColumns.bind(this) 
    this.getTitle = this.getTitle.bind(this)
    this.getFooter = this.getFooter.bind(this)
  }

  getColumns() {
      const menu = (
         <IrsMenu dataSource={this.state.menu} />
        );
      let columns = [
          {
            title: '姓名',
            dataIndex: 'name',
            fixed:'left',
            sorter: false,
            width:120,
          },
          {
            title: '头像',
            dataIndex: 'icon',
            sorter: false,
            width: 200,
            render: (text, record, index) => {
                const obj = {
                    children: (<IrsAvatar style={{ color: '#f56a00', height: '30px', width: '30px' }}>{text}</IrsAvatar>)
                };
                return obj;
            },
          },
          {

            title: '手机号',
            dataIndex: 'phoneNum',
            sorter: false,
            width: 200,
          },
          {

            title: '性别',
            dataIndex: 'sex',
            sorter: false,
            width: 200,
          },
          {

            title: '职位',
            sorter: false,
            dataIndex: 'postion',
            width: 200,
          },
          {
            title: '操作',
            dataIndex: '',
            width: 80,
            fixed: 'right',
            sorter: false,
            showClearFilter: true,
            render: (text, record, index) => {
                const obj = {
                    children: (<IrsDropdown overlay={menu} trigger="hover"><a>...</a></IrsDropdown>)
                };
                return obj;
            },
          },
      ]
      return columns;
  }

    getTitle() {
        return (
            <div>表格头部</div>
        )
    }

    getFooter() {
        return (
            <div>表格尾部</div>
        )
    }

render() {
    const columns = this.getColumns()
    return (
        <IrsRow>
            <IrsCol span = {24}>
                 <IrsTable
                    scroll={{ x: 1100 }}
                    columns = {columns}
                    dataSource = {this.state.dataSource}
                    title = {this.getTitle}
                    footer = {this.getFooter}
                />
            </IrsCol>
        </IrsRow>
    )
  }
}
;<IrsTableDemo />
```


####  嵌套子表格
```jsx
class IrsTableDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        showSort: false,
        dataSource: [
            {
                key:1,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                children: [
                    {
                        key: 3,
                        name: '张扬',
                        department: '技术部/一组',
                        phoneNum: '13266666666',
                    }
                ]
            },
            {
                key:2,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                children: [
                    {
                        key: 4,
                        name: '王伟',
                        department: '技术部/二组',
                        phoneNum: '13222222222',
                    }
                    
                ]
            },
        ],
        menu: [{
            key: 0,
            text: '查看',
            title: '查看',
        },
        {
            key: 1,
            text: '修改信息',
            title: '修改信息',
        }]
    }
    this.getColumns = this.getColumns.bind(this) 
    this.getTitle = this.getTitle.bind(this)
    this.getFooter = this.getFooter.bind(this)
  }

  getColumns() {
      const menu = (
         <IrsMenu dataSource={this.state.menu} />
        );
      let columns = [
          {
            title: '姓名',
            dataIndex: 'name',
            width:120,          
            sorter: false,
          },
          {
            title: '部门',
            dataIndex: 'department',
            width: 200,
            sorter: false,
          },
          {
            title: '手机号',
            dataIndex: 'phoneNum',
            width: 200,
            sorter: false,
          },
          {
            title: '操作',
            dataIndex: '',
            width: 80,
            sorter: false,
            render: (text, record, index) => {
                const obj = {
                    children: (<IrsDropdown overlay={menu} trigger="hover"><a>...</a></IrsDropdown>)
                };
                return obj;
            },
          },
      ]
      return columns;
  }

    getTitle() {
        return (
            <div>表格头部</div>
        )
    }

    getFooter() {
        return (
            <div>表格尾部</div>
        )
    }

render() {
    const columns = this.getColumns()
    return (
        <IrsRow>
            <IrsCol span = {24}>
                 <IrsTable
                    columns = {columns}
                    dataSource = {this.state.dataSource}
                />
            </IrsCol>
        </IrsRow>
    )
  }
}
;<IrsTableDemo />
```

####  table + pagination
```jsx
const paginationStyle={ 
    marginTop:'10px', 
}
class IrsTableDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        showSort: false,
        current: 1,
        pageSize: 10,
        total: 20,
        dataSource1: [
            {
                key:1,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
            },
            {
                key:2,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
            },
            {
                key:4,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
            },
            {
                key:3,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
            },
            {
                key:5,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
            },
            {
                key:6,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
            },
            {
                key:7,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
            },
            {
                key:8,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
            },
            {
                key:9,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
            },
            {
                key:10,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
            },
        ],

        dataSource2: [
            {
                key:11,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
            },
            {
                key:12,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
            },
            {
                key:13,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
            },
            {
                key:14,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
            },
            {
                key:15,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
            },
            {
                key:16,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
            },
            {
                key:17,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
            },
            {
                key:18,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
            },
            {
                key:19,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
            },
            {
                key:20,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
            }
        ],
        menu: [{
            key: 0,
            text: '查看',
            title: '查看',
        },
        {
            key: 1,
            text: '修改信息',
            title: '修改信息',
        }]
    }
    this.getColumns = this.getColumns.bind(this) 
    this.getTitle = this.getTitle.bind(this)
    this.getFooter = this.getFooter.bind(this)
    this.onChange = this.onChange.bind(this)
    this.onShowSizeChange = this.onShowSizeChange.bind(this)
    this.getDataSource = this.getDataSource.bind(this)
  }

  getColumns() {
      const menu = (
         <IrsMenu dataSource={this.state.menu} />
        );
      let columns = [
          {
            title: '姓名',
            dataIndex: 'name',
            sorter: false,
            width:200,
          },
          {
 
            title: '部门',
            dataIndex: 'department',
            sorter: false,
            width: 200,
          },
          {

            title: '手机号',
            dataIndex: 'phoneNum',
            sorter: false,
            width: 200,
          },
          {

            title: '性别',
            dataIndex: 'sex',
            sorter: false,
            width: 200,
          },
          {

            title: '职位',
            dataIndex: 'postion',
            sorter: false,
            width: 200,
          },
          {
            title: '操作',
            dataIndex: '',
            width: 80,
            sorter: false,
            render: (text, record, index) => {
                const obj = {
                    children: (<IrsDropdown overlay={menu} trigger="hover"><a>...</a></IrsDropdown>)
                };
                return obj;
            },
          },
      ]
      return columns;
  }

    getTitle() {
        return (
            <div>表格头部</div>
        )
    }

    getFooter() {
        return (
            <div>表格尾部</div>
        )
    }

    onChange(page, pageSize) {
        this.setState({
            current: page
        })
    }

    onShowSizeChange(current, size) {
        if (size > 10) {
            this.setState({
            current: 1
        })
        }
        this.setState({
            pageSize: size
        })
    }

    getDataSource () {
        if (this.state.pageSize === 10) {
            if (this.state.current === 1) {
                return this.state.dataSource1
            } else {
                return this.state.dataSource2
            }
        } else {
            return this.state.dataSource1.concat(this.state.dataSource2)
        }
    }

render() {
    const columns = this.getColumns()
    const dataSource = this.getDataSource()
    return (
        <IrsRow>
            <IrsCol span = {24}>
                 <IrsTable
                    columns = {columns}
                    dataSource = {dataSource}
                    title = {this.getTitle}
                    footer = {this.getFooter}
                />
            </IrsCol>
            <IrsCol style={paginationStyle} span = {24}>
                <IrsPagination 
                    textAlign = 'right'
                    defaultCurrent={1}
                    defaultPageSize={10}
                    current = {this.state.current}
                    pageSize = {this.state.pageSize}
                    showQuickJumper = {true}
                    showSizeChanger = {true}
                    onChange = {this.onChange}
                    onShowSizeChange = {this.onShowSizeChange}
                    total = {this.state.total}
                />
            </IrsCol>
        </IrsRow>
    )
  }
}
;<IrsTableDemo />
```

####  自定义配置表格
```jsx
const spanStyle = {
    float: 'right',
    marginRight: '5px',
    marginBottom: '10px',
}

const expandedRowRender = record => <span>{record.description}</span>;

class IrsTableDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        showSort: false,
        loading: false,
        bordered: false,
        size: 'default',
        expand: false,
        
        showHeader: true,
        footer: false,
        rowSelection: undefined,
        hasData: true,
        needToolTip: false,
        showTitle: false,

        dataSource: [
            {
                key:1,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
                description: '这是扩展行',
            },
            {
                key:2,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
                description: '这是扩展行',
            },
            {
                key:4,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
                description: '这是扩展行',
            },
            {
                key:3,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
                description: '这是扩展行',
            }
        ],       
        menu: [{
            key: 0,
            text: '查看',
            title: '查看',
        },
        {
            key: 1,
            text: '修改信息',
            title: '修改信息',
        }]
    }
    this.getColumns = this.getColumns.bind(this) 
    this.getTitle = this.getTitle.bind(this)
    this.getFooter = this.getFooter.bind(this)
    this.loadingOnChange = this.loadingOnChange.bind(this)
    this.borderedOnChange = this.borderedOnChange.bind(this)
    this.showHeaderOnChange = this.showHeaderOnChange.bind(this)
    this.checkboxOnChange = this.checkboxOnChange.bind(this)
    this.titleOnChange = this.titleOnChange.bind(this)
    this.footerOnChange = this.footerOnChange.bind(this)
    this.sizeOnChange = this.sizeOnChange.bind(this)
    this.dataOnChange = this.dataOnChange.bind(this)
    this.expandOnChange = this.expandOnChange.bind(this)
    this.toolTopOnChange = this.toolTopOnChange.bind(this)
  }

  getColumns() {
      const menu = (
         <IrsMenu dataSource={this.state.menu} />
        );
      let columns = [
          {
            title: '姓名',
            dataIndex: 'name',
            needToolTip: this.state.needToolTip,
            sorter: false,
          },
          {
            title: '部门',
            dataIndex: 'department',
            needToolTip: this.state.needToolTip,
            sorter: false,
          },
          {
            title: '手机号',
            dataIndex: 'phoneNum',
            needToolTip: this.state.needToolTip,
            sorter: false,
          },
          {
            title: '性别',
            dataIndex: 'sex',
            needToolTip: this.state.needToolTip,
            sorter: false,
          },
          {
            title: '操作',
            dataIndex: '',
            width:80,
            sorter: false,
            sorter: false,
            render: (text, record, index) => {
                const obj = {
                    children: (<IrsDropdown overlay={menu} trigger="hover"><a>...</a></IrsDropdown>)
                };
                return obj;
            },
          },
      ]
      return columns;
  }

    getTitle() {
        return (
            <div>表格头部</div>
        )
    }

    getFooter() {
        return (
            <div>表格尾部</div>
        )
    }

    loadingOnChange(checked) {
        this.setState({
            loading: checked
        })
    }

    borderedOnChange(checked) {
        this.setState({
            bordered: checked
        })
    }

    showHeaderOnChange(checked) {
        this.setState({
            showHeader: checked
        })
    }

    checkboxOnChange(checked) {
        this.setState({
            rowSelection: checked ? {} : undefined
        })
    }
    
    titleOnChange(checked) {
        this.setState({
            showTitle: checked
        })
    }

    footerOnChange(checked) {
        this.setState({
            footer: checked
        })
    }

    sizeOnChange(checked) {
        this.setState({
            size: !checked ? 'default' : 'small'
        })
    }
    
    dataOnChange(checked) {
        this.setState({
            hasData: checked
        })
    }
    
    expandOnChange(checked) {
        this.setState({
            expand: checked
        })
    }

    toolTopOnChange(checked) {
        this.setState({
            needToolTip: checked
        })
    }

render() {
    
    const columns = this.getColumns()
    return (
        <div>
            <IrsRow justify = 'center'>
                <IrsCol span = {2}><span style={spanStyle}>loading:</span></IrsCol> <IrsCol span = {2}> <IrsSwitch onChange={this.loadingOnChange} defaultChecked = {false}/></IrsCol>

                <IrsCol span = {2}><span style={spanStyle}>Bordered:</span></IrsCol> <IrsCol span = {2}> <IrsSwitch onChange={this.borderedOnChange} defaultChecked = {false}/></IrsCol>

                <IrsCol span = {2}><span style={spanStyle}>showHeader:</span></IrsCol> <IrsCol span = {2}> <IrsSwitch onChange={this.showHeaderOnChange} defaultChecked = {true}/></IrsCol>

                <IrsCol span = {2}><span style={spanStyle}>checkbox:</span></IrsCol> <IrsCol span = {2}> <IrsSwitch onChange={this.checkboxOnChange} defaultChecked = {false}/></IrsCol>

                <IrsCol span = {2}><span style={spanStyle}>title:</span></IrsCol> <IrsCol span = {2}> <IrsSwitch onChange={this.titleOnChange} defaultChecked = {false}/></IrsCol>

                <IrsCol span = {2}><span style={spanStyle}>footer:</span></IrsCol> <IrsCol span = {2}> <IrsSwitch onChange={this.footerOnChange} defaultChecked = {false}/></IrsCol>

            </IrsRow>

            <IrsRow>
                <IrsCol span = {2}><span style={spanStyle}>size:</span></IrsCol> <IrsCol span = {2}> <IrsSwitch checkedChildren="default" unCheckedChildren="small" onChange={this.sizeOnChange} defaultChecked = {false}/></IrsCol>

                <IrsCol span = {2}><span style={spanStyle}>Has Data:</span></IrsCol> <IrsCol span = {2}> <IrsSwitch  onChange={this.dataOnChange} defaultChecked = {true}/></IrsCol>

                <IrsCol span = {2}><span style={spanStyle}>Expandable:</span></IrsCol> <IrsCol span = {2}> <IrsSwitch  onChange={this.expandOnChange} defaultChecked = {false}/></IrsCol>

                <IrsCol span = {2}><span style={spanStyle}>toolTip:</span></IrsCol> <IrsCol span = {2}> <IrsSwitch  onChange={this.toolTopOnChange} defaultChecked = {false}/></IrsCol>

            </IrsRow>

            <IrsRow>
                <IrsCol span = {24}>
                    <IrsTable
                        bordered = {this.state.bordered}
                        size = {this.state.size}
                        columns = {columns}
                        dataSource = { this.state.hasData ? this.state.dataSource : []}
                        loading = {this.state.loading}
                        showHeader = {this.state.showHeader}
                        rowSelection = {this.state.rowSelection}
                        title = {this.state.showTitle ? this.getTitle : undefined}
                        footer = {this.state.footer ? this.getFooter : undefined}
                        expandedRowRender = {this.state.expand ? expandedRowRender : undefined}
                    />
                </IrsCol>
            </IrsRow>
        </div>
    )
  }
}
;<IrsTableDemo />
```



####  table + tableconfigure
```jsx
const btnStyle={ 
    marginBottom:'10px', 
}
class IrsTableDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        showSort: false,
        size: 'default',
        bored: false,
        dataSource: [
            {
                key:1,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
                address: '上海',
            },
            {
                key:2,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
                address: '上海',
            },
            {
                key:4,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
                address: '上海',
            },
            {
                key:3,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
                address: '上海',
            },
            {
                key:5,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
                address: '上海',
            },
            {
                key:6,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
                address: '上海',
            },
            {
                key:7,
                name: '张扬',
                department: '技术部/一组',
                phoneNum: '13266666666',
                sex: '男',
                postion: '组长',
                address: '上海',
            },
            {
                key:8,
                name: '王伟',
                department: '技术部/二组',
                phoneNum: '13222222222',
                sex: '男',
                postion: '组长',
                address: '上海',
            },
            {
                key:9,
                name: 'Allen',
                department: '董事会',
                phoneNum: '13488888888',
                sex: '男',
                postion: '董事会主席',
                address: '上海',
            },
            {
                key:10,
                name: 'Well',
                department: '董事会',
                phoneNum: '13888888888',
                sex: '男',
                postion: '董事会主席',
                address: '上海',
            },
        ],

        menu: [{
            key: 0,
            text: '查看',
            title: '查看',
        },
        {
            key: 1,
            text: '修改信息',
            title: '修改信息',
        }],

      showModal: false,
   
      selectedDataSource: [],

      leftDataSource: [
      ],
      rightDataSource: [
        {
            key:'name',
            title:'姓名',
            fixed: true,
            canHide: false,
            code:'name',
            width: 120,
        },
        {
            key:'department',
            title:'部门',
            fixed: false,
            canHide: true,
            code:'department',
            width: 150,
        },
        {
            key:'phoneNum',
            title:'手机号',
            fixed: false,
            canHide: true,
            code:'phoneNum',
            width: 150,
        },
        {
            key:'sex',
            title:'性别',
            fixed: false,
            canHide: true,
            code:'sex',
            width: 100,
        },
        {
            key:'address',
            title:'地址',
            fixed: false,
            canHide: true,
            code:'address',
            width: 120,
        },
        {
            key:'postion',
            title:'职位',
            fixed: false,
            canHide: true,
            code:'postion',
            width: 100,
        },
      ]
    }
    this.btnClick = this.btnClick.bind(this)
    this.onCancel = this.onCancel.bind(this)
    this.onOk = this.onOk.bind(this)
    this.getColumns = this.getColumns.bind(this) 
    this.onClick = this.onClick.bind(this)
  }


  getColumns() {
    const menu = (
        <IrsMenu dataSource={this.state.menu} />
    );

    const columns = [];

    this.state.rightDataSource.map((item) => {
        columns.push({
            title: item.title,
            dataIndex: item.key,
            sorter: false,
            width: item.width,
            fixed: item.fixed ? 'left' : false,
        }) 
    })

    columns.push({
        title: '操作',
        dataIndex: '',
        sorter: false,
        width: 80,
        fixed: false,
        render: (text, record, index) => {
                const obj = {
                    children: (<IrsDropdown overlay={menu} trigger="hover"><a>...</a></IrsDropdown>)
                };
                return obj;
            },
    })
         
    return columns
  }

    btnClick() {
        this.setState({
        showModal: true
        })
    }

    onCancel() {
        this.setState({
        showModal: false
        })
    }

    onOk(dataSource, targetKeys, selectedKeys, showBorder, size) {
        this.setState({
            showModal: false,
            size: size,
            bored: showBorder,
            leftDataSource: dataSource,
            rightDataSource: targetKeys,
            selectedDataSource: selectedKeys
        })

        console.log(dataSource)
        console.log(targetKeys)
        console.log(selectedKeys)
        console.log(showBorder)
        console.log(size)
    }

    getDataSource () {
        if (this.state.pageSize === 10) {
            if (this.state.current === 1) {
                return this.state.dataSource1
            } else {
                return this.state.dataSource2
            }
        } else {
            return this.state.dataSource1.concat(this.state.dataSource2)
        }   
    }

    onClick () {
        this.setState({
            showModal: true
        })
    }

render() {
    const columns = this.getColumns()
    let scrollX = 0;
    this.state.rightDataSource.map((item) => {
        scrollX = scrollX + item.width
    })
    return (
        <IrsRow>

            <IrsCol span = {24}>
                <IrsButton style={btnStyle} type="Default" onClick={this.onClick}>配置</IrsButton>
            </IrsCol>

            <IrsCol span = {24}>
                 <IrsTable
                    size = {this.state.size}
                    bordered = {this.state.bored}
                    // scroll = { x=scrollX, y=scrollY }
                    scroll={{ x: 1000, y:100 }}
                    columns = {columns}
                    dataSource = {this.state.dataSource}
                />
            </IrsCol>
            
            <IrsTableConfigure 
                visible = {this.state.showModal}
                onCancel = {this.onCancel}
                onOk = {this.onOk}
                size={this.state.size}
                showBorder={this.state.bored}
                leftDataSource = {this.state.leftDataSource}
                rightDataSource = {this.state.rightDataSource}
                selectedDataSource = {this.state.selectedDataSource}
            />
        </IrsRow>
    )
  }
}
;<IrsTableDemo />
```