export interface IrsTransferItem {
    /** 唯一的key值 */
    key: string;

    /** title */
    title: string;

    /** 是否固定 */
    fixed: boolean,

    /** 是否不可选 */
    // canHide: boolean,

    /** 宽度 */
    // width: number,

    /** 自定义右边的视图 右侧是生效 */
    renderRightContiner?: (item: IrsTransferItem) => React.ReactNode;
}


export interface IPropsInterface {

    /** id */
    id?: string;

    /** style */
    style?: any;

    /** className */
    className?: string;

    /** 对话框是否可见 默认false */
    visible?: boolean;

    /** 设置 Modal 的 z-index 默认1000 */
    zIndex?: number;

    /** 点击遮罩层或右上角叉或取消按钮的回调 */
    onCancel?: (e: React.MouseEvent<any>) => void;

    /** 点击确定回调 */
    onOk?: (dataSource: any[], targetKeys: string[], selectedKeys: string[], showBorder: boolean, size: string) => void;

    /** 点击蒙层是否允许关闭 默认true */
    maskClosable?: boolean;

    /** 是否展示遮罩 默认true */
    mask?: boolean;

    /** 关闭时销毁 Modal 里的子元素 默认true */
    destroyOnClose?: boolean;

    /** 确定按钮 loading  默认false */
    confirmLoading?: boolean;

    /** 是否展示边框 默认false */
    showBorder?: boolean;

    /** 表格的大小  默认default */
    size?: 'small' | 'default';

    /** 左边的数据源 */
    leftDataSource?: IrsTransferItem[];

    /** 右边的数据源 */
    rightDataSource?: IrsTransferItem[];

    /** 选中的 */
    selectedDataSource?: IrsTransferItem[];

    /** 右边数据需要排序  默认true */
    rightDataNeedSort?: boolean;

    /** 最多固定的数量 默认3 */
    maxfixkeyCount?: number;

    /** 达到最大固定数量后的回调 */
    maxCountDeal?: () => void;
}

