### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.15 | V0.0.1 | Kang | 新增TableConfigure组件
2019.1.25 | V0.0.2 | Gail | 组件可拖动文字改为可移动, title显示过长出现省略号, 修复锁定状态在还未保存情况下就被修改的bug, 修复maskClosable属性不生效问题

<br><br/>
### 2.安装方式
<code>
npm install irs-tableconfigure
</code>

<br><br/><br><br/>
### 3. 调用方式


```jsx
class IrsTableConfigureDemo extends React.Component {
  constructor() {
    super()
    this.state = {

      showModal: false,
      targetKeys: [
        {
          key:'6',
          title:'特长-- 6',
          fixed: true,
          canHide: false,
          width: 100,
        },
        {
          key:'8',
          title:'自定义 -- 8',
          fixed: true,
          canHide: true,
          width: 100,
        },
        {
          key:'7',
          title:'好爱 -- 7',
          fixed: false,
          canHide: true,
          width: 100,
        },
      ],
      selectedKeys: [],

      dataSource: [
        {
          key:'1',
          title:'姓名 -- 1',
          fixed: false,
          canHide: true,
          width: 100,
        },
        {
          key:'2',
          title:'年龄 -- 2',
          fixed: false,
          canHide: true,
          width: 100,
        },
        {
          key:'3',
          title:'地址 -- 3',
          fixed: false,
          canHide: true,
          width: 100,
        },
        {
          key:'4',
          title:'电话 -- 4',
          fixed: false,
          canHide: true,
          width: 100,
        },
        {
          key:'5',
          title:'身份证 -- 5',
          fixed: false,
          canHide: true,
          width: 100,
        },
      ]
    },
    this.btnClick = this.btnClick.bind(this)
    this.onCancel = this.onCancel.bind(this)
    this.onOk = this.onOk.bind(this)
  }

  btnClick() {
    this.setState({
      showModal: true
    })
  }

  onCancel() {
    this.setState({
      showModal: false
    })
  }

  onOk(dataSource, targetKeys, selectedKeys, showBorder, size) {
    this.setState({
      showModal: false
    })
    console.log(dataSource)
    console.log(targetKeys)
    console.log(selectedKeys)
    console.log(showBorder)
    console.log(size)
  }

  render() {
    return (
      <IrsRow>
        <IrsCol>
            <IrsButton onClick={this.btnClick} >显示/关闭 table配置</IrsButton>
            <IrsTableConfigure 
              visible = {this.state.showModal}
              leftDataSource = {this.state.dataSource}
              onCancel = {this.onCancel}
              onOk = {this.onOk}
              rightDataSource = {this.state.targetKeys}
              selectedDataSource = {this.state.selectedKeys}
            />
        </IrsCol>
      </IrsRow>
    )
  }
}
;<IrsTableConfigureDemo />
```