/**
 * The only true tab.
 * @date 2018.12.01
 * @version 0.0.1
 * @author Kang
 */
import * as React from 'react';
import * as module from './module';
import './style.less';
import { others } from 'fit-transmit-transparently';
import { Switch, Icon, message } from 'antd';
import RadioGroup from 'antd/lib/radio/group';
import RadioButton from 'antd/lib/radio/radioButton';

import IrsTransfer from '../../../componsties/irs-transfer'
import IrsModal from '../../irs-modal'


const modalWidth = '680px'

class IrsTableConfigure extends React.Component<module.IPropsInterface, any> {

    static defaultProps = {
        visible: false,
        zIndex: 1000,
        maskClosable: true,
        mask: true,
        destroyOnClose: true,
        confirmLoading: false,

        showBorder: false,
        size: 'default',

        rightDataNeedSort: true,
        maxfixkeyCount: 3,
    }
    constructor(props: module.IPropsInterface) {
        super(props);
        this.state = {
            dataSource: [],
            targetKeys: [],
            selectedKeys: [],
            checked: false,
            value: '0'
        }

        this.renderTransferListContent = this.renderTransferListContent.bind(this)
        this.onOk = this.onOk.bind(this)
        this.deepCopy = this.deepCopy.bind(this)
        this.arrDeepCopy = this.arrDeepCopy.bind(this)
        this.setOriginData = this.setOriginData.bind(this)
        this.upClick = this.upClick.bind(this)
        this.getRightRendView = this.getRightRendView.bind(this)
    }

    componentWillMount() {
        this.setOriginData(this.deepClone(this.props))
    }

    componentWillReceiveProps(nextProps: any) {
        this.setOriginData(this.deepClone(nextProps))
    }

    setOriginData(props: any) {

        props.leftDataSource.map((item: any, index: any) => {
            item.isLeft = true;
            item.disabled = false;
        })

        props.rightDataSource.map((item: any, index: any) => {
            item.isLeft = false;
            item.disabled = item.fixed;
        })

        const dataSource = props.leftDataSource.concat(props.rightDataSource)
        const targetKeys: string[] = []
        dataSource.map((item: any, index: any) => {
            if (!item.isLeft) {
                targetKeys.push(item.key)
            }
        })
        const selectedKeys: string[] = []
        props.selectedDataSource.map((item: any, index: any) => {
            selectedKeys.push(item.key)
        })

        this.setState({
            dataSource,
            targetKeys,
            selectedKeys,
            size: this.props.size,
            showBorder: this.props.showBorder,
            checked: props.showBorder,
            value: props.size === 'default' ? "0" : "1"
        })
    }

    deepClone = (obj: any) => {
        const result = typeof obj.splice === "function" ? [] : {};
        if (obj && typeof obj === 'object') {
            for (const key in obj) {
                if (obj[key] && typeof obj[key] === 'object') {
                    result[key] = this.deepClone(obj[key]);//如果对象的属性值为object的时候，递归调用deepClone,即在吧某个值对象复制一份到新的对象的对应值中。
                } else {
                    result[key] = obj[key];//如果对象的属性值不为object的时候，直接复制参数对象的每一个键值到新的对象对应的键值对中。
                }

            }
            return result;
        }
        return obj;
    }

    deepCopy(obj: any) {
        const newObj = {};
        if (typeof obj !== 'object') {
            return obj;
        } else {
            for (const attr in obj) {
                if (obj[attr]) {
                    newObj[attr] = this.deepCopy(obj[attr]);
                }
            }
        }
        return newObj;
    }

    arrDeepCopy(source: any) {
        const sourceCopy: any[] = [];
        for (const item in source) {
            if (typeof source[item] === 'object') {
                sourceCopy[item] = this.arrDeepCopy(source[item])
            } else {
                sourceCopy[item] = source[item];
            }
        }
        return sourceCopy;
    }

    canFixData = () => {
        const arr: string[] = [];
        this.state.targetKeys.map((items: string, index: any) => {
            this.state.dataSource.map((item1: any, index1: any) => {
                if (items === item1.key && item1.fixed) {
                    arr.push(items)
                }
            })
        })

        if (arr.length >= this.props.maxfixkeyCount) {
            if (this.props.maxCountDeal) {
                this.props.maxCountDeal()
            } else {
                message.error('最多固定' + this.props.maxfixkeyCount + '条')
            }
            return false;
        }
        return true;
    }

    clickIcon = (type: number, item: any, event: any) => {
        event.preventDefault();
        event.stopPropagation();

        if (!item.fixed && !this.canFixData()) {
            return
        }

        item.fixed = !item.fixed
        item.disabled = item.fixed

        const selectedKeys = this.state.selectedKeys

        if (item.fixed) {
            let indexs = -1;
            selectedKeys.map((item1: any, index: any) => {
                if (item.key === item1) {
                    indexs = index
                }
            })
            if (indexs !== -1) {
                selectedKeys.splice(indexs, 1)
            }
        }
        this.setState({
            selectedKeys
        }, () => {
            const arr1: string[] = []
            this.state.targetKeys.map((items: string, index: any) => {
                this.state.dataSource.map((item1: any, index1: any) => {
                    if (items === item1.key && item1.fixed) {
                        arr1.push(items)
                    }
                })
            })

            this.state.targetKeys.map((items: string, index: any) => {
                this.state.dataSource.map((item1: any, index1: any) => {
                    if (items === item1.key && !item1.fixed) {
                        arr1.push(items)
                    }
                })
            })

            this.setState({
                targetKeys: arr1
            })
        })
    }

    // 上移
    upClick = (item: any, event: Event) => {
        event.preventDefault();
        event.stopPropagation();

        const index = this.state.targetKeys.indexOf(item.key)
        //需要深拷贝一下 才起作用
        const targetKeys1 = this.arrDeepCopy(this.state.targetKeys)

        const dataSource1 = this.state.dataSource
        if (index > 0) {

            const previousKey = targetKeys1[index - 1];
            let previousItem: any;
            dataSource1.map((items: any, indexs: any) => {
                if (items.key === previousKey) {
                    previousItem = items
                }
            })

            if (!previousItem.fixed) {
                const value = targetKeys1[index]
                targetKeys1[index] = targetKeys1[index - 1]
                targetKeys1[index - 1] = value

                this.setState({
                    targetKeys: targetKeys1,
                })
            }
        }
    }

    // 下移
    downClick = (item: any, event: Event) => {
        event.preventDefault();
        event.stopPropagation();

        const index = this.state.targetKeys.indexOf(item.key)
        //需要深拷贝一下 才起作用
        const targetKeys1 = this.arrDeepCopy(this.state.targetKeys)

        if (index !== targetKeys1.length - 1) {

            const value = targetKeys1[index]
            targetKeys1[index] = targetKeys1[index + 1]
            targetKeys1[index + 1] = value

            this.setState({
                targetKeys: targetKeys1,
            })
        }
    }

    getRightRendView = (item: any) => {

        if (this.state.targetKeys.indexOf(item.key) === -1) {
            return ''
        } else if (item.renderRightContiner) {
            return item.renderRightContiner(item)
        } else if (item.fixed) { // 锁了
            return (
                <div className="rightContiner">
                    <span>
                        <Icon style={{ cursor: "pointer" }} onClick={this.clickIcon.bind(this, 0, item)} className="iconfont lockIcon rightContiner" type="lock" />
                    </span>

                </div>)
        } else { //未锁
            return (
                <div className="rightContiner">
                    <span style={{ marginRight: '10px' }}>
                        <Icon style={{ cursor: "pointer" }} onClick={this.upClick.bind(this, item)} className="iconfont lockIcon" type="up" />
                    </span>
                    <span style={{ marginRight: '10px' }}>
                        <Icon style={{ cursor: "pointer" }} onClick={this.downClick.bind(this, item)} className="iconfont lockIcon" type="down" />
                    </span>

                    <span>
                        <Icon style={{ cursor: "pointer" }} onClick={this.clickIcon.bind(this, 1, item)} className="iconfont lockIcon rightContiner" type="unlock" />
                    </span>
                </div>)
        }
    }

    renderTransferListContent = (item: any) => {
        const customLabel = (
            <div className="contentContiner">
                <div className="titleContiner">{item.title}</div>
                {
                    this.getRightRendView(item)
                }
            </div>
        );
        return {
            label: customLabel,
            value: item.title
        }
    }

    filterOption = (inputValue: string, option: any) => option.title.indexOf(inputValue) > -1

    handleChange = (targetKeys: any, direction: any, moveKeys: any) => {

        if (this.props.rightDataNeedSort) {
            let targetKeys1 = this.state.targetKeys

            if (direction === 'right') {
                targetKeys1 = targetKeys1.concat(moveKeys)
            } else {
                targetKeys1 = targetKeys1.filter((key: any) => {
                    return moveKeys.indexOf(key) === -1;
                });
            }

            this.setState({
                targetKeys: targetKeys1
            })
        } else {
            this.setState({
                targetKeys
            })
        }
    }

    onSelectChange = (sourceSelectedKeys: any[], targetSelectedKeys: any) => {
        this.setState({
            selectedKeys: sourceSelectedKeys.concat(targetSelectedKeys)
        })
    }

    onOk() {
        if (this.props.onOk) {
            const leftDataSource: any[] = [];
            const rightDataSource: any[] = [];
            const selectedDataSource: any[] = [];

            this.state.dataSource.map((item: any, index: any) => {
                if (this.state.targetKeys.indexOf(item.key) === -1) {
                    leftDataSource.push(item)
                }
            })

            this.state.targetKeys.map((items: string, index: any) => {
                this.state.dataSource.map((item1: any, index1: any) => {
                    if (items === item1.key) {
                        rightDataSource.push(item1)
                    }
                })
            })

            this.state.dataSource.map((item: any, index: any) => {
                if (this.state.selectedKeys.indexOf(item.key) >= 0) {
                    selectedDataSource.push(item)
                }
            })

            this.props.onOk(leftDataSource, rightDataSource, selectedDataSource, this.state.showBorder, this.state.size)
        }
    }

    showBorderOnChange = (value: any) => {
        this.setState({
            showBorder: value
        })
    }

    sizeOnChange = (e: any) => {
        this.setState({
            size: e.target.value === "0" ? "default" : 'small'
        })
    }

    render() {
        others(IrsTableConfigure.defaultProps, this.props);

        return (
            <IrsModal
                title="表格相关设置"
                destroyOnClose={this.props.destroyOnClose}
                visible={this.props.visible}
                onOk={this.onOk}
                onCancel={this.props.onCancel}
                confirmLoading={this.props.confirmLoading}
                zIndex={this.props.zIndex}
                width={modalWidth}
                maskClosable={this.props.maskClosable}
                content={
                    <div className="tableSettings">
                        <div className="isSwitch">
                            <span className="lineSpan">是否显示表格线条：</span>
                            <Switch onChange={this.showBorderOnChange} checked={this.state.showBorder} />
                            <span className="tableSpan">选择表格大小：</span>
                            <RadioGroup onChange={this.sizeOnChange} value={this.state.size === 'default' ? "0" : "1"}>
                                <RadioButton value="0">默认</RadioButton>
                                <RadioButton value="1">小号</RadioButton>
                            </RadioGroup>
                        </div>
                        <span className="descSapn">(可移动/锁定/移除)</span>
                        <IrsTransfer
                            dataSource={this.state.dataSource}
                            targetKeys={this.state.targetKeys}
                            selectedKeys={this.state.selectedKeys}
                            titles={['表头未选', '已选']}
                            showSearch={true}
                            filterOption={this.filterOption}
                            onChange={this.handleChange}
                            render={this.renderTransferListContent}
                            onSelectChange={this.onSelectChange}
                        />
                        {/* <div>注: 表格宽度自适应内容宽度, 最小宽度100px, 最大宽度400px</div> */}
                    </div>
                }
            />
        )
    }
}

export default IrsTableConfigure;
