/**
 * The only true tag.
 * @date 2018.12.08
 * @version 0.0.1
 * @author Reci.Lu
 */
import * as React from 'react';
import * as module from './module';
import { Tag } from 'antd';
import { others } from 'fit-transmit-transparently';

const { CheckableTag } = Tag;

class IrsTag extends React.Component<module.IPropsInterface, any> {
    static defaultProps = {
        type: 'tag',
        // visible: false,
        closable: false,
        color: ''
    }
    constructor(props: module.IPropsInterface) {
        super(props);
        this.state = {
            visible: true
        };
        this.onClose = this.onClose.bind(this)
    }

    onClose = (e: any) => {
        e.stopPropagation()
        e.preventDefault()
        if (this.props.onClose) {
            this.props.onClose(e, this.props.id, this.props.text ? this.props.text : this.props.children)
        }
    }


    getView() {
        if (this.props.type === 'tag') {
            return (
                <Tag
                    {...this.props}
                    color={this.props.color}
                    style={this.props.style}
                    closable={this.props.closable}
                    // visible={this.props.visible}
                    onClose={this.onClose}
                    className={this.props.className}
                >
                    {
                        this.props.text ? this.props.text : this.props.children
                    }
                </Tag>
            )
        } else {
            return (
                <CheckableTag {...this.props} checked={this.props.checkProps.checked} onChange={this.props.checkProps.onChange} />
            )
        }
    }

    render() {
        others(IrsTag.defaultProps, this.props);
        return (
            this.getView()
        )
    }
}

export default IrsTag;
