import { TimePickerProps } from 'antd/lib/time-picker/index';
import * as moment from 'moment';

export interface IPropsInterface extends TimePickerProps {
    /** 组件id */ 
    id?:any,
    /** 需要显示的名称 */ 
    label: string,
    /** 显示方式，垂直/水平 */
    labelType?:'vertical' | 'level',
    /** 自定义组件class名称 */ 
    className?: string;
    /** 组件size */ 
    size?: 'large' | 'default' | 'small';
    /** 显示的日期值 */ 
    value?: moment.Moment;
    /** 默认显示的日期值 */ 
    defaultValue?: moment.Moment | moment.Moment[];
    /** 面板是否打开 */ 
    open?: boolean;
    /** 展示的时间格式 */ 
    format?: string;
    /** 时间发生变化的回调 */ 
    onChange?: (time: moment.Moment, timeString: string) => void;
    /** 面板打开/关闭时的回调 */ 
    onOpenChange?: (open: boolean) => void;
    /** 禁用全部操作 */ 
    disabled?: boolean;
    /** 没有值的时候显示的内容 */ 
    placeholder?: string;
    /** 禁止选择部分小时选项 */ 
    disabledHours?: () => number[];
    /** 禁止选择部分分钟选项 */ 
    disabledMinutes?: (selectedHour: number) => number[];
    /** 禁止选择部分秒选项 */ 
    disabledSeconds?: (selectedHour: number, selectedMinute: number) => number[];
    /** 样式 */ 
    style?: React.CSSProperties;
    /** 使用 12 小时制，为 true 时 format 默认为 h:mm:ss a */ 
    use12Hours?: boolean;
    /** 小时选项间隔 */ 
    hourStep?: number;
    /** 分钟选项间隔 */ 
    minuteStep?: number;
    /** 秒选项间隔 */ 
    secondStep?: number;
    /** 是否展示清除按钮 */ 
    allowEmpty?: boolean;
    /** 设置输入框为只读（避免在移动设备上打开虚拟键盘） */ 
    inputReadOnly?: boolean;
    /** 清除按钮的提示文案 */ 
    clearText?: string;
    /** 当 defaultValue/value 不存在时，可以设置面板打开时默认选中的值 */ 
    defaultOpenValue?: moment.Moment;
    /** 自定义的选择框后缀图标 */ 
    suffixIcon?: React.ReactNode;
}

