### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.01 | V0.0.1 | Gail | 新增timepicker组件

<br><br/>
### 2.安装方式
<code>
npm install irs-timepicker
</code>

<br><br/><br><br/>
### 3. 调用方式
#### 基础组件格式
```jsx
  <div className="App">
     <IrsTimePicker />
  </div>
```
#### 基础组件格式, 需要label展示字段名
```jsx
  <div className="App">
    <IrsRow gutter={24}>
        <IrsCol span={8}>
          <IrsTimePicker label="时间默认" />
        </IrsCol>
        <IrsCol span={8}>
          <IrsTimePicker label='日期水平' labelType="level" />
        </IrsCol>
        <IrsCol span={8}>
          <IrsTimePicker label='日期垂直' labelType="vertical" />
        </IrsCol>
     </IrsRow>
  </div>
```
####  禁用，选择框的不可用状态。
```jsx
  <div className="App">
     <IrsTimePicker disabled="true" />
  </div>
```
####  受控组件（组件上有value属性），value 和 onChange 需要配合使用。
```jsx
  onChange = (time) => {
    // console.log(time)
    // 把获取到的time放入value中
  }
  <div className="App">
     <IrsTimePicker value={undefined} onChange={this.onChange} />
  </div>
```
####  三种大小的输入框，中的为默认。
```jsx
  <div className="App">
     <IrsRow gutter={24}>
        <IrsCol span={8}>
          <IrsTimePicker size="large" />
        </IrsCol>
        <IrsCol span={8}>
          <IrsTimePicker />
        </IrsCol>
        <IrsCol span={8}>
          <IrsTimePicker size="small" />
        </IrsCol>
     </IrsRow>
  </div>
```

####  TimePicker 浮层中的列会随着 format 变化，当略去 format 中的某部分时，浮层中对应的列也会消失。
```jsx
  const format = 'HH:mm';
  <div className="App">
     <IrsRow gutter={24}>
        <IrsCol span={8}>
          <IrsTimePicker format={format} />
        </IrsCol>
     </IrsRow>
  </div>
```

####  步长控制--可以使用 hourStep minuteStep secondStep 按步长展示可选的时分秒。
```jsx
  <div className="App">
     <IrsRow gutter={24}>
        <IrsCol span={8}>
          <IrsTimePicker 
            hourStep={5}
            minuteStep={10}
            secondStep={15} />
        </IrsCol>
     </IrsRow>
  </div>
```

####  在 TimePicker 选择框底部显示自定义的内容，open属性和onOpenChange属性需配合使用。
```jsx
class IrsTimePickerDemo extends React.Component {
  constructor() {
    super()
    this.state = {
        open: false
    }
    this.handleOpenChange = this.handleOpenChange.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  handleOpenChange(open) {
    this.setState({ open });
  }
  handleClose() {
    this.setState({open: false});
  };
  render() {
    return (
      <div className="App">
        <IrsRow gutter={24}>
          <IrsCol span={8}>
            <IrsTimePicker
              open={this.state.open}
              onOpenChange={this.handleOpenChange}
              addon={() => (
                <IrsButton size="small" onClick={this.handleClose}>ok</IrsButton>
              )}
            />
          </IrsCol>
        </IrsRow>
      </div>
    )
  }
}
;<IrsTimePickerDemo />
```
####  12 小时制的时间选择器，默认的 format 为 h:mm:ss a。
```jsx
  <div className="App">
      <IrsRow gutter={24} style={{margin: '0 0 10px 0'}}>
        <IrsTimePicker use12Hours={false} />
      </IrsRow>
      <IrsRow gutter={24} style={{margin: '0 0 10px 0'}}>
        <IrsTimePicker use12Hours={true} />
      </IrsRow>
      <IrsRow gutter={24} style={{margin: '0 0 10px 0'}}>
        <IrsTimePicker use12Hours={true} format="h:mm:ss A" />
      </IrsRow>
      <IrsRow gutter={24} style={{margin: '0 0 10px 0'}}>
        <IrsTimePicker use12Hours={true} format="h:mm a" />
      </IrsRow>
  </div>
```






