/**
 * The only true datePicker.
 * @date 2018.11.27
 * @version 0.0.1
 * @author Gail.Chen
 */
import * as React from 'react';
// import * as classNames from 'classnames';
import * as module from './module';
import * as moment from "moment";
// import 'moment/locale/zh-cn';
// moment.locale('zh-cn');
// import locale from 'antd/lib/date-picker/locale/zh_CN';
// import './style.less';
import { TimePicker } from 'antd';
import { others } from 'fit-transmit-transparently';


class IrsTimePicker extends React.Component<module.IPropsInterface, any> {
    static defaultProps = {
        showToday: true,
        showTime: false,
        disabled: false
    }
    constructor(props: module.IPropsInterface) {
        super(props);
        this.state = {
        };
        this.handleChange = this.handleChange.bind(this);
    }
    handleChange = (time: moment.Moment, timeString: string) => {
        if (this.props.onChange) {
            this.props.onChange(time, timeString);
        }

    }
    handleOpenChange = (open: boolean) => {
        if (this.props.onOpenChange) {
            this.props.onOpenChange(open);
        }
    }
    render() {
        others(IrsTimePicker.defaultProps, this.props);
        const {
            handleChange,
            handleOpenChange } = this;
        return (
            <div style={this.props.labelType === 'vertical' ? {
                'display': 'inline-flex',
                'flexDirection': 'column',
                'justifyContent': 'space-between'
            } : {
                    'display': 'inline-flex',
                    'alignItems': 'center'
                }}>
                {this.props.label ? <label>{this.props.label}：</label> : null}
                <TimePicker
                    {...this.props}
                    style={this.props.style}
                    onChange={handleChange}
                    disabled={this.props.disabled}
                    format={this.props.format}
                    onOpenChange={handleOpenChange}
                    allowEmpty={this.props.allowEmpty}
                    className={this.props.className}
                    defaultOpenValue={this.props.defaultOpenValue}
                    defaultValue={this.props.defaultValue}
                    placeholder={this.props.placeholder ? this.props.placeholder : '请选择时间'}
                    suffixIcon={this.props.suffixIcon}
                />
            </div>
        )
    }
}

export default IrsTimePicker;
