export declare type placement = 'top' | 'left' | 'right' | 'bottom' | 'topLeft' | 'topRight' | 'bottomLeft' | 'bottomRight' | 'leftTop' | 'leftBottom' | 'rightTop' | 'rightBottom';

export declare type trigger = 'hover' | 'focus' | 'click' | 'contextMenu';

export interface IPropsInterface {

    /** 文字提示内容 */
    title: string

    /** 箭头是否指向目标元素中心,默认true */
    arrowPointAtCenter?: boolean

    /** 气泡被遮挡时自动调整位置,默认true */
    autoAdjustOverflow?: boolean

    /** 默认是否显隐,默认false */
    defaultVisible?: boolean

    /** 鼠标移入后延时多少才显示 Tooltip，单位:秒,默认0 */
    mouseEnterDelay?: number

    /** 鼠标移出后延时多少才隐藏 Tooltip，单位:秒,默认0.1 */
    mouseLeaveDelay?: number

    /** 气泡框位置,可选,默认top */
    placement?: placement

    /** 触发行为,可选,默认hover */
    trigger?: trigger

    /** 自定义类名 */
    overlayClassName?: string

    /** 自定义卡片样式 */
    overlayStyle?: {}

}
