### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.20 | V0.0.1 | Kang | 新增Upload组件

<br><br/>
### 2.安装方式
<code>
npm install irs-tooltip
</code>

<br><br/><br><br/>
### 3. 调用方式

#### 样式1
```jsx
class IrsUploadDemo extends React.Component {
    constructor() {
        super()
        this.state = {
            previewVisible: false,
            previewImage: '',
            fileList: [{
                uid: '-1',
                name: 'xxx.png',
                status: 'done',
                url: 'https://zos.alipayobjects.com/rmsportal/jkjgkEfvpUPVyRjUImniVslZfWPnJuuZ.png',
            }],
        }
        this.handleCancel = this.handleCancel.bind(this)
        this.handlePreview = this.handlePreview.bind(this)
        this.handleChange = this.handleChange.bind(this)
    }

    handleCancel() {
        this.setState({ previewVisible: false })
    }

    handlePreview(file){
            this.setState({
            previewImage: file.url || file.thumbUrl,
            previewVisible: true,
        });
    }

    handleChange (fileList) {
        this.setState({ fileList })
    }

    render() {
        const { previewVisible, previewImage, fileList } = this.state;

        return (
            <div>
                <IrsUpload 
                    appearanceStyle = "PicLoad"
                />
            </div>
            
        )
    }
}
;<IrsUploadDemo />
```


#### 样式2
```jsx
class IrsUploadDemo extends React.Component {
    constructor() {
        super()
        this.state = {
            previewVisible: false,
            previewImage: '',
            fileList: [
            ],
        }
        this.onChange = this.onChange.bind(this)
    }

    onChange (info) {
        const status = info.file.status;
        console.log(status)
        if (status === 'uploading') {
            this.setState({
                fileList: info.fileList
            })
        }

        if (status === 'error') {

            info.fileList.map((item) => {
                // item.error.statusText = ''
                delete item.response;
            })

            this.setState({
                fileList: info.fileList
            })
        } else  if (status === 'done') {
            this.setState({
                fileList: info.fileList
            })
        } else if (status === 'removed') {
            this.setState({
                fileList: info.fileList
            })
        }
    }

    render() {

        return (
            <IrsUpload 
                multiple = {true}
                fileList = {this.state.fileList}
                onChange = {this.onChange}
                appearanceStyle='FileLoad'>
            </IrsUpload>            
        )
    }
}
;<IrsUploadDemo />
```

#### 样式3
```jsx
class IrsUploadDemo extends React.Component {
    constructor() {
        super()
        this.state = {
            fileList: [
            ],
        }
    this.onChange = this.onChange.bind(this)
    }

    onChange (info) {
        const status = info.file.status;
        if (status === 'uploading') {
            this.setState({
                fileList: info.fileList
            })
        }

        if (status === 'error') {

            info.fileList.map((item) => {
                delete item.response;
                delete item.error;
            })

            this.setState({
                fileList: info.fileList
            })
        } else if (status === 'done') {
            this.setState({
                fileList: info.fileList
            })
        } else if (status === 'removed') {
            this.setState({
                fileList: info.fileList
            })
        }
    }

    render() {

        return (
            <IrsUpload 
                multiple = {true}
                fileList = {this.state.fileList}
                onChange = {this.onChange}
                appearanceStyle='UploadButton'/>    
        )
    }
}
;<IrsUploadDemo />
```