/**
 * The only true tab.
 * @date 2018.12.01
 * @version 0.0.1
 * @author Kang
 */
import * as React from 'react';
import * as module from './module';
import './style.less';
import { others } from 'fit-transmit-transparently';
import {
    Upload, Icon
} from 'antd';
import Dragger from 'antd/lib/upload/Dragger';
import IrsButton from '../../irs-button'

class IrsUpload extends React.Component<module.IPropsInterface, any> {

    static defaultProps = {
        listType: 'text',
        directory: false,
        disabled: false,
        multiple: false,
        name: 'file',
        showUploadList: true,
        supportServerRender: false,
        withCredentials: false,
        openFileDialogOnClick: true,
        appearanceStyle: 'Upload',
        title: '点击或将文件拖拽到这里上传',
        subTitle: '支持扩展名: .rar .zip .doc. .docx .pdf .jpg...',
        maxCount: 1,

    }
    constructor(props: module.IPropsInterface) {
        super(props);
        this.state = {
            previewVisible: false,
            previewImage: '',
        }
    }

    beforeUpload = (file: any, fileList: any) => {
        if (this.props.beforeUpload) {
            return this.props.beforeUpload(file, fileList)
        }
        return true;
    }

    render() {
        others(IrsUpload.defaultProps, this.props);

        const fileList = this.props.fileList ? this.props.fileList : []
        const uploadButton = (
            <div>
                <Icon type="plus" />
                <div className="ant-upload-text">上传</div>
            </div>
        );

        return (

            this.props.appearanceStyle === 'Upload' ? <Upload {...this.props}>{this.props.children}</Upload> :
                this.props.appearanceStyle === 'Dragger' ? <Dragger {...this.props}>{this.props.children}</Dragger> :
                    this.props.appearanceStyle === 'PicLoad' ? <Upload {...this.props} listType="picture-card">
                        {
                            fileList.length >= this.props.maxCount ? null : uploadButton
                        }
                    </Upload> :
                        this.props.appearanceStyle === 'FileLoad' ? <Dragger {...this.props} beforeUpload={this.beforeUpload}>
                            <p className="irs-upload-drag-icon">
                                <Icon type="inbox" />
                            </p>
                            <p className="ant-upload-text">{this.props.title}</p>
                            <p className="ant-upload-hint">{this.props.subTitle}</p>
                        </Dragger> :
                            <Upload {...this.props}>
                                <IrsButton>
                                    <Icon type="upload" /> 上传
                                    </IrsButton>
                            </Upload>
        )
    }
}

export default IrsUpload;
