export declare type Breakpoint = 'xxl' | 'xl' | 'lg' | 'md' | 'sm' | 'xs';
export declare type BreakpointMap = Partial<Record<Breakpoint, string>>;
export interface IPropsInterface {
    
    /** 类名 */
    className?: string,

    /** 样式 */
    style?: any,
    
    /** flex 布局下的垂直对齐方式：top middle bottom */
    align?: 'top' | 'middle' | 'bottom';

    /** 栅格间隔，可以写成像素值或支持响应式的对象写法 { xs: 8, sm: 16, md: 24} */
    gutter?: number | Partial<Record<Breakpoint, number>>;

    /** flex 布局下的水平排列方式：start end center space-around space-between */
    justify?: 'start' | 'end' | 'center' | 'space-around' | 'space-between';

    /** 布局模式，可选 flex */
    type?: 'flex';
}

