### 1.变更记录

变更时间 | 变更版本 | 变更人 | 变更内容
:-: | :-: | :-: | :-: |
2018.12.1 | V0.0.1 | Danae | 新增Row组件

<br><br/>
### 2.安装方式
<code>
npm install irs-row
</code>

<br><br/><br><br/>
### 3. 调用方式

#### Flex布局
```jsx
const styles = {
    padding: '5px',
    marginBottom: '10px',
    color: '#fff', 
    textAlign: 'center', 
    background: 'linear-gradient(to right,  #19AA8D, #50caa4)'
};
<div className="App">
    <IrsRow type="flex" justify="start">
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
    </IrsRow>
    <IrsRow type="flex" justify="center">
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
    </IrsRow>
    <IrsRow type="flex" justify="end">
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
    </IrsRow>
    <IrsRow type="flex" justify="space-between">
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
    </IrsRow>
    <IrsRow type="flex" justify="space-around">
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
    </IrsRow>
</div>

```
#### Flex对齐
```jsx
const styles = {
    padding: '5px',
    marginBottom: '10px',
    color: '#fff', 
    textAlign: 'center', 
    background: 'linear-gradient(to right,  #19AA8D, #50caa4)'
};
const heightBox = {
    height: '50px',
    padding: '5px',
    marginBottom: '10px',
    lineHeight: '40px',
    color: '#fff', 
    textAlign: 'center', 
    background: 'linear-gradient(to right,  #19AA8D, #50caa4)'
};
<div className="App">
    <IrsRow type="flex" justify="center" align="top">
        <IrsCol style={heightBox} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={heightBox} span={6}>Col-6</IrsCol>
    </IrsRow>
    <IrsRow type="flex" justify="space-around" align="middle">
        <IrsCol style={heightBox} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={heightBox} span={6}>Col-6</IrsCol>
    </IrsRow>
    <IrsRow type="flex" justify="space-between" align="bottom">
        <IrsCol style={heightBox} span={6}>Col-6</IrsCol>
        <IrsCol style={styles} span={6}>Col-6</IrsCol>
        <IrsCol style={heightBox} span={6}>Col-6</IrsCol>
    </IrsRow>
</div>
```


